/* Copyright Statement:
 *
 * (C) 2017  Airoha Technology Corp. All rights reserved.
 *
 * This software/firmware and related documentation ("Airoha Software") are
 * protected under relevant copyright laws. The information contained herein
 * is confidential and proprietary to Airoha Technology Corp. ("Airoha") and/or its licensors.
 * Without the prior written permission of Airoha and/or its licensors,
 * any reproduction, modification, use or disclosure of Airoha Software,
 * and information contained herein, in whole or in part, shall be strictly prohibited.
 * You may only use, reproduce, modify, or distribute (as applicable) Airoha Software
 * if you have agreed to and been bound by the applicable license agreement with
 * Airoha ("License Agreement") and been granted explicit permission to do so within
 * the License Agreement ("Permitted User").  If you are not a Permitted User,
 * please cease any access or use of Airoha Software immediately.
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT AIROHA SOFTWARE RECEIVED FROM AIROHA AND/OR ITS REPRESENTATIVES
 * ARE PROVIDED TO RECEIVER ON AN "AS-IS" BASIS ONLY. AIROHA EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.
 * NEITHER DOES AIROHA PROVIDE ANY WARRANTY WHATSOEVER WITH RESPECT TO THE
 * SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY, INCORPORATED IN, OR
 * SUPPLIED WITH AIROHA SOFTWARE, AND RECEIVER AGREES TO LOOK ONLY TO SUCH
 * THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO. RECEIVER EXPRESSLY ACKNOWLEDGES
 * THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES
 * CONTAINED IN AIROHA SOFTWARE. AIROHA SHALL ALSO NOT BE RESPONSIBLE FOR ANY AIROHA
 * SOFTWARE RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND AIROHA'S ENTIRE AND
 * CUMULATIVE LIABILITY WITH RESPECT TO AIROHA SOFTWARE RELEASED HEREUNDER WILL BE,
 * AT AIROHA'S OPTION, TO REVISE OR REPLACE AIROHA SOFTWARE AT ISSUE,
 * OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE CHARGE PAID BY RECEIVER TO
 * AIROHA FOR SUCH AIROHA SOFTWARE AT ISSUE.
 */

#include "types.h"
#include "log.h"



/* example */
LOG_STRING_SYS1 char exampleLogString[]  = "Jump To Flash Code";
LOG_STRING_SYS2 char testLogString[]  = "Log Binary Verify";
LOG_STRING char exampleLogString1[] = "This is Example Log String1";
LOG_STRING char testString[2][MAX_LOG_STRING] ={
	"THIS IS TEST STRING1",
	"THIS IS TEST STRING2"
};

/* System */
LOG_STRING char SystemPowerOff[]  = "System Power Off";
LOG_STRING char SystemPowerOffFail[]  = "System Power Off Fail";
LOG_STRING char SystemLowPowerMode[]  = "System Low Power Mode";
LOG_STRING char SystemNormalPowerMode[]  = "System Normal Power Mode";
LOG_STRING char tickInfo[]   = "System tick[%d] Sleep[%dms] frozen[%dus] freeRTOS tick[%d] realTick[%u]";
LOG_STRING char isrInfo[]   = "Level2 ISR[%dus] Level3 ISR[%dus] Level4 ISR[%dus] ";
LOG_STRING char isrStackSize[] = "Minimun ISR Stack Size[%d]";
LOG_STRING char taskInfo0[]  = "Task[%s] RunTime[%dus] MinStack[%d] State[%s] Task[%s] RunTime[%dus] MinStack[%d] State[%s]";
LOG_STRING char taskInfo1[]  = "Task[%s] RunTime[%dus] MinStack[%d] State[%s]";
LOG_STRING char taskBackTrace[]  = "Task[%s] Backtrace Start";
LOG_STRING char memoryInfo[] = "%s Current Block[%d] Minimun Block[%d] %s Current Block[%d] Minimun Block[%d]";
LOG_STRING char heapInfo[]   = "Current heap Size[%d]  Minimun heap Size[%d] Log Loss[%d]";
LOG_STRING char wakeUpInfo[] = "Wake Up From Sleep, Expect Sleep Time[%dms], Actually Sleep Time[%dms]";
LOG_STRING char heapBlockInfo[] = "Used Heap Addr = 0x%x, Size = 0x%x, Heap Caller = 0x%x OSMEM caller = 0x%x";
LOG_STRING char heapFragInfo[] = "Free Heap Addr = 0x%x, Size = 0x%x";
LOG_STRING char heapCrash[] = "heap crash!!!!!";
LOG_STRING char systemDead[] = "System Dead Here";
LOG_STRING char airapptest[] = "Kernel/Double Exception";



LOG_STRING char taskNameString2[][MAX_LOG_STRING] =
{
    "KERNEL",
    "DM2L",
    "DSP",
    "DPR",
    "DAV",
    "DHP",
    "LC",
    "LC PROCESS",
};

LOG_STRING char taskNameString[][MAX_LOG_STRING] =
{
    "KERNEL",
    "DM2L",
    "DSP",
    "DPR",
    "DAV",
    "DHP",
    "LC",
    "LC PROCESS",
    "GSound",
    "GPorting",
    "TIMER",
    "IDLE TASK"
};

LOG_STRING char taskState[][MAX_LOG_STRING] =
{
    "eRunning",
    "eReady",
    "eBlocked",
    "eSuspended",
    "eDeleted"
};

LOG_STRING char memoryInfoString[][MAX_LOG_STRING] =
{
    "OSMEM0",
    "OSMEM1",
    "OSMEM2_small_TX",
    "OSMEM2_tiny_RX",
    "OSMEM2_small_RX",
    "OSMEM2_large_RX",
};

/* DSP */
LOG_STRING char DSP_WarningString[][MAX_LOG_STRING] =
{
    "DSP - Warning:Invalid type %d",                                            /*DSP_WARNING_RESERVED*/
    "DSP - Warning:Sink Buffer Empty. Type:%d",                                 /*DSP_WARNING_SINK_EMPTY*/
    "DSP - Warning:Disable Streaming. Source:%d, Sink:%d",                      /*DSP_WARNING_STREAMING_DISABLE*/
    "DSP - Warning:Memory Flush. Task:%x, Count:%d.",                           /*DSP_WARNING_MEMORY_FLUSH*/
    "DSP - Warning:Feature Ptr Null. Source:%d, Sink:%d",                       /*DSP_WARNING_FEATURE_NULL*/
    "DSP - Warning:SCO Wait For DM2L setup, Direction:%d",                      /*DSP_WARNING_SCO_WAIT_DM2L*/
    "DSP - Warning:SBC In Frame Mismatch.In:%d, Parser:%d, skip:%d",            /*DSP_WARNING_SBC_FRAME_MISMATCH*/
    "DSP - Warning:SBC In Frame Error",                                         /*DSP_WARNING_SBC_FRAME_ERROR*/
    "DSP - Warning:Modify callback in_size SourceRead:%d, MallocSize:%d",       /*DSP_WARNING_CALLBACK_READSIZE_MODIFICATION*/
    "DSP - Warning:Feature Frame Size Mismatch: Feature:%d, Size:%d",           /*DSP_WARNING_FEATURE_FRAME_MISMATCH*/
    "DSP - Warning:Drift Compensation Maximum. Source:%d, Sink:%d, Value:%d",   /*DSP_WARNING_DRIFT_COMPENSATION_MAXIMUM*/
    "DSP - Warning:Wait SRC Done",                                              /*DSP_WARNING_WAIT_SRC_DONE*/
    "DSP - Warning:Try to disable SRC Clock",                                   /*DSP_WARNING_TRY_TO_DISABLE_CLOCK*/
    "DSP - Warning:Sink zero padding wait too long",                            /*DSP_WARNING_ZEROPADDING_DPC_TIMEOUT*/
    "DSP - Warning:Update feature fail %d",                                     /*DSP_WARNING_UPDATE_FEATURE_FAIL*/
    "DSP - Warning:Source Empty. Type:%d",                                      /*DSP_WARNING_SOURCE_EMPTY*/
    "DSP - Warning:Callback Resolution Mmismatch. codec out:%d, feature:%d",    /*DSP_WARNING_CALLBACK_RESOLUTION_MISMATCH*/
    "DSP - Warning:AMA Data Source Full",                                       /*DSP_WARNING_AMA_SOURCE_FULL*/
};

LOG_STRING char DSP_INFO_CreateCallbackStream[]         = "DSP - Create Callback Stream, Source:%d, Sink:%d, Codec:%x";
LOG_STRING char DSP_INFO_CloseCallbackStream[]          = "DSP - Close Callback Stream, Source:%d, Sink:%d";
LOG_STRING char DSP_INFO_AnalogInputGainString[]  	    = "DSP - Analog Input Afe Component: %d, Gain: %d";
LOG_STRING char DSP_INFO_AnalogOutputGainString[]       = "DSP - Analog Output Gain: %d";
LOG_STRING char DSP_INFO_DigitalInputGainString[]       = "DSP - Digital Input Gain: %d";
LOG_STRING char DSP_INFO_DigitalOutputGainString[]      = "DSP - Digital Output Audio Component: %d, Gain: %d";
LOG_STRING char DSP_INFO_SourceConfiguration[]          = "DSP - Source Configure type:%d, Value:%d";
LOG_STRING char DSP_INFO_SinkConfiguration[]            = "DSP - Sink Configure type:%d, Value:%d";
LOG_STRING char DSP_INFO_EnableSrc[]                    = "DSP - Enable Src.Src:%x InRate;%d, OutRate:%d, Res:%d";
LOG_STRING char DSP_INFO_DisableSrcClk[]                = "DSP - Disable Src Clock";
LOG_STRING char DSP_INFO_EnableAudioClock[]             = "DSP - Enable Audio Clock";
LOG_STRING char DSP_INFO_DisableAudioClock[]            = "DSP - Disable Audio Clock";
LOG_STRING char DSP_INFO_Audio3wireSetting[]            = "DSP - Audio 3-wire Setting. Voltage:%d";
LOG_STRING char DSP_INFO_EnableMceAudio[]               = "DSP - Enable Mce Audio Module";
LOG_STRING char DSP_INFO_DisableMceAudio[]              = "DSP - Disable Mce Audio Module";
LOG_STRING char DSP_INFO_ModifyAudioChannelSel[]        = "DSP - Audio Channel Select :%d";
LOG_STRING char DSP_INFO_UpdateFeatureCommand[]         = "DSP - Update Feature Command :%d";
LOG_STRING char DSP_INFO_UpdateFeatureMips[]            = "DSP - Feature Mips - Current:%d, Updated feature:%d";
LOG_STRING char DSP_INFO_MceSyncParaPush[]              = "DSP - Mce Sync Para Push. Mode:%d";
LOG_STRING char DSP_INFO_MceSyncParaPop[]               = "DSP - Mce Sync Para Pop. Status:%d, Mode:%d Para:%d";
LOG_STRING char DSP_INFO_StreamDeinit[]                 = "DSP - Deinit Callback Stream, Source:%d, Sink:%d";
LOG_STRING char DSP_INFO_ScoPacketCheck[]               = "DSP - Sco Packet Status LossCnt:%d, SchedCnt:%d, CrcErrCnt:%d";
LOG_STRING char DSP_INFO_MicBiasCtrl[]                  = "DSP - Mic Bias Setting :0x%x";
LOG_STRING char DSP_INFO_AdioOutputDelayTime[]          = "DSP - Audio Output Status:%d, DelayTime:%d";
LOG_STRING char DSP_INFO_AudioMutePenalties[]           = "DSP - Mute Penalty Mutliplier:%d";
LOG_STRING char DSP_INFO_AudioMutePenaltyClear[]        = "DSP - Mute Penalty Clear!";
LOG_STRING char DSP_INFO_AudioInputDevice[]             = "DSP - Audio Input Device :0x%x, GPIO pin(group):%d";
LOG_STRING char DSP_INFO_AudioOutputDevice[]            = "DSP - Audio Output Device :0x%x, GPIO pin(group):%d";
LOG_STRING char DSP_INFO_AudioI2SMclkConfigure[]        = "DSP - Audio I2S master case:%d, MClk:%dMHz, rate:%dkHz";
LOG_STRING char DSP_INFO_DebugString[]                  = "DSP - Warning!! Debug: %d, %d, %d";


LOG_STRING char DSP_MemoryCorruptionLogString[]         = "DSP - Memory Corruption";
LOG_STRING char DSP_MemoryCorruptionHeaderLogString[]   = "DSP - Memory Corruption Header. Task:%d, MemSeq:%d";
LOG_STRING char DSP_MemoryCorruptionEOBLogString[]      = "DSP - Memory Corruption EOB. User:%x, Task:%d, Size:%d";
LOG_STRING char DSP_MemoryCorruptionFeatureLogString[]  = "DSP - Memory Corruption Feature. Source:%d, Sink:%d, Seq:%d, Timing:%d";


/* DM2L */
LOG_STRING char DM2L_TxLmpLogString[]       = "DM2L - Tx LMP OpCode = %x, Extended OpCode = %x, TID = %x, ConHdl = %x";
LOG_STRING char DM2L_RxLmpLogString[]       = "DM2L - Rx LMP OpCode = %x, Extended OpCode = %x, TID = %x, ConHdl = %x";
LOG_STRING char DM2L_TxLlcpLogString[]      = "DM2L - Tx LLCP OpCode = %x, ConHdl = %x";
LOG_STRING char DM2L_RxLlcpLogString[]      = "DM2L - Rx LLCP OpCode = %x, ConHdl = %x";
LOG_STRING char DM2L_RxHciCmdLogString[]    = "DM2L - Rx HCI Command, OGF = %x, OCF = %x";
LOG_STRING char DM2L_TxHciEvtLogString[]    = "DM2L - Tx HCI Event OpCode = %x";
LOG_STRING char DM2L_RedundantStopEncLogString[]    = "DM2L - warning: redundant stop encryption";

/* Stream A2dp */

LOG_STRING char StreamA2dp_RemainPacketLogString[]   			= "[StreamA2dp] Remain Packet:%d";
LOG_STRING char StreamA2dp_StreamSendMsgToAppLogString[]    	= "[StreamA2dp] Stream layer send msg to App";
LOG_STRING char StreamA2dp_AudioOutOfSyncNotiLogString[]   		= "[StreamA2dp] Audio out of sync notification!";
LOG_STRING char StreamA2dp_AudioAdjustClockLogString[]   		= "[StreamA2dp] Audio out of sync adjust clock";
LOG_STRING char StreamA2dp_ModifyAbnormatWaitLogString[]   		= "[StreamA2dp] Modify abnormal wait state!!";
LOG_STRING char StreamA2dp_CloseRx2PktBDALogString[]   			= "[StreamA2dp] Close rx2 pkt, BDA: %x %x %x";
LOG_STRING char StreamA2dp_OpenRx2pktBDALogString[]   			= "[StreamA2dp] Open rx2 pkt, BDA: %x %x %x";
LOG_STRING char StreamA2dp_CloseRx1PktBDALogString[]   			= "[StreamA2dp] Close rx1 pkt, BDA: %x %x %x";
LOG_STRING char StreamA2dp_OpenRx1pktBDALogString[]   			= "[StreamA2dp] Open rx1 pkt, BDA: %x %x %x";
LOG_STRING char StreamA2dp_CustomizedLatencyLogString[]   		= "[StreamA2dp] Customized Latency:%d, Frame:%d";
LOG_STRING char StreamA2dp_GetFrameSize0LogString[]   			= "[StreamA2dp] Get Frame Size 0 !!";
LOG_STRING char StreamA2dp_WrongSyncWordLogString[]   			= "[StreamA2dp] Wrong sync word";
LOG_STRING char StreamA2dp_GetFrameSize0LogString1[]   			= "[StreamA2dp] Get Frame Size 0 Again !!";
LOG_STRING char StreamA2dp_WaitFrame2LogString[]   				= "[StreamA2dp] Wait Frame 2";
LOG_STRING char StreamA2dp_WaitFrame1LogString[]   				= "[StreamA2dp] Wait Frame 1";
LOG_STRING char StreamA2dp_PktDropCurrLogString[]   			= "[StreamA2dp] Pkt Drop - curr:%d, target:%d";
LOG_STRING char StreamA2dp_FirtPktNoLogString1[]   				= "[StreamA2dp] First Packet Seq No:%d";
LOG_STRING char StreamA2dp_WaitFrameDueToOutOfSyncLogString[]   = "[StreamA2dp] Wait Frame Due To Out of Sync";
LOG_STRING char StreamA2dp_WaitDebugLogString[]   				= "[StreamA2dp] Wait Debug";
LOG_STRING char StreamA2dp_MuteDebugLogString[]   				= "[StreamA2dp] Mute Debug - PktCnt:%d, FrmCnt:%d";
LOG_STRING char StreamA2dp_AudioInfo2CrcErrLogString1[]   		= "[StreamA2dp] Audio Info2 CrcErr:%d NoSuitBufCnt:%d BufFullNakCnt:%d";
LOG_STRING char StreamA2dp_AudioInfo1LogString[]   				= "[StreamA2dp] Audio Info ListNum:%d FrameNum:%d CurrSeq:%d sniffLoss:%d DspLoss:%d";
LOG_STRING char StreamA2dp_AudioInfoCrcErrLogString1[]   		= "[StreamA2dp] Audio Info CrcErr:%d NoSuitBufCnt:%d BufFullNakCnt:%d";
LOG_STRING char StreamA2dp_RoleChangeLogString1[]   			= "[StreamA2dp] Role Changed!! Prev:%d, Curr:%d";

/* Stream AMA */

LOG_STRING char StreamAma_FrameSizeZeroLogString[]   		= "[StreamAma] Get frame Size 0!!";
LOG_STRING char StreamAma_FrameNumLogString[]   			= "[StreamAma] Calculate Frame Num: %d, buf size: %d, frame size: %d";

/* AMA */
LOG_STRING char AMA_GetLinkIdxString[]                     = "[AMA] Ama_GetLinkIdx: NULL bdAddr";
LOG_STRING char AMA_UpdateUpgradeTransportDataString[]     = "[AMA] AMA_UpdateUpgradeTransportData: NULL!";
LOG_STRING char AMA_GetEmptyLinkInfoString[]               = "[AMA] Ama_GetEmptyLinkInfo: NOT AVALIBLE LINK IDX! %x";
LOG_STRING char AMA_ClearLinkInfoString[]                  = "[AMA] Ama_ClearLinkInfo bdAddr:0x%x%x";
LOG_STRING char AMA_RhoLinkManagerGetDataLengthString[]    = "[AMA RHO] LinkManager: Get data length:%d";
LOG_STRING char AMA_RhoLinkManagerGetDataNoAmaLinkString[] = "[AMA RHO] LinkManager: Get data fail: No AMA link";
LOG_STRING char AMA_RhoLinkManagerGetDataOkString[]        = "[AMA RHO] LinkManager: Get data OK: isBle:%d";
LOG_STRING char AMA_RhoLinkManagerApplyAgentFailString[]   = "[AMA RHO] LinkManager: Apply Agent fail. pLinkInfo:0x%x, pData:0x%x, length:%d";
LOG_STRING char AMA_RhoLinkManagerApplyAgentOkString[]     = "[AMA RHO] LinkManager: Apply Agent OK";
LOG_STRING char AMA_RhoLinkManagerApplyPartnerOkString[]   = "[AMA RHO] LinkManager: Apply Partner OK";
LOG_STRING char AMA_NvkeyGetVarDataString[]                = "[AMA] === GET NVKEY AMA VAR ===";
LOG_STRING char AMA_NvkeyUpdateVarDataString[]             = "[AMA] === UPDATED NVKEY AMA VAR ===";
LOG_STRING char AMA_NvkeyVarDataOobString[]                = "[AMA] OOBE:%x";
LOG_STRING char AMA_NvkeyVarDataBdAddrString[]             = "[AMA] bdAddr:0x%x%x misc:%x keyId:0x%04x";

/* AMA BLE */
LOG_STRING char AMA_BleEnableAdvBdAString[]         = "[AMA BLE] EnableAdv bdAddr:0x%x%x";
LOG_STRING char AMA_BleAccessRxDescString[]         = "[AMA BLE] AccessRxDesc CCCD:%x bdAddr:0x%x%x";
LOG_STRING char AMA_BleDeviceStateString[]          = "[AMA BLE] deviceState %x";
LOG_STRING char AMA_BleKeyIdString[]                = "[AMA BLE] keyId: 0x%04x";
LOG_STRING char AMA_BleSetAdvEnableCfmString[]      = "[AMA BLE] ama_BleSetAdvEnableCfmHandler state:%x advState:%x status:%x";
LOG_STRING char AMA_BleConnectedString[]            = "[AMA BLE] Connected bdAddr:0x%x%x";
LOG_STRING char AMA_BleDeinitString[]               = "[AMA BLE] Deinit state:%x";
LOG_STRING char AMA_BleDisableAdvString[]           = "[AMA BLE] DisableAdv state:%x advState:%x";
LOG_STRING char AMA_BleEnableAdvString[]            = "[AMA BLE] EnableAdv state:%x advState:%x";
LOG_STRING char AMA_BleDisconnString[]              = "[AMA BLE] Disconn state:%x bdAddr:0x%x%x";
LOG_STRING char AMA_BleTxStateErrorString[]         = "[AMA BLE] Tx State error:%d";
LOG_STRING char AMA_BleTxString[]                   = "[AMA BLE] Tx Invalid bdAddr:0x%x%x";
LOG_STRING char AMA_BleTxCccdString[]               = "[AMA BLE] Tx linkIdx %x cccd 0x%04x";
LOG_STRING char AMA_BleGetDataLengthString[]        = "[AMA RHO] BLE: Get data length:%d";
LOG_STRING char AMA_BleGetDataNoAmaLinkString[]     = "[AMA RHO] BLE: Get data fail: No AMA link";
LOG_STRING char AMA_BleGetDataNoGapLinkString[]     = "[AMA RHO] BLE: Get data fail: No GAP link";
LOG_STRING char AMA_BleGetDataOkString[]            = "[AMA RHO] BLE: Get data OK";
LOG_STRING char AMA_BleApplyAgentNoGapLinkString[]  = "[AMA RHO] BLE: Apply Agent fail: No GAP link (idx:%d)";
LOG_STRING char AMA_BleApplyAgentOkString[]         = "[AMA RHO] BLE: Apply Agent OK";
LOG_STRING char AMA_BleApplyPartnerOkString[]       = "[AMA RHO] BLE: Apply Partner OK";

/* AMA SPP */
LOG_STRING char AMA_SppNullSinkString[]                 = "[AMA SPP] NULL sink";
LOG_STRING char AMA_SppStateSinkString[]                = "[AMA SPP] state:%x";
LOG_STRING char AMA_SppNullLinkInfoString[]             = "[AMA SPP] NULL pLinkInfo";
LOG_STRING char AMA_SppInvalidClaimString[]             = "[AMA SPP] SINK_INVALID_CLAIM length:%d";
LOG_STRING char AMA_SppStatusString[]                   = "[AMA SPP] status:%x";
LOG_STRING char AMA_SppConnIndHandlerString[]           = "[AMA SPP] RfcommConnectIndHandler";
LOG_STRING char AMA_SppGetDataLengthString[]            = "[AMA RHO] SPP: Get data length:%d";
LOG_STRING char AMA_SppGetDataNoAmaLinkString[]         = "[AMA RHO] SPP: Get data fail: No AMA link";
LOG_STRING char AMA_SppGetDataNoSppLinkString[]         = "[AMA RHO] SPP: Get data fail: No SPP link";
LOG_STRING char AMA_SppGetDataOkString[]                = "[AMA RHO] SPP: Get data OK";
LOG_STRING char AMA_SppApplyAgentNoEmptyLinkString[]    = "[AMA RHO] SPP: Apply Agent fail: No empty link";
LOG_STRING char AMA_SppApplyAgentOkString[]             = "[AMA RHO] SPP: Apply Agent OK";
LOG_STRING char AMA_SppApplyPartnerOkString[]           = "[AMA RHO] SPP: Apply Partner OK. idx:%d";

/* AMA RHO */
LOG_STRING char AMA_RhoFillDataNoBufferString[]         = "[AMA RHO] Fill RHO data error: No buffer";
LOG_STRING char AMA_RhoFillDataFailString[]             = "[AMA RHO] Fill RHO data fail. moduleId:%d";
LOG_STRING char AMA_RhoFillDataOkString[]               = "[AMA RHO] Fill RHO data OK";
LOG_STRING char AMA_RhoAssignDataFailString[]           = "[AMA RHO] Assign RHO data fail. moduleId:%d";
LOG_STRING char AMA_RhoAssignDataOkString[]             = "[AMA RHO] Assign RHO data OK";
LOG_STRING char AMA_RhoNotAllowSdpConnectingString[]    = "[AMA RHO] Old Agent Is NOT Allow: SPP SDP connecting";
LOG_STRING char AMA_RhoIsAllowString[]                  = "[AMA RHO] Old Agent IsAllow Msg Num:%d";
LOG_STRING char AMA_RhoGetDataLengthString[]            = "[AMA RHO] Old Agent Get Data length:%d (Qlength:%d)";
LOG_STRING char AMA_RhoGetDataNoBufferString[]            = "[AMA RHO] Old Agent Get Data error: No buffer";
LOG_STRING char AMA_RhoGetDataFillFailString[]            = "[AMA RHO] Old Agent Get Data error: Fill data fail";
LOG_STRING char AMA_RhoGetDataPopQueueString[]            = "[AMA RHO] Old Agent Get Data popQ:%d/%d";
LOG_STRING char AMA_RhoGetDataRemainingQLengthString[]            = "[AMA RHO] Old Agent Get Data error: remaining Qlength:%d";
LOG_STRING char AMA_RhoApplyAgentAssignErrorString[]            = "[AMA RHO] New Agent assign data error";
LOG_STRING char AMA_RhoApplyAgentOkString[]            = "[AMA RHO] New Agent apply OK";
LOG_STRING char AMA_RhoApplyPartnerFailString[]            = "[AMA RHO] Apply partner RHO data fail. moduleId:%d";
LOG_STRING char AMA_RhoApplyPartnerOkString[]            = "[AMA RHO] New Partner apply OK";

/* AMA Core */
LOG_STRING char AMA_CorePutTxInQueueLinkInfoOkString[]      = "[AMA] ama_PutTxDataInQueue(OK) num %d";
LOG_STRING char AMA_CorePutTxInQueueLinkInfoNgString[]      = "[AMA] ama_PutTxDataInQueue(NG) num %d";
LOG_STRING char AMA_CorePutTxInQueueString[]                = "[AMA] ama_PutTxDataInQueue(%d)";
LOG_STRING char AMA_CoreRxString[]                          = "[AMA] %x => %s (%d), which_payload: %d (len: %d)";
LOG_STRING char AMA_CoreRxFailString[]                      = "[AMA] Decoding failed: %s";
LOG_STRING char AMA_CoreSendVersionExchangeFailString[]     = "[AMA] send version exchange fail!";
LOG_STRING char AMA_CoreDeviceInfoString[]                  = "[AMA] deviceInfo batLevel:%d batStatue:%d linkStatus:%d";
LOG_STRING char AMA_CoreDeviceStatusChangedString[]         = "[AMA] device status changed %d %d";
LOG_STRING char AMA_CoreBalLevelChangedString[]             = "[AMA] bat level changed %d %d";
LOG_STRING char AMA_CoreBalStatusChangedString[]            = "[AMA] bat status changed %d %d";
LOG_STRING char AMA_CoreUpdateNvkeyString[]                 = "[AMA] ama_UpdateNvkeyData bdAddr:0x%x%x  linkIdx:%x  keyId:0x%04x";
LOG_STRING char AMA_CoreUpdateString[]                      = "[AMA] update bdAddr:0x%x%x  flashIdx:%x keyId:0x%04x";
LOG_STRING char AMA_CoreSetVoiceTxTimerString[]             = "[AMA] ama_SetVoiceTxTimer frame %d";
LOG_STRING char AMA_CoreInitBufString[]                     = "[AMA] InitRecombineBuf curlen %d buf %x %x %x %x %x %x";
LOG_STRING char AMA_CoreDisconnCfmHandlerString[]           = "[AMA] ama_CoreDisconnectCfmHandler status %x state %x";
LOG_STRING char AMA_CoreDisconnIndHandlerString[]           = "[AMA] ama_CoreDisconnectIndHandler status %x state %x";
LOG_STRING char AMA_CoreUpgradeString[]                     = "[AMA] Ama_IsUpgradeTransportBdAddr";
LOG_STRING char AMA_CoreTxAvailableNgString[]               = "[AMA] ama_CoreTxAvailableHandler NG";
LOG_STRING char AMA_CoreTxAvailableOkString[]               = "[AMA] ama_CoreTxAvailableHandler OK";
LOG_STRING char AMA_CoreTxAvailableSwitchString[]           = "[AMA] ama_CoreTxSwitchHandler bdAddr:0x%x%x";
LOG_STRING char AMA_CoreRxWrongPktString[]                  = "[AMA] ama_GetTransportPayload - receive wrong packet!";
LOG_STRING char AMA_CoreSendMsgEncodeVarintFailString[]     = "[AMA] SendCtrlMessage_ex pb_encode_varint fail";
LOG_STRING char AMA_CoreSendMsgNullCbString[]               = "[AMA] SendCtrlMessage_ex callback = NULL";
LOG_STRING char AMA_CoreSendMsgNullStreamString[]           = "[AMA] SendCtrlMessage_ex stream full";
LOG_STRING char AMA_CoreSendMsgEncodeFailString[]           = "[AMA] SendCtrlMessage_ex pb_encode fail";
LOG_STRING char AMA_CoreSendMsgSizeChangedString[]          = "[AMA] SendCtrlMessage_ex2 submsg size changed";
LOG_STRING char AMA_CoreSendMsgInfoString[]                 = "[AMA] %x <= %s, which_payload: %d (len: %d)";
LOG_STRING char AMA_CoreRspDialogString[]                   = "[AMA] SendCtrlRspWithDialog cmd:%d errorCode:%x id:%d";
LOG_STRING char AMA_CoreRspProvideSpeechString[]            = "[AMA] ama_SendCtrlRspProvideSpeech errorCode:%x id:%d";
LOG_STRING char AMA_CoreDeviceCfgString[]                   = "[AMA] deviceCfg: needs_assistant_override %d needs_setup %x";
LOG_STRING char AMA_CoreHandleSpeechString[]                = "[AMA] HandleCtrlSpeech BD_Addr Error";
LOG_STRING char AMA_CoreTagIdString[]                       = "[AMA] id:%d, currId:%d, currState:%d";
LOG_STRING char AMA_CoreStopSpeecpErrCodeString[]           = "[AMA] StopSpeech errCode:%d";
LOG_STRING char AMA_CoreRspSpeechString[]                   = "[AMA] cmd:%d id:%d, currId:%d, currSpeechState:%d";
LOG_STRING char AMA_CoreFeatureValueString[]                = "[AMA] feature:0x%04x, which_value:%d value:%d";
LOG_STRING char AMA_CoreGetStateErrCodeString[]             = "[AMA] GetState Rsp errCode: %d";
LOG_STRING char AMA_CoreSetStateErrCodeString[]             = "[AMA] SetState Rsp errCode: %d";
LOG_STRING char AMA_CoreSyncStateErrCodeString[]            = "[AMA] SynchronizeState Rsp errCode: %d";
LOG_STRING char AMA_CoreIssueMediaErrCodeString[]           = "[AMA] IssueMediaControl Rsp errCode: %d";
LOG_STRING char AMA_CoreIncomingCallErrCodeString[]         = "[AMA] incomingCall Rsp errCode: %d";
LOG_STRING char AMA_CoreOverAssistantErrCodeString[]        = "[AMA] OverrideAssistant Rsp errCode: %d";
LOG_STRING char AMA_CoreGetCentralInfoErrCodeString[]       = "[AMA] GetCentralInformation Rsp errCode: %d platform %d rspWhichPaylod %d";
LOG_STRING char AMA_CoreIdString[]                          = "[AMA] id: %d";
LOG_STRING char AMA_CoreNotImpString[]                      = "[AMA] Not implement yet! %d";
LOG_STRING char AMA_CoreIssueMediaControlTagString[]        = "[AMA] AMA_IssueMediaControl - control:%d";
LOG_STRING char AMA_CoreIncomingCallString[]                = "[AMA] Ama_IncommingCall - length:%d";
LOG_STRING char AMA_CoreVoiceClaimString[]                  = "[AMA] VoiceStreamSinkClaim ActiveLinkIdx Error";
LOG_STRING char AMA_CoreVoiceClaimNumString[]               = "[AMA] VoiceStreamSinkClaim drop data!! queue size %d, heap size %d, mtu %d";
LOG_STRING char AMA_CoreVoiceClaimSizeString[]              = "[AMA] VoiceStreamSinkClaim size %d";
LOG_STRING char AMA_CoreReleaseBufString[]                  = "[AMA] ama_ReleaseRecombineBuf curLen %d";
LOG_STRING char AMA_CoreVoiceFlushFailString[]              = "[AMA] AMA_Target_VoiceStreamSinkFlush allocate fail mtu:%x status:%x";
LOG_STRING char AMA_CoreVoiceFlushOkString[]                = "[AMA] AMA_Target_VoiceStreamSinkFlush allocate ok mtu:%d time:%d ms frame:%d";
LOG_STRING char AMA_CoreSyncStateRspString[]                = "[AMA] AMA_SynchronizeStateResponse";
LOG_STRING char AMA_CoreGetMemoryFailString[]               = "[AMA] GetMemory fail(%d)";
LOG_STRING char AMA_CoreFeatureString[]                     = "[AMA] feature(%x)";
LOG_STRING char AMA_CoreErrCodeValuesString[]               = "[AMA] errCode:%d valueType:%d value:%x";
LOG_STRING char AMA_CoreValuesString[]                      = "[AMA] valueType:%d value:%x";
LOG_STRING char AMA_CoreErrBdAddrString[]                   = "[AMA] BD_Addr Error";
LOG_STRING char AMA_CoreNoConnectionString[]                = "[AMA] No connection";
LOG_STRING char AMA_CoreRxCtrlMsgString[]                   = "[AMA] %x => %s (%d), which_payload: %d (len: %d)";
LOG_STRING char AMA_CoreCeUnknowString[]                    = {"CE_UNKNOW_TAGS"};
LOG_STRING char AMA_CoreRspUnknowString[]                   = {"RSP_UNKNOW_TAGS"};
LOG_STRING char AMA_CoreCtlMsgSpeechStateString[]           = "[AMA] speech state: %s";
LOG_STRING char AMA_CoreSpeechStateUnknowString[]           = "[AMA] speech state: UNKNOW";
LOG_STRING char AMA_CoreErrCodeString[]                     = "[AMA] errCode %x";
LOG_STRING char AMA_CoreStartCurrentSpeechString[]          = "[AMA] StartSpeech - SpeechCurrState: %d";
LOG_STRING char AMA_CoreStopCurrentSpeechString[]           = "[AMA] StopSpeech - SpeechCurrState: %d";
LOG_STRING char AMA_CoreEndpointCurrentSpeechString[]       = "[AMA] EndpointSpeech - SpeechCurrState: %d";
LOG_STRING char AMA_CoreEndpointRspCurrentSpeechString[]    = "[AMA] EndpointSpeechResponse - SpeechCurrState: %d";
LOG_STRING char AMA_CoreStopRspCurrentSpeechString[]        = "[AMA] StopSpeechResponse - SpeechCurrState: %d";
LOG_STRING char AMA_CoreProvideRspCurrentSpeechString[]     = "[AMA] ProvideSpeechResponse - SpeechCurrState: %d";
LOG_STRING char AMA_CoreIssueMediaControlString[]           = "[AMA] media control: %d";
LOG_STRING char AMA_CoreReleaseTxVoicePktString[]           = "[AMA] ama_ReleaseTxVoicePkt NUM:%d";
LOG_STRING char AMA_CoreUpdateKeyIdBeforeString[]           = "[AMA] ama_UpdataKeyId before num %d key: 0x%04x 0x%04x";
LOG_STRING char AMA_CorePrintInfoString[]                   = "[AMA] bdAddr:0x%x%x misc:%x keyId:0x%04x";
LOG_STRING char AMA_CoreUpdateKeyIdAfterString[]            = "[AMA] ama_UpdataKeyId after";
LOG_STRING char AMA_CoreBeforeRankOobeString[]              = "[AMA] before rank oobe";
LOG_STRING char AMA_CoreUpdateRank1String[]                 = "[AMA] nvkey Empty link list idx %x";
LOG_STRING char AMA_CoreUpdateRank2String[]                 = "[AMA] write idx: %x partner idx: %x same: %d";
LOG_STRING char AMA_CoreCtrlMsgSizeString[]                 = "[AMA] ctrl msg size: %d";
LOG_STRING char AMA_CoreTxCtrlMsgSizeString[]               = "[AMA] tx ctrl msg size: %d";
LOG_STRING char AMA_CoreUpdateTxCtlParam1String[]           = "[AMA] UpdateTxCtlParam1 isTx:%x numSendCtlMsgNoRsp:%x";
LOG_STRING char AMA_CoreUpdateTxCtlParam2String[]           = "[AMA] UpdateTxCtlParam2 isTx:%x numSendCtlMsgNoRsp:%x";

LOG_STRING char SM_AddAuthList1String[]                      = "[SM] ADD LIST length: %d data %x %x %x %x";
LOG_STRING char SM_AddAuthList2String[]                      = "[SM] ADD bda:%x %x %x %x %x %x flag:%x";
LOG_STRING char SM_AddAuthList3String[]                      = "[SM] ADD LIST oldKeyId:0x%04x newKeyId:0x%04x";
LOG_STRING char SM_GetAuthListString[]                       = "[SM] GET_AUTH_DEVICE_LIST_EX_REQ num:%d len:%d";
LOG_STRING char SM_WriteLtk1String[]                         = "[SM] BLE W ltk %x%x%x%x%x%x%x%x";
LOG_STRING char SM_WriteLtk2String[]                         = "[SM] BLE W keyid 0x%04x";
LOG_STRING char SM_WriteLtk3String[]                         = "[SM] BLE W NEW ltk %x%x%x%x%x%x%x%x";
LOG_STRING char SM_ReadLtk1String[]                          = "[SM] BLE R ltk %x%x%x%x%x%x%x%x";
LOG_STRING char SM_ReadLtk2String[]                          = "[SM] BLE R keyid 0x%04x";


LOG_STRING char AMA_CoreMediaControlString[][MAX_LOG_STRING] =
{
    "PLAY",
    "PAUSE",
    "NEXT",
    "PREVIOUS",
    "PALA_PAUSE"
};
LOG_STRING char AMA_CoreSpeechState[][MAX_LOG_STRING] =
{
    "IDLE",
    "LISTENING",
    "PROCESSING",
    "SPEAKING",
};
LOG_STRING char AMA_CoreCeString[][MAX_LOG_STRING] =
{
    "ce_response",
    "ce_provide_speech",
    "ce_start_speech",
    "ce_stop_speech",
    "ce_endpoint_speech",
    "ce_notify_speech_state",
    "ce_get_device_information",
    "ce_get_device_configuration",
    "ce_override_assistant",
    "ce_start_setup",
    "ce_complete_setup",
    "ce_notify_device_configuration",
    "ce_update_device_information",
    "ce_notify_device_information",
    "ce_upgrade_transport",
    "ce_switch_transport",
    "ce_forward_at_command",
    "ce_incoming_call",
    "ce_synchronize_settings",
    "ce_reset_connection",
    "ce_keep_alive",
    "ce_remove_device",
    "ce_issue_media_control",
    "ce_get_state",
    "ce_set_state",
    "ce_synchronize_state",
    "ce_get_central_information",
    "ce_command",
    "ce_unknow"
};
LOG_STRING char AMA_CoreRspString[][MAX_LOG_STRING] =
{
    "rsp_device_information",
    "rsp_state",
    "rsp_connection_details",
    "rsp_device_configuration",
    "rsp_central_information",
    "rsp_dialog",
    "rsp_speech_provider",
    "rsp_error_code"
};

/* TRSPX APP*/
LOG_STRING char APP_TrspxBtTimerString[]                    = "[TRSPX APP] state:%d txUartFailCnt:%d";
LOG_STRING char APP_TrspxBtStartServiceString[]             = "[TRSPX APP] TRSPX_START_SERVICE_CFM status:%d";
LOG_STRING char APP_TrspxBtConnCfm1String[]                 = "[TRSPX APP] TRSPX_CONNECT_CFM status:%d";
LOG_STRING char APP_TrspxBtConnCfm2String[]                 = "[TRSPX APP] TRSPX_CONNECT_CFM bdAddr:0x%x%x MTU:%d";
LOG_STRING char APP_TrspxBtDisconnCfmString[]               = "[TRSPX APP] TRSPX_DISCONNECT_CFM status:%d";
LOG_STRING char APP_TrspxBtUartTxString[]                   = "[TRSPX APP] APP_UartTxData fail!!! len:%d txUartFailCnt:%d";
LOG_STRING char APP_TrspxBtRxDoneString[]                   = "[TRSPX APP] TRSPX_RxDone fail!!!";
LOG_STRING char APP_TrspxBtRegAllProfileString[]            = "[TRSPX APP] PM_REGISTER_ALL_PROFILE_CFM status:%d";
LOG_STRING char APP_TrspxUartTxString[]                     = "[TRSPX APP] APP_UartTxData  CTS is HIGH";
LOG_STRING char APP_TrspxUartClaimFailString[]              = "[TRSPX APP] UART SinkClaim FAIL len:%d";
LOG_STRING char APP_TrspxUartBtTxString[]                   = "[TRSPX APP] APP_BtTxData status:%d len:%d";
LOG_STRING char APP_TrspxUartBtTxTimeoutString[]            = "[TRSPX APP] APP_BtTxData timeout status:%d len:%d";
LOG_STRING char APP_TrspxUartTimerString[]                  = "[TRSPX APP] APP_TIMER_ID_RX_UART";

/* TRSPX */
LOG_STRING char TRSPX_BleConnectedString[]            = "[TRSPX BLE] Connected bdAddr:0x%x%x";


/*APP*/
/*Key*/
LOG_STRING char APP_KeyLogString[] = "[Key]: index: %s, action: %s, stateMask: 0x%x";
LOG_STRING char APP_EvtKeyLogString[] = "[Key]: eventCode: %s, bdAddr: 0x%x%x";
LOG_STRING char APP_EvtKeyRHOLogString[] = "[Key]: invalid in RHOing";

/*State*/
LOG_STRING char APP_AddStateLogString[] = "[State] Add State: %s, bdAddr:0x%x%x";
LOG_STRING char APP_RmvStateLogString[] = "[State] Rmv state: %s, bdAddr:0x%x%x";
LOG_STRING char APP_InsertStateLogString[] = "[State] Insert State before: %s, state: %s, bdAddr:0x%x%x";
LOG_STRING char APP_ReplaceStateLogString[] = "[State] Replace State old: %s, new: %s, bdAddr:0x%x%x";
LOG_STRING char APP_CleanNestStateLogString[] = "[State] CleanNestState bdAddr:0x%x%x";

/*MediaEvt*/
LOG_STRING char APP_PushMediaEvtLogString[] = "[Media]: PushMediaEvent %s, Qnum: %d";
LOG_STRING char APP_MediaEvtLogString[] = "[Media]: LED: %d, VP: %s, RT: %s";
LOG_STRING char APP_VPRTStartLogString[] = "[Media][%s Start]: MediaEvent: %s, %s: %s";
LOG_STRING char APP_VPRTStopLogString[] = "[Media][%s Stop]: event:0x%x, MediaEvent: %s, %s: %s";
LOG_STRING char APP_MediaEndLogString[] = "[Media] Media End: 0x%X";
LOG_STRING char APP_MediaCantFindNvKeyLogString[] = "[Media] Cant Find NVKey:%s";
LOG_STRING char APP_MediaInitSucessLogString[] = "[Media] Media Init Sucess";
LOG_STRING char APP_MediaNeedToSyncLogString[] = "[Media] Media Need to Sync, event:0x%x";
LOG_STRING char APP_MediaNotNeedToSyncLogString[] = "[Media] Media Not Need to Sync, event:%d";

LOG_STRING char APP_MediaAgentEventInHFPstring[] = "[Media] Agent media event in HFP state, event:%x";
LOG_STRING char APP_MediaPartnerEventInHFPstring[] = "[Media] Partner media event in HFP state, event:%x";
LOG_STRING char APP_MediaEventPlayUnderHFPStatetring[] = "[Media] Media Event :%d, is not to be played under HFP state";



/*Led Control*/
LOG_STRING char APP_SetLedBGPatternLogString[] = "[    APP][LED] BG: ptnIdx:%d, LedOnOff:0x%x";
LOG_STRING char APP_SetLedFGPatternLogString[] = "[    APP][LED] FG: ptnIdx:%d, LedOnOff:0x%x";
LOG_STRING char APP_SetLedFilterPatternLogString[] = "[    APP][LED] Filter: type:%d, ptnIdx:%d, LedOnOff:0x%x";
LOG_STRING char APP_CancelLedFilterLogString[] = "[    APP][LED] Cancel Filter: ptnIdx:%d";
LOG_STRING char APP_ResumeLedLogString[] = "[    APP][LED] Resume: LedOnOff:0x%x";

/*Link History*/
LOG_STRING char APP_LinkHistoryClearEntryLogString[] = "[    APP][LinkHistory]: Clear Entry";
LOG_STRING char APP_LinkHistoryClearNormalLogString[] = "[    APP][LinkHistory]: Clear Normal History: %d";
LOG_STRING char APP_LinkHistoryClearAirLogString[] = "[    APP][LinkHistory]: Clear Air History: %d";

/*Profile Manager*/
LOG_STRING char APP_PMLoadLogString[] = "[     PM][Load]: profile: %s, bdAddr: 0x%x%x";
LOG_STRING char APP_PMUnLoadLogString[] = "[     PM][UnLoad]: profile: %s, bdAddr: 0x%x%x";
LOG_STRING char APP_PMActivateLogString[] = "[     PM][Activate]: profile: %s, bdAddr: 0x%x%x";
LOG_STRING char PM_ProfileRegisteredCfmLog[] = "[     PM] ----- ALL PROFILES REGISTERED , BOOT REASON : (%d) -----";

/*APP DSP Ctrl*/
LOG_STRING char APP_DSPSCOStartLogString[] = "[    APP][DSP] SCO Start - bdaddr : 0x%x%x";
LOG_STRING char APP_DSPSCOStopLogString[] = "[    APP][DSP] SCO Stop - bdaddr : 0x%x%x, result:%d";
LOG_STRING char APP_DSPSCOTxFailLogString[] = "[    APP][DSP] Audio SCO:%d Tx Fail";
LOG_STRING char APP_DSPSCORxFailLogString[] = "[    APP][DSP] Audio SCO:%d Rx Fail";
LOG_STRING char APP_DSPSCOSuccessLogString[] = "[    APP][DSP] Audio SCO codec:%d Success";

LOG_STRING char APP_DSPStreamStartLogString[] = "[    APP][DSP] A2DP Stream Start - bdaddr : 0x%x%x";
LOG_STRING char APP_DSPStreamStopLogString[] = "[    APP][DSP] A2DP Stream Stop: - bdaddr : 0x%x%x, isByLink:%d";

LOG_STRING char APP_DSPSideToneStartLogString[] = "[DSP] SideTone Start";
LOG_STRING char APP_DSPSideToneStopLogString[] = "[DSP] SideTone Stop";

LOG_STRING char APP_DSPVPStartLogString[] = "[DSP] VP Start";
LOG_STRING char APP_DSPVPStopLogString[] = "[DSP] VP Stop";

LOG_STRING char APP_DSPRTStartLogString[] = "[DSP] RT Start";
LOG_STRING char APP_DSPRTStopLogString[] = "[DSP] RT Stop";

LOG_STRING char APP_DSPMP3StartLogString[] = "[    APP][DSP] MP3 Start";
LOG_STRING char APP_DSPMP3StartedLogString[] = "[    APP][DSP] MP3 Started";
LOG_STRING char APP_DSPMP3StartFailLogString[] = "[    APP][DSP] MP3 Start Fail";
LOG_STRING char APP_DSPMP3StartFailAlreadyRegisteredLogString[] = "[    APP][DSP] MP3 Start Fail: Already Registered";
LOG_STRING char APP_DSPMP3StopLogString[] = "[    APP][DSP] MP3 Stop";
LOG_STRING char APP_DSPMP3NotInitLogString[] = "[    APP][DSP] MP3 Not Init";
LOG_STRING char APP_DSPMP3InitFailLogString[] = "[    APP][DSP] MP3 Init Fail";
LOG_STRING char APP_DSPMP3InitSuccessfulLogString[] = "[    APP][DSP] MP3 Init Successful";
LOG_STRING char APP_DSPMP3SourceEndLogString[] = "[    APP][DSP] MP3 Source End";
LOG_STRING char APP_DSPMP3SinkEndLogString[] = "[    APP][DSP] MP3 Sink End";
LOG_STRING char APP_DSPMP3ModeControlLogString[] = "[    APP][DSP] MP3 Mode Control[%d]";
LOG_STRING char APP_DSPMP3PauseLogString[] = "[    APP][DSP] MP3 Pause";
LOG_STRING char APP_DSPMP3ResumeLogString[] = "[    APP][DSP] MP3 Resume";
LOG_STRING char APP_DSPMP3ForwardLogString[] = "[    APP][DSP] MP3 Forward";
LOG_STRING char APP_DSPMP3BackwardLogString[] = "[    APP][DSP] MP3 Backward";
LOG_STRING char APP_DSPMP3FileOpenLogString[] = "[    APP][DSP] MP3 File Open[%d] TrackNo:%d";

/*APP ChargerBattery*/
LOG_STRING char APP_ChgBatStatusLogString[] = "[    APP][ChgBat] status: %s";
LOG_STRING char APP_ChgBatLevelLogString[] = "[    APP][ChgBat] Get Level Percent: %d";
LOG_STRING char APP_ChgBatMonitorPercentLogString[] = "[    APP][ChgBat] Monitor Hundred Percent:%d, Thousand Percent:%d";
LOG_STRING char APP_ChgBatEnterDeepSleepString[] = "[    APP][ChgBat] - Enter Deep Sleep !!! - ";
LOG_STRING char APP_ChgBatInitString[] = "[    APP][ChgBat] CHG_GPIO_OUTPUT_HIGH / CHG_GPIO_INPUT_INITIAL";
LOG_STRING char APP_ChgBatOutputLowString[] = "[    APP][ChgBat] DRV_CHARGER_MSG_CHARGERCPL : input(0x%x), output(0x%x), isDoingRHO(%d) -> CHG_GPIO_OUTPUT_LOW";
LOG_STRING char APP_ChgBatInputStatusString[] = "[    APP][ChgBat] DRV_CHARGER_MSG_CHARGEROUT : CHG_GPIO_INPUT_STATUS(0x%x) : [%d]";
LOG_STRING char APP_ChgBatChgOutSetOutputHighString[] = "[    APP][ChgBat] Charger out, CHG_GPIO_OUTPUT_HIGH";
LOG_STRING char APP_ChgBatGpioYInterruptString[] = "[    APP][ChgBat] DRV_CHARGER_MSG_GPIO_Y = 1, set x = 1, reset";
LOG_STRING char APP_ChgBatChgInThenPowerOffString[] = "[    APP][ChgBat] Charger In, then power off";
LOG_STRING char APP_ChgBatChgOutPowerLogString[] = "[    APP][ChgBat] CheckNestState[FAKEOFF]:(0x%d), APP_PowerOff_IsPowerOn:(0x%d), isChgOutOn:(0x%d), DRV_BAT_IsBelowInitBat:(0x%d)";
LOG_STRING char APP_ChgBatNotDummyDelayLogString[] = "[    APP][ChgBat] not dummy delay, cpl handler !!!";
LOG_STRING char APP_ChgBatDummpyCplLogString[] = "[    APP][ChgBat] dummy delay, cpl";
LOG_STRING char APP_ChgBat_DRV_CHARGER_MSG_GPIO_YLogString[] = "[    APP][ChgBat] DRV_CHARGER_MSG_GPIO_Y ext_id:(%d) APP_ChgBat_GetPowerOffState():(%d)";
LOG_STRING char APP_ChgBat_DUMMY_DELAY_IDLogString[] = "[    APP][ChgBat]  APP_CHGBAT_CHARGER_IN_DUMMY_DELAY_ID %d";
LOG_STRING char APP_ChgBat_app_ChgBat_DrvEvtHandlerLogString[] = "[    APP][ChgBat]  app_ChgBat_DrvEvtHandler([%x])";
LOG_STRING char APP_ChgBat_DuringChgOutDummyDelayReleaseTimerLogString[] = "[    APP][ChgBat]  DuringChgOutDummyDelay Release Timer";
LOG_STRING char APP_ChgBat_DuringDummyDelayAndcaseLogString[] = "[    APP][ChgBat]  DuringDummyDelay && case gpio_xy:%d";
LOG_STRING char APP_ChgBat_DuringDummyDelay1LogString[] = "[    APP][ChgBat]  DuringDummyDelay && (id >= DRV_CHARGER_MSG_CHARGERIN) && case_none (%d)";
LOG_STRING char APP_ChgBat_DuringDummyDelay2LogString[] = "[    APP][ChgBat]  id:%x DuringDummyDelay:%d";




LOG_STRING char APP_DSPAncStartLogString[] = "[    APP][DSP] ANC Start:%d/%d";
LOG_STRING char APP_DSPAncStartFailedLogString[] = "[    APP][DSP] ANC Start Failed (Wrong Type)";
LOG_STRING char APP_DSPAncStopLogString[] = "[    APP][DSP] ANC Stop";
LOG_STRING char APP_DSPAncStopFailedLogString[] = "[    APP][DSP] ANC Stop Failed";
LOG_STRING char APP_DSPAncChangeLogString[] = "[    APP][DSP] ANC Change %d to %d";

LOG_STRING char APP_MicMuteOnLogString[] = "[    APP][VolumeSetting]Mic Mute On";
LOG_STRING char APP_MicMuteOffLogString[] = "[    APP][VolumeSetting]Mic Mute Off";

LOG_STRING char APP_CheckAiroThruCanPlayFail[] = "[    APP][DSP] AiroThru Check Can Play Fail";
LOG_STRING char APP_CheckAiroThruCanPlaySuccess[] = "[    APP][DSP] AiroThru Check Can Play Success";
LOG_STRING char APP_IsAiroThruOpened[] = "[    APP][DSP] AiroThru is Opened";
LOG_STRING char APP_IsAiroThruClosed[] = "[    APP][DSP] AiroThru is Closed";
LOG_STRING char APP_AiroThruStartSuccess[] = "[    APP][DSP] AiroThru Start Success";
LOG_STRING char APP_AiroThruStartFail[] = "[    APP][DSP] AiroThru Start Fail";
LOG_STRING char APP_AiroThruStartFail2[] = "[    APP][DSP] AiroThru Start Fail. In the Case";
LOG_STRING char APP_AiroThruStopSuccess[] = "[    APP][DSP]AiroThru Stop Success";
LOG_STRING char APP_AiroThruStopFail[] = "[    APP][DSP] AiroThru Stop Fail";

LOG_STRING char APP_DSPLineInNoSourceLogString[] = "[    APP][DSP] LineIn No Source";
LOG_STRING char APP_DSPLineInNoSinkLogString[] = "[    APP][DSP] LineIn No Sink";
LOG_STRING char APP_DSPLineInTransformFailLogString[] = "[    APP][DSP] LineIn Transform Fail";
LOG_STRING char APP_DSPLineInTransformOKLogString[] = "[    APP][DSP] LineIn Transform Success";
LOG_STRING char APP_DSPLineInStopCloseLogString[] = "[    APP][DSP] LineIn Stop";
LOG_STRING char APP_DSPLineInNoExistCloseLogString[] = "[    APP][DSP] LineIn Close";

/* Sound Level Control */
LOG_STRING char APP_RemoteSpkVolSetLogString[] = "[VolumeManager]Remote Set Speaker soundlevel:%d, component:%s";
LOG_STRING char APP_RemoteMicVolSetLogString[] = "[VolumeManager]Remote Set Mic vgm:%d, component:%s";
LOG_STRING char APP_VolumeMaxLogString[] = "[Volume]Vol reach Max";
LOG_STRING char APP_VolumeMinLogString[] = "[Volume]Vol reach Min";
LOG_STRING char APP_A2dpVolUpDownSetLogString[] = "[Volume]A2DP Volup:%d, IsFollower:%d, CurSoundlevel:%d";
LOG_STRING char APP_A2dpVolRemoteSetLogString[] = "[Volume]A2DP Remote set soundlevel:%d";
LOG_STRING char APP_Mp3VolUpDownSetLogString[] = "[Volume]MP3 Volup:%d, CurSoundlevel:%d";
LOG_STRING char APP_ScoMicVolUpDownSetLogString[] = "[Volume]ScoMic Volup:%d, CurSoundlevel:%d";
LOG_STRING char APP_ScoMicVolRemoteSetLogString[] = "[Volume]ScoMic Remote set Vgm:%d, soundlevel:%d";
LOG_STRING char APP_ScoMicVolTopStateLogString[] = "[Volume]ScoMic topState:%d";
LOG_STRING char APP_ScoVolUpDownSetLogString[] = "[Volume]Sco Volup:%d, IsFollower:%d, CurSoundlevel:%d";
LOG_STRING char APP_ScoVolRemoteSetLogString[] = "[Volume]Sco Remote set soundlevel:%d";
LOG_STRING char APP_ScoVolTopStateLogString[] = "[Volume]Sco topState:%d, rolePartner:%d";
LOG_STRING char APP_VpRtVolUpDownSetLogString[] = "[Volume]VpRt Volup:%d, CurSoundlevel:%d";
LOG_STRING char APP_SetSoundLevelToDSPLogString[] = "[Volume]Set Volume to DSP SoundLevel:%d, Percentage:%d, Component:%s";
LOG_STRING char APP_SetSoundLevelWrongLogString[] = "[Volume]wrong component:%d";
LOG_STRING char APP_AiroThruVolUpDownSetLogString[] = "[Volume]AiroThru Volup, CurSoundlevel:%d";
LOG_STRING char APP_AiroThruCycleVolumeLogString[] = "[Volume]AiroThru Cycle Volume isUp:%d";
LOG_STRING char APP_LoadVCGainTableLogString[] = "[Volume]Load VC gain table";
LOG_STRING char APP_LoadATGainTableLogString[] = "[Volume]Load AT gain table";

/* PEQ */
LOG_STRING char APP_PEQGroupLoadLogString[] = "[    APP][PEQ]Load PEQ component:%s";
LOG_STRING char APP_PEQGroupChangeLogString[] = "[    APP][PEQ]Change PEQ component:%s";
LOG_STRING char APP_PEQGroupSetLogString[] = "[    APP][PEQ]Set PEQ component:%s";
LOG_STRING char APP_NotActiveComponentLogString[] = "[    APP][PEQ]Not Set Active Component:%d";
LOG_STRING char APP_ForceUsePEQLogString[] = "[    APP][PEQ]Force to use PEQ Feature";
LOG_STRING char APP_NotForceUsePEQLogString[] = "[    APP][PEQ]Not Force to use PEQ Feature";
LOG_STRING char APP_PEQGroupAndModeLogString[] = "[    APP][PEQ]PEQ Group:%d, Mode:%d";
LOG_STRING char APP_GetPEQParaNvkeyFailLogString1[] = "[    APP][PEQ]PEQ Para Nvkey ID NOT in range";
LOG_STRING char APP_GetPEQParaNvkeyFailLogString2[] = "[    APP][PEQ]Get PEQ Para Nvkey by NvkeyID:%X fail";
LOG_STRING char APP_SendPEQToDSPLogString[] = "[    APP][PEQ]Set PEQ Para to DSP:%s, Nvkey ID:%X";
LOG_STRING char APP_RealTimePEQLogString[] = "[    APP][PEQ]Realtime Set PEQ to DSP:%s";
LOG_STRING char APP_GetParaAddrByNvkeyIDFailLogString1[] = "[    APP][PEQ]GetParaAddrByNvkeyID fail datasize:%d memory Ptr:%x";
LOG_STRING char APP_GetParaAddrByNvkeyIDFailLogString2[] = "[    APP][PEQ]GetParaAddrByNvkeyID read full key fail";

/* PEQ */
LOG_STRING char APP_RealTimePEQSyncTimeClockToStartLogString[] = "[    APP][PEQ]PEQ SYNC TIME: %d, clockToStart: %d";
LOG_STRING char APP_RealTimePEQAgentEndLogString[] = "[    APP][PEQ]Agent End";
LOG_STRING char APP_RealTimePEQPartnerEndLogString[] = "[    APP][PEQ]Partner End";
LOG_STRING char APP_RealTimePEQPlayingTimerLogString[] = "[    APP][PEQ]PEQ Playing Timer";
LOG_STRING char APP_RealTimePEQPhaseLengthLogString[] = "[    APP][PEQ]PEQ PHASE: %d, Length:%d";
LOG_STRING char APP_RealTimePEQDataLogString[] = "[    APP][PEQ]realtime: %d - Realtime data:%d %d %d %d %d %d";
LOG_STRING char APP_RealTimePEQPartnerPicoLogString[] = "[    APP][PEQ]PEQ current Pico:%d, get current Pico:%d";
LOG_STRING char APP_RealTimePEQPartnerTimeToStartString[] = "[    APP][PEQ]partner sync value:%d";

LOG_STRING char APP_RealTimePEQFillRHODataErrorLogString[] = "[APP_PeqProc] Fill RHO data error";
LOG_STRING char APP_RealTimePEQAssignRHODataErrorLogString[] = "[APP_PeqProc] Assign RHO data error";

/* Audio Nvkey */
LOG_STRING char APP_AudioDSPNvkeyInitString[] = "[    APP][DSP]NvKey audioInputPath:0x%x,voiceInputPath:0x%x, outputPath1:0x%x, outputPath2:0x%x";
LOG_STRING char APP_AudioDSPNvkeyReadOutputPathString[] = "[    APP][DSP]outputPath1[0x%x] / outputPath2[0x%x]";
LOG_STRING char APP_AudioDSPNvkeyReadAudioInputString[] = "[    APP][DSP]audioInputPath[0x%x]";
LOG_STRING char APP_AudioDSPNvkeyReadVoiceInputString[] = "[    APP][DSP]voiceInputPath[0x%x]";
LOG_STRING char APP_AudioDSPNvkeyReadAudioChannelString[] = "[    APP][DSP]audioChannel[0x%x]";
LOG_STRING char APP_AudioDSPNvkeyIsFeatureOnString[] = "[    APP][DSP]feature[0x%x]";

/* Audio Driver */
LOG_STRING char APP_AudioDrvSendVPStopCmdString[] = "[    APP][AudioDriver]VoicepromptStop:%x";
LOG_STRING char APP_AudioDrvSendRTStopCmdString[] = "[    APP][AudioDriver]RingtoneStop:%x";

/* Audio Register */
LOG_STRING char APP_AudioRegSetCurrentLinkAudioDeviceString[] = "[Audio Reg] Set Current Audio Dev[%d]:0x%x%x";
LOG_STRING char APP_AudioRegSetCurrentSystemAudioDeviceString[] = "[Audio Reg]Set Current Audio Dev[%d]:System";
LOG_STRING char APP_AudioRegPauseCurrentMusicString[] = "[Audio Reg]Pause Current Music:0x%x%x";
LOG_STRING char APP_AudioRegRecordDeviceString[] = "[Audio Reg] Audio Reg[%d]:0x%x%x";
LOG_STRING char APP_AudioRegRecordSystemString[] = "[Audio Reg] Audio Reg[%d]:System";
LOG_STRING char APP_AudioRegDeleteDeviceString[] = "[Audio Reg] Audio Dereg[%d]:0x%x%x";
LOG_STRING char APP_AudioRegDeleteSystemString[] = "[Audio Reg] Audio Dereg[%d]: System";
LOG_STRING char APP_AudioRegDeleteErrorString[] = "[Audio Reg] Audio Dereg Error!!";
LOG_STRING char APP_AudioRegResumeOtherErrorString[] = "[Audio Reg] Audio Resume Other[%d]:Error!!";
LOG_STRING char APP_AudioRegFillRhoDataErrorString[] = "[Audio Reg] Fill RHO data error";
LOG_STRING char APP_AudioRegAssignRhoDataErrorString[] = "[Audio Reg] Assign RHO data error";
LOG_STRING char APP_AudioRegCurrentAndInDevice[] = "[Audio Reg] Audio Current Dev id:%d priority:%d vs Coming Dev id:%d  priority:%d";

/* Audio Stream */
LOG_STRING char APP_AudioStreamStartSuccessfulLogString[] = "Start [%s] Successful. BdAddr: 0x%x%x";
LOG_STRING char APP_AudioStreamStartFailedLogString[] = "Start [%s] Failed. BdAddr: 0x%x%x";
LOG_STRING char APP_AudioStreamStopSuccessfulLogString[] = "Stop [%s] Successful. BdAddr: 0x%x%x";
LOG_STRING char APP_AudioStreamStopFailedLogString[] = "Stop [%s] Failed. BdAddr: 0x%x%x";
LOG_STRING char APP_AudioStreamDSPSuspendLogString[] = "FW_SUSPEND_DSP";
LOG_STRING char APP_AudioStreamRealTimeDSPSuspendLogString[] = "BT_APP_DSP_REALTIME_SUSPEND_DSP";
LOG_STRING char APP_AudioStreamRealTimeDSPResumeLogString[] = "BT_APP_DSP_REALTIME_RESUME_DSP";
LOG_STRING char APP_AudioStreamClearDspInfoLogString[] = "Clear Dsp Info";
LOG_STRING char APP_AudioStreamSetDspLogString[]= "Set Dsp Info type:%d codec:%d";

/*Audio Transfer*/
LOG_STRING char APP_AudioTransferToAGLogString[] = "[Audio Transfer] From DUT change to AG";
LOG_STRING char APP_AudioTransferToDUTLogString[] = "[Audio Transfer] From AG change to DUT";

/*Call Status (hold/unhold)*/
LOG_STRING char APP_CallStatusLogString[] = "[Call Status] %s";

LOG_STRING char APP_VoiceCommandString[] = "[APP_VC] Voice Commnad ";
LOG_STRING char APP_VoiceCommandStartString[] = "[APP_VC] VC Start ";
LOG_STRING char APP_VoiceCommandEndString[] = "[APP_VC] Voice End ";
LOG_STRING char APP_VoiceCommandNvkeyInitSuccessString[] = "Voice Command Init Success";
LOG_STRING char APP_VoiceCommandNvkeyInitFailString[] = "Voice Command Init Fail";

LOG_STRING char APP_SetVoicePromptLanguageString[] = "[APP_VP] Change Language:%d";

/*Message Subsystem*/
LOG_STRING char MSG_CallbackTimeConsuming[]="[Message] Handler@0x%X used %d ms with id=0x%X and id_ext=%d";
LOG_STRING char MSG_MessageSendInternalFromISR_Return3[]="[Message] MSG_MessageSendInternalFromISR return 3 HandlerVar=0x%X id=0x%X delay=%d and id_ext=%d called@0x%X";
LOG_STRING char MSG_MessageSendInternalFromISR_Return2[]="[Message] MSG_MessageSendInternalFromISR return 2 Too many pending msgs";
LOG_STRING char MSG_MessageSendInternalFromISR_Return1[]="[Message] MSG_MessageSendInternalFromISR return 1 Memory allocation fail";
LOG_STRING char MSG_MessageSendInternalFromISR_Return1DPC[]="[Message] MSG_MessageSendInternalFromISR return 1 DPC";
LOG_STRING char MSG_MessageSendInternal_Return3[]="[Message] MSG_MessageSendInternal return 3 HandlerVar=0x%X id=0x%X delay=%d and id_ext=%d called@0x%X";
LOG_STRING char MSG_MessageSendInternal_Return2[]="[Message] MSG_MessageSendInternal return 2 Too many pending msgs";
LOG_STRING char MSG_MessageSendInternal_Return1[]="[Message] MSG_MessageSendInternal return 1 Memory allocation fail";
LOG_STRING char MSG_MessageSendInternal_Return1DPC[]="[Message] MSG_MessageSendInternal return 1 DPC";
LOG_STRING char MSG_PendingStatus[]="[Message] MSG_MessageConsume() now#=%d peak#=%d KernelSignal.value=0x%X";
LOG_STRING char MSG_StartDelayMessageFromISR[]="[Message] DelayMessage FromISR Start MsgEntry=0x%X Handler@0x%X id=0x%X delay=%d and id_ext=%d";
LOG_STRING char MSG_StartDelayMessage[]="[Message] DelayMessage Start MsgEntry=0x%X Handler@0x%X id=0x%X delay=%d and id_ext=%d";
LOG_STRING char MSG_DPCCallback[]="[Message] DelayMessage Timeout MsgEntry=0x%X Handler@0x%X id=0x%X delay=%d and id_ext=%d";
LOG_STRING char MSG_CallDelayedMessageHandler[]="[Message] DelayMessage Handler Called @ MessageConsume() MsgEntry=0x%X @0x%X id=0x%X delay=%d and id_ext=%d";
LOG_STRING char MSG_CancelDelayMessage[]="[Message] DelayMessage Cancel MsgEntry=0x%X Handler@0x%X id=0x%X delay=%d and id_ext=%d";
LOG_STRING char MSG_MessageDumpPendingString[]="[Message_Dumping]MsgEntry=0x%X Handler@0x%X id=0x%X delay=%d and id_ext=%d";
LOG_STRING char MSG_MessageNullHandler[]="[Message] Null Handler MsgEntry=0x%X HandlerVar=0x%X id=0x%X delay=%d and id_ext=%d called@0x%X";
LOG_STRING char MSG_MessageDPCCallbackEnter[]="[Message] DPC callback enter";
LOG_STRING char MSG_MessageDPCCallbackLeave[]="[Message] DPC callback leave";

/*NVKEY Subsystem*/
LOG_STRING char NVKEY_LOG_RAMBufferedWriting[]="[NVKEY] Writing 0x%X buffered due to bit status=0x%X, flash address bit status=0x%X, total buffered=%d";
LOG_STRING char NVKEY_LOG_RAMBufferedFlushed[]="[NVKEY] Flush buffered writing request 0x%X";
LOG_STRING char NVKEY_LOG_SectorSwapping[]="[NVKEY] Sector swapping 0-based sector number %d with erased sector number %d";
LOG_STRING char NVKEY_LOG_Write[]="[NVKEY] Writing 0x%X with length=%d rc=%d used %d ms";
LOG_STRING char NVKEY_LOG_CleanInvalidThreshold[]="[NVKEY] Clean sector invalid bytes threshold = %d bytes";
LOG_STRING char NVKEY_LOG_SectorStatusReport[]="[NVKEY] Sector #%d Status: Status Byte=0x%X Invalid Bytes=%d Space Bytes=%d Read-Only=%d";
LOG_STRING char NVKEY_LOG_NVKEYNotFound[]="[NVKEY] ID=0x%X not found";
LOG_STRING char NVKEY_LOG_NVKEYDecryptionCRCError[]="[NVKEY] ID=0x%X Decryption CRC wrong 0x%X %X %X %X vs. 0x%X %X %X %X";
LOG_STRING char NVKEY_LOG_NVKEYDecryptionLengthTooShort[]="[NVKEY] ID=0x%X Decryption error since length = %d <= 4";
LOG_STRING char NVKEY_LOG_NVKEYDecryptionNoMemory[]="[NVKEY] ID=0x%X Decryption memory allocation = %d fail";
LOG_STRING char NVKEY_LOG_NVKEYWriteError[]="[NVKEY] Write with Error = %d";
LOG_STRING char NVKEY_LOG_NVKEYWriteSameContents[]="[NVKEY] Write same contents for id=0x%X";
LOG_STRING char NVKEY_LOG_NVKEYFlashAddressDoubleEnter[]="[NVKEY] NVKEY_GetPayloadFlashAddress_Enter() double called for Task No=%d @ 0x%X";
LOG_STRING char NVKEY_LOG_AddNonExistedNVKEY_Non_FOTA[]="[NVKEY] Add Non-Existed ID=0x%X into Non-FOTA region";
LOG_STRING char NVKEY_LOG_AddNonExistedNVKEY_FOTA[]="[NVKEY] Add Non-Existed ID=0x%X into FOTA region";
LOG_STRING char NVKEY_LOG_NVKEY_GetFlashAddress_Wrong_Tag[]="[NVKEY] Wrong NVKEY(0x%X) State(0x%X) @[%d,%d]. Save 2MB flash for debug!";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_WriteFullKey[]="[NVKEY][Enter] NVKEY_WriteFullKey() id=0x%X called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_ReclaimCheck[]="[NVKEY][Enter] NVKEY_ReclaimCheck() called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_ReadFullKey[]="[NVKEY][Enter] NVKEY_ReadFullKey() id=0x%X called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_Next[]="[NVKEY][Enter] NVKEY_Next() id=0x%X called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_GetPayloadFlashAddress[]="[NVKEY][Enter] NVKEY_GetPayloadFlashAddress() id=0x%X called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_GetPayloadLength[]="[NVKEY][Enter] NVKEY_GetPayloadLength() id=0x%X called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_Flash_Access_Disable[]="[NVKEY][Enter] NVKEY_Flash_Access_Disable() called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_Flash_Access_Enable[]="[NVKEY][Enter] NVKEY_Flash_Access_Enable() called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_SetDecryptionKey[]="[NVKEY][Enter] NVKEY_SetDecryptionKey() called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_GetPayloadFlashAddress_Enter[]="[NVKEY][Enter] NVKEY_GetPayloadFlashAddress_Enter() called by 0x%X";
LOG_STRING char NVKEY_LOG_Enter_NVKEY_GetPayloadFlashAddress_Leave[]="[NVKEY][Enter] NVKEY_GetPayloadFlashAddress_Leave() called by 0x%X";
LOG_STRING char NVKEY_LOG_Semaphore_Take[]="[NVKEY][Semaphore] Taken called by 0x%X";
LOG_STRING char NVKEY_LOG_Semaphore_Release[]="[NVKEY][Semaphore] Released called by 0x%X";

/*ROFS Subsystem*/
LOG_STRING char ROFS_LOG_BaseAddressNotFound[]="[ROFS] ROFS_partitionbase() base address not found";
LOG_STRING char ROFS_LOG_FileNotFound[]="[ROFS] ROFS_fopen() file not found: id=0x%X base=0x%X pROFS_Header=0x%X ulFileNumber=%d";

/*File Stream*/
LOG_STRING char FLS_MetFileLengthZero[]="[FileStream] Met a file with lenght = 0!!!";
LOG_STRING char FLS_SDCardReadInterval[]="[FileStream] SD Card read interval = %d ms > 50 ms";

/*APP QOS*/
LOG_STRING char APP_SetQosCmdLogString[] = "[APP_QOS] [%x,%x,%x]Set Qos Cmd";
LOG_STRING char APP_QosCmdCfmLogString[] = "[APP_QOS] [%x,%x,%x]Qos Cmd Cfm:%d";

/*APP Realtime DSP*/
LOG_STRING char APP_RealtimePeqUnhandleLogString[] = "[Realtime DSP] Unhandled message = %s";
LOG_STRING char APP_RealtimePeqUndefinedLogString[] = "[Realtime DSP] Undefined message = %d";
LOG_STRING char APP_RealtimePeqSuspendDspLogString[] = "[Realtime DSP] BT_APP_DSP_REALTIME_SUSPEND_DSP";
LOG_STRING char APP_RealtimePeqResumeDspLogString[] = "[Realtime DSP] BT_APP_DSP_REALTIME_resume_DSP";
LOG_STRING char APP_RealtimePeqUpdateLogString[] = "[Realtime DSP] PEQ realtime";
LOG_STRING char APP_RealtimePeqSaveStatusLogString[] = "[Realtime DSP] PEQ SAVE Status";

/*APP Reconnect*/
LOG_STRING char APP_ReconnAddListFailLogString[] = "[APP_Reconn] invalid BdAddr";
//LOG_STRING char APP_ReconnAddListBdaddrLogString[] = "[APP_Reconn] BdAddr:%x,%x,%x,%x,%x,%x";
LOG_STRING char APP_ReconnAddListMemFailLogString[] = "[APP_Reconn] Allocate Memory fail, no reconnection!";
LOG_STRING char APP_ReconnAddListGetTag1FailLogString[] = "[APP_Reconn] 1. Get CtlData Fail, no reconnection!";
LOG_STRING char APP_ReconnAddListGetTag2FailLogString[] = "[APP_Reconn] 2. Get CtlData Fail, no reconnection!";
LOG_STRING char APP_ReconnStartACLExistLogString[] = "[APP_Reconn] ACL Exist Reconnect";
LOG_STRING char APP_ReconnStartSucessLogString[] = "[APP_Reconn] Start Reconnecting, Priority:%d, targetIdx:%d, rtyCnt:%d";
LOG_STRING char APP_ReconnAddLinkLossLogString[] = "[APP_Reconn] ReConn OOR:%d,%d";
LOG_STRING char APP_ReconnectAddListLogString[] = "[APP_Reconn] Add list type:%d, BdAddr:0x%x%x, pReconnectList:0x%x";
LOG_STRING char APP_ReconnectStopLogString[] = "[APP_Reconn] STOP_RECONNECT no list:%d is poweron :%d normal cnt:%d highpri cnt:%d";
LOG_STRING char APP_ReconnectStopLogString2[] = "[APP_Reconn] STOP_RECONNECT, feature:%d, type:%d";
LOG_STRING char APP_ReconnectStartActiveString[] = "[APP_Reconn] app_ReConn_Start isActiveLink:%d, profileCnt:%d, targetBda:0x%x%x";
LOG_STRING char APP_ReconnectStopNoTargetString[] = "[APP_Reconn] STOP_RECONNECT no target";
LOG_STRING char APP_ReconnectProfileMaskString[] = "[APP_Reconn] Reconnect profile mask exist";
LOG_STRING char APP_ReconnectNoListString[] = "[APP_Reconn] app_ReConn_Start No reconnect list count";
LOG_STRING char APP_ReconnectProfileNotReadyString[] = "[APP_Reconn] ----- Profile Not Ready!! return -----";
LOG_STRING char APP_ReconnectCheckString[] = "[APP_Reconn] ------ Reconnect Check %d!! -----";
LOG_STRING char APP_ReconnectStopRetryString[] = "[APP_ReConn] Reconn stop retry";
LOG_STRING char APP_ReconnectDeleteProfileMaskString[] = "[APP_ReConn] DeleteProfileMask profileId:0x%x, reason:%d, list cnt:%d, bdAddr:0x%x%x";
LOG_STRING char APP_ReconnectDeleteProfileMaskString2[] = "[APP_ReConn] DeleteProfileMask mask:0x%x, isActiveLink:%d";
LOG_STRING char APP_ReconnectDeleteInvalidListString[] = "[APP_ReConn] Delete Invalid List";
LOG_STRING char APP_ReconnectDeleteInvalidListByBdAddrString[] = "[APP_ReConn] Delete Invalid List by BdAddr:0x%x%x";
LOG_STRING char APP_ReconnectDeleteListString[] = "[APP_ReConn] Delete list bdAddr:0x%x%x";
LOG_STRING char APP_ReconnectPartnerRejectReconnect[] = "[APP_ReConn] Partner NOT reconnect after power on";
LOG_STRING char APP_Reconnect[] = "[APP_ReConn] Reconnect. type:%d, defaultRole:0x%x, isPowerOn:%d, airPairing:%d";
LOG_STRING char APP_ReconnectPartnerRejectReconnectString[] = "[APP_ReConn] Partner NOT reconnect after power on";
LOG_STRING char APP_ReconnectCurTgtIdxNotInvalidString[] = "[APP_ReConn] Current Target Index NOT Invalid";
LOG_STRING char APP_ReconnectStopAndClearString[] = "[APP_ReConn] Stop Reconnecting and Clear Control";
LOG_STRING char APP_ReconnectAddListByModeString[] = "[APP_ReConn] Add reconnect list by Mode:%d";
LOG_STRING char APP_ReconnectSetTypeString[] = "[APP_ReConn] Set reconnect type, before:%d, after:%d";
LOG_STRING char APP_ReconnectSetProfileMaskString[] = "[APP_ReConn] Set profile mask, before:%d, after:%d";
LOG_STRING char APP_ReconnectSetDataString[] = "[APP_ReConn] Set data, BdAddr:0x%x%x, isRecord:%d";
LOG_STRING char APP_ReconnectString1[] = "[APP_ReConn] Reconnect. type:%d, role:0x%x, isPowerOn:%d";
LOG_STRING char APP_ReconnectString2[] = "[APP_ReConn] Reconnect. ready:%d, disc:%d, airPairing:%d";
LOG_STRING char APP_ReconnectString3[] = "[APP_ReConn] Reconnect. isReady:%d, activeCnt:%d, supportNo:%d";
LOG_STRING char APP_ReconnectPutQueueIdxString[] = "[APP_ReConn] Put queue. idx:%d, type:%d";
LOG_STRING char APP_ReconnectPourQueueNumString[] = "[APP_ReConn] Pour queue. Num:%d";
LOG_STRING char APP_ReconnectPourQueueTypeString[] = "[APP_ReConn] Pour queue. type:%d";
LOG_STRING char APP_ReconnectCurrentActiveLinkCNTFailString[] = "[APP_ReConn] CURRENT_ACTIVE_LINK_CNT fail";
LOG_STRING char APP_ReconnectEnterSuperReconnectString[] = "[APP_ReConn] APP_Mcsync_EnterSuperReconnectMode";
LOG_STRING char APP_ReconnectReconnectUsrInitString[] = "[APP_ReConn] RECONNECT_USER_INIT";
LOG_STRING char APP_ReconnectCheckReconnect1String[] = "[APP_ReConn] Check Reconnect. defaultRole:0x%x, AG state:%d, keyIdx:%d, type:%d";
LOG_STRING char APP_ReconnectCheckReconnect2String[] = "[APP_ReConn] Check Reconnect. BdAddr:0x%x%x";

LOG_STRING char APP_ReconnectSpecialLinkExistString[] = "[APP_ReConn] Special link already exist";
LOG_STRING char APP_ReconnectProfileNotReady1String[] = "[APP_ReConn] Profile not ready";
LOG_STRING char APP_ReconnectPdlFcdKeyString[] = "[APP_ReConn] pdlNo:%d, fcdKeyState:%d";
LOG_STRING char APP_ReconnectActiveDiscPushToQueueString[] = "[APP_ReConn] Active disconnecting, push to Queue";



/*APP ResourceManager*/
LOG_STRING char APP_RMSetBdaddrAlreadyExistLogString[] = "[APP_RM] Set Link Addr Already";
LOG_STRING char APP_RMSetBdaddrOKLogString[] = "[APP_RM] Set Link Addr OK";
LOG_STRING char APP_RMSetScoDiscFailLogString[] = "[APP_RM] Set Sco Disc Fail, Linkinfo NULL";
LOG_STRING char APP_RMSetBdaddrFailLogString[] = "[APP_RM] Set Link Addr Fail (Full)";
LOG_STRING char APP_RMClearLinkLogString[] = "[APP_RM] Clear Link Addr";
LOG_STRING char APP_RMClearHFPLinkLogString[] = "[APP_RM] APP_ClearHfpLinkInfo!!!!!!!";
LOG_STRING char APP_RMClearAVRCPLinkLogString[] = "[APP_RM] APP_ClearAvrcpLinkInfo!!!!!!!";
LOG_STRING char APP_RMSetServiceBdAddrString[] = "[APP_RM] APP SetServiceBdAddr bdAddr:0x%x%x";

LOG_STRING char APP_RMESDInfoString[] = "[APP_RM] ESD: %d %d";

/*APP State*/
LOG_STRING char APP_StatePreventAutoPwrOnLogString[] = "[APP_STATE] PREVENT_AUTO_POWER_ON_TIMER, boot reason:(%d), ForaReconn(%d)";
LOG_STRING char APP_StateLoadStateLogString[] = "[APP_STATE] load state :%s";
LOG_STRING char APP_StatePassThruLogString[] = "[APP_STATE] Pass Thru Msg: %s, Opcode:0x%x, evtcode:0x%x, linkIndex:%d";
LOG_STRING char APP_StateGetTopStateLogString[] = "[APP_STATE] GetTopState: BdAddr: 0x%x%x, State:%s";
LOG_STRING char APP_StateIsSetAppLinkString[] = "[APP_STATE] APP IsSetAppLink TopState:%d";
LOG_STRING char APP_StateDefaultLinkString[] = "[APP_STATE] APP DefaultLink TopState:%d";
LOG_STRING char APP_StateFakeOnStatusString1[] = "[APP_STATE] Fake On Power On1:%d, %d, %d, %d";
LOG_STRING char APP_StateFakeOnStatusString2[] = "[APP_STATE] Fake On Power On2:%d, %d, %d";
LOG_STRING char APP_StateVpRtAliveLogString[] = "[APP_STATE] Vp/Rt is alive, set PREVENT_AUTO_POWER_ON_TIMER";
LOG_STRING char APP_StateIsInChargerCaseString1[] = "[APP_STATE] APP_ChgBat_IsInChargerCase():%d";
LOG_STRING char APP_StateConnectabilityString[] = "[APP_STATE] Connect ability action:%d";
LOG_STRING char APP_StateDiscoverabilityString[] = "[APP_STATE] Discover ability action:%d";

/*APP CheckKeyValid*/
LOG_STRING char APP_CheckKeyPwrOnLowBatInvalidLogString[] = "[APP_CKKey] Key Invalid: Power On Low Battery";
LOG_STRING char APP_CheckKeyInvalidReason1LogString[] = "[APP_CKKey] Key Invalid: Q Full:%d, Media Event Lock:%d";

/*APP HFPKey*/
LOG_STRING char APP_HfpKeyATIsActiveLinkLogString[] = "[APP_HfpKey] !APP_IsActiveLink";

/*APP SystemKey*/
LOG_STRING char APP_SystemKeyReconnectMaxLinkLogString[] = "[APP_SystemKey] Max Link";
LOG_STRING char APP_SystemKeyResetNameSucessLogString[] = "[APP_SystemKey] Reset device name successful";
LOG_STRING char APP_SystemKeyResetNameFailLogString[] = "[APP_SystemKey] Reset device name fail";
LOG_STRING char APP_SystemKeyAncOnFailLogString[] = "Anc On fail";
LOG_STRING char APP_SystemKeyAncOffFailLogString[] = "Anc Off fail";
LOG_STRING char APP_SystemKeyFCDResetToFactoryLogString[] = "[APP_SystemKey] APP_FCD_ResetToFactory %d";


/*APP TestMode*/
LOG_STRING char APP_TestModeStatusLogString[] = "[APP_TestMode] status:[%d]";
LOG_STRING char APP_TestModeHandlerLogString[] = "[APP_TestMode] app_TestModeHandler id:[%d]";

/*APP Pairng*/
LOG_STRING char APP_ParingConnectableStateLogString[] = "[APP_Pairing] Scan enable, Inquiry disable";
LOG_STRING char APP_ParingConDiscoverableStateLogString[] = "[APP_Pairing] Scan enable, Inquiry enable";
LOG_STRING char APP_ParingNonStateLogString[] = "[APP_Pairing] Scan disable, Inquiry disable";
LOG_STRING char APP_ParingNoMatchDiscoverModeLogString[] = "[APP_Pairing] No Match Discover Mode";
LOG_STRING char APP_ParingNoMatchConnectModeLogString[] = "[APP_Pairing] No Match Connect Mode";
LOG_STRING char APP_ParingSetConnDiscHnadlerLogString[] = "[APP_Pairing] SetConnDiscHandler. airPairState:%d, checkTimer:%d";
LOG_STRING char APP_ParingSetConnDiscHnadlerLogString2[] = "[APP_Pairing] SetConnDiscHandler. pairState:%d, role:0x%x, id:%d";

/*APP Power On*/
LOG_STRING char APP_PowerOnHandlerLogString[] 			= "[APP_PWRON] APP_SYSTEM_PowerOnHandler, power on:%d";
LOG_STRING char APP_PowerOnRHOIngStopStatusLogString[]  = "[APP_PWRON] RHOing. Stop status:%d";

/*APP Power Off*/
LOG_STRING char APP_PowerOffLoaderReasonLogString[] = "[APP_PWROFF] Power Off Loader. Reason:%d, FakeOffState:%d, IsPowerOn:%d";
LOG_STRING char APP_PowerOffTimeoutLogString[] = "[APP_PWROFF] POWER_OFF_TIMEOUT!!!!!!!";
LOG_STRING char APP_PowerOffSystemOffLogString[] = "[APP_PWROFF] System off, charger in:%d, power on:%d";
LOG_STRING char APP_PowerOffNotFakeOffPowerLogString[] = "[APP_PWROFF] not fakeoff , poweroff...";

LOG_STRING char APP_PowerOffIsDefaultRolePartnerSyncPwrKeyLogString[] = "[APP_PWROFF] IsDefaultRolePartner(%d), SYNC_PWR_OFF_KEY_TO_AGENT_FEAT(%d)";

/*APP Race Cmd*/
LOG_STRING char APP_RaceCmdHandlerLogString[] = "[APP_RACE] Unhandled Race Command ID:%d\n";
LOG_STRING char APP_RaceCmdFotaStartLogString[] = "[APP FOTA] Start Ind. isDspSuspend:%d";
LOG_STRING char APP_RaceCmdFotaStopLogString[] = "[APP FOTA] Stop Ind";
LOG_STRING char APP_RaceCmdFotaStopReconnectScoLogString[] = "[APP FOTA] Reconnect SCO";

/*APP Race ANC*/
LOG_STRING char APP_RaceCmdANCGetStatusLogString[] = "[APP_RACE] APP_AncGetStatus[%x]";
LOG_STRING char APP_RaceCmdANCSetGainLogString[] = "[APP_RACE] AppAncSetGain[%x][%x]";

/*APP VolumeA2DPProcess*/
LOG_STRING char APP_VolA2dpSaveHistoryRuntimeLogString[] = "[APP_A2DP] A2DP save history in run time";
LOG_STRING char APP_VolA2dpSpkMuteByLinkLogString[] = "[APP_A2DP] A2DP speaker mute by link";
LOG_STRING char APP_VolA2dpCycleVolUpLogString[] = "[APP_A2DP] A2DP cyclic volume up feature";
LOG_STRING char APP_VolA2dpCycleVolDownLogString[] = "[APP_A2DP] A2DP cyclic volume down feature";

/*APP VolumeAiroThru*/
LOG_STRING char APP_VolAiroThruSendVolToDspLogString[] = "[APP_AIROTHRU] AiroThru send vol to dsp soundlevel:%d";
LOG_STRING char APP_VolAiroThruSetSoundLevelLogString[] = "[APP_AIROTHRU] Set AiroThru Sound Level: %d";

/*APP VolumeLineIn*/
LOG_STRING char APP_VolLineInVolUpLogString[] = "[APP_LINEIN] Line in Volume Up:%d, CurSoundLevel:%d";
LOG_STRING char APP_VolLineInCycleVolUpLogString[] = "[APP_LINEIN] Line in cyclic volume up feature";
LOG_STRING char APP_VolLineInReachMaxLogString[] = "[APP_LINEIN] Line in volume reach max volume";
LOG_STRING char APP_VolLineInCycleVolDownLogString[] = "[APP_LINEIN] Line in volume down feature";
LOG_STRING char APP_VolLineInReachMinLogString[] = "[APP_LINEIN] Line in volume reach min volume";
LOG_STRING char APP_LineInClearAudioDevLogString[] = "[APP_LINEIN] Clear Line-in audiodev only";

/*APP VolumeMP3*/
LOG_STRING char APP_VolMp3CycleVolUpLogString[] = "[APP_MP3] MP3 cyclic volume up feature";
LOG_STRING char APP_VolMp3CycleVolDownLogString[] = "[APP_MP3] MP3 cyclic volume down feature";

/*APP VolumeScoMic*/
LOG_STRING char APP_VolScoMicSaveHistoryLogString[] = "[APP_SCOMIC] SCO Mic save history in run time";
LOG_STRING char APP_VolScoMicMuteByLinkLogString[] = "[APP_SCOMIC] SCO Mic mute by link";
LOG_STRING char APP_VolScoMicCycleVolUpLogString[] = "[APP_SCOMIC] SCO Mic cyclic volume up feature";
LOG_STRING char APP_VolScoMicCycleVolDownLogString[] = "[APP_SCOMIC] SCO Mic cyclic volume down feature";
LOG_STRING char APP_VolScoMicSetMicMuteLogString[] = "[APP_SCOMIC] Set SCO Mic MuteOn:%d";

/*APP VolSco*/
LOG_STRING char APP_VolScoSaveHistoryLogString[] = "[APP_SCO] SCO save history in run time";
LOG_STRING char APP_VolScoMuteByLinkLogString[] = "[APP_SCO] SCO speaker mute by link";
LOG_STRING char APP_VolScoCycleVolUpLogString[] = "[APP_SCO] SCO cyclic volume up feature";
LOG_STRING char APP_VolScoCycleVolDownLogString[] = "[APP_SCO] SCO cyclic volume down feature";
LOG_STRING char APP_VolScoSetSpkMuteLogString[] = "[APP_SCO] Set SCO Spk MuteOn:%d";

/*APP VolVpRt*/
LOG_STRING char APP_VolVpRtCycleVolUpLogString[] = "[APP_VPRT] VPRT cyclic volume up feature";
LOG_STRING char APP_VolVpRtCycleVolDownLogString[] = "[APP_VPRT] VPRT cyclic volume down feature";

/*APP System*/
LOG_STRING char APP_SystemBtInitCfmLogString[] = "[APP_SYS] BT_INIT_CFM %s";
LOG_STRING char APP_SystemBtDeInitCfmLogString[] = "[APP_SYS] BT_DEINIT_CFM %s, %d";
LOG_STRING char APP_SystemWriteLocalNameCfmLogString[] = "[APP_SYS] BT_WRITE_LOCAL_NAME_CFM %s";
LOG_STRING char APP_SystemWriteClassDeviceCfmLogString[] = "[APP_SYS] BT_WRITE_CLASS_OF_DEVICE_CFM %s";
LOG_STRING char APP_SystemWriteEIRDataCfmLogString[] = "[APP_SYS] BT_WRITE_EIR_DATA_CFM %s";
LOG_STRING char APP_SystemACLOpenIndLogString[] = "[APP_SYS] BT_ACL_OPENED_IND %d: 0x%x%x";
LOG_STRING char APP_SystemACLOpenFailLogString[] = "[APP_SYS] BT ACL OPEN FAIL";
LOG_STRING char APP_SystemACLCloseIndLogString[] = "[APP_SYS] BT_ACL_CLOSED_IND %d: 0x%x%x";
LOG_STRING char APP_SystemSmIoCapabilityLogString[] = "[APP_SYS] BT_SM_IO_CAPABILITY_REQ_IND";
LOG_STRING char APP_SystemSmPinCodeLogString[] = "[APP_SYS] BT_SM_PIN_CODE_IND";
LOG_STRING char APP_SystemSmUserCfmReqLogString[] = "[APP_SYS] BT_SM_USER_CONFIRMATION_REQ_IND";
LOG_STRING char APP_SystemSmUserPassKeyReqLogString[] = "[APP_SYS] BT_SM_USER_PASSKEY_REQ_IND";
LOG_STRING char APP_SystemSmSetServiceCfgCfmLogString[] = "[APP_SYS] BT_SM_SET_SERVICE_CONFIG_CFM cfm:%d";
LOG_STRING char APP_SystemSmDelAllAuthDeviceCfnLogString[] = "[APP_SYS] BT_SM_DELETE_ALL_AUTH_DEVICE_CFM_T cfm:%d";
LOG_STRING char APP_SystemSetSniffSubratingLogString[] = "[APP_SYS] BT_SET_SNIFF_SUBRATING_CFM: %d";
LOG_STRING char APP_SystemSetModeCfmLogString[] = "[APP_SYS] BT_SET_MODE_CFM: %d";
LOG_STRING char APP_SystemGapReqStatusLogString[] = "[APP_SYS] gap reg status:[%d]";
LOG_STRING char APP_SystemUnknownMsgLogString[] = "[APP_SYS] Rx Unknown Message:%x";
LOG_STRING char APP_SystemZombieAudioDeviceLogString[] = "[APP_SYS] Zombie Audio Device";
LOG_STRING char APP_SystemMpTestModeLogString[] = "[APP_SYS] MP test mode ENABLED";
LOG_STRING char APP_SystemSetSingleHSModeLogString[] = "[APP_SYS] Set Single Headset Mode:%d, Role:0x%x, State:%d";
LOG_STRING char APP_SystemSingleHSModeEnableLogString[] = "[APP_SYS][SingleHS] Mode Enable";
LOG_STRING char APP_SystemSingleHSModeDisableLogString[] = "[APP_SYS][SingleHS] Mode Disable. NvKeyRole:0x%x";
LOG_STRING char APP_SystemSetSingleHSModeStateLogString[] = "[APP_SYS][SingleHS] Set Mode State:%d";

LOG_STRING char APP_SystemSingleHSModeEndLogString[] 						= "[APP_SYS][SingleHS] Mode End";
LOG_STRING char APP_SystemSingleHSSetRoleSuccLogString[] 					= "[APP_SYS][SingleHS] set role successful";
LOG_STRING char APP_SystemSingleHSSetRoleFailLogString[] 					= "[APP_SYS][SingleHS] set role failed";
LOG_STRING char APP_SystemSingleHSLeavingModeSuccLogString[] 				= "[APP_SYS][SingleHS] Leaving mode isSuccessful:%d";
LOG_STRING char APP_SystemSingleHSSingleHSModeStateLogString[] 				= "[APP_SYS][SingleHS] SingleHS Mode. state:%d";
LOG_STRING char APP_SystemSingleHSEnterSingleHeadsetModeLogString[] 		= "[APP_SYS][SingleHS] Enter Single Headset Mode";
LOG_STRING char APP_SystemSingleHSEnterSingleHeadsetModeFailedLogString[] 	= "[APP_SYS][SingleHS] Enter Single Headset Mode Failed";
LOG_STRING char APP_SystemSingleHSExitHSModeStateLogString[] 				= "[APP_SYS][SingleHS] Exit Single Headset Mode. state:%d, isNeedBackRole:%d, NvKeyRole:0x%x";
LOG_STRING char APP_SystemSingleHSModeBackRoleFailedLogString[] 			= "[APP_SYS][SingleHS] Single HS Mode back role failed";
LOG_STRING char APP_SystemSingleHSRoleModeLeaveLogString[] 					= "[APP_SYS][SingleHS] RoleMode Leave. currMode:%d, isNeedBackRole:%d, isClearAllMode:%d";
LOG_STRING char APP_SystemSingleHSSetRoleMode1LogString[] 					= "[APP_SYS][SingleHS] Set RoleMode. setMode:%d, setRole:0x%x";
LOG_STRING char APP_SystemSingleHSSetRoleMode2LogString[] 					= "[APP_SYS][SingleHS] Set RoleMode. currMode:%d, nextMode:%d, currRole:0x%x, nextRole:0x%x";
LOG_STRING char APP_SystemSingleHSRoleModeLeaveIndLogString[] 				= "[APP_SYS][SingleHS] role mode leave ind. mode:%d, currMode:%d, nextMode:%d";
LOG_STRING char APP_SystemSingleHSRoleModeLeaveIndClearAllModeLogString[] 	= "[APP_SYS][SingleHS] Role mode leave ind clear all mode";
LOG_STRING char APP_SystemSingleHSRoleModeChangeIndLogString[] 				= "[APP_SYS][SingleHS] role mode change ind. status:%d, currMode:%d";
LOG_STRING char APP_SystemSBTGapDUTCfmLogString[] 							= "[APP_SYS][GAP] BT_GAP_DUTMODE_CFM";

/*APP Sniff*/
LOG_STRING char APP_SniffDisableLogString[] = "[APP_SNIFF] APP Exit sniff mode: BdAddr:0x%x%x, reason:%d, Mask:0x%x";
LOG_STRING char APP_SniffEnableLogString[] = "[APP_SNIFF] APP Enter sniff mode: BdAddr:0x%x%x, reason:%d, Mask:0x%x";
LOG_STRING char APP_SniffCheckLogString[] = "[APP_SNIFF] APP Check sniff: BdAddr:0x%x%x, LinkMask:0x%x, systemMask:0x%x";

/**APP AirApp*/
LOG_STRING char APP_AirAppFotaReconnectLogString[] = "[APP_AIRAPP] FOTA Reconnect Byte: %x";
LOG_STRING char APP_AirAppFotaDisReconnLogString[] = "[APP_AIRAPP] FOTA Disable Recon Error code:%x";
LOG_STRING char APP_AirAppDisConnSppLogString[] = "[APP_AIRAPP] DisconnectReq SPP";
LOG_STRING char APP_AirAppDisConnBleLogString[] = "[APP_AIRAPP] DisconnectReq BLE. isBleConnected:%d";
LOG_STRING char APP_AirAppHandlerInitCfmLogString[] = "[APP_AIRAPP] HandleInitCfm";
LOG_STRING char APP_AirAppHandlerConnIndLogString[] = "[APP_AIRAPP] HandleConnectInd bearer %d";
LOG_STRING char APP_AirAppHandlerDisConnIndLogString[] = "[APP_AIRAPP] HandleDisconnectInd bearer %d";
LOG_STRING char APP_AirAppHandlerDisConnCfmLogString[] = "[APP_AIRAPP] HandleDisconnectCfm bearer %d";
LOG_STRING char APP_AirAppHandlerStartServiceCfmLogString[] = "[APP_AIRAPP] HandleStartServerCfm";
LOG_STRING char APP_AirAppHandlerSetRandomAddrCfmLogString[] = "[APP_AIRAPP] HandleSetRandomAddrCfm";
LOG_STRING char APP_AirAppHandlerAdvParamCfmLogString[] = "[APP_AIRAPP] HandleAdvParamCfm";
LOG_STRING char APP_AirAppAdvEnableReqLogString[] = "[APP_AIRAPP] BleSetAdvEnableReq";
LOG_STRING char APP_AirAppHandlerSetAdvDataCfmLogString[] = "[APP_AIRAPP] HandleSetAdvDataCfm";
LOG_STRING char APP_AirAppHandlerExchangeMTULogString[] = "[APP_AIRAPP] HandleExchangeMTU: %02x\n";
LOG_STRING char APP_AirAppHandlerBleDisConnRspLogString[] = "[APP_AIRAPP] HandleBleDisconnectRsp status %d";

/*APP Link Key*/
LOG_STRING char APP_LinkKeyReadNormalHistoryFail[] = "[APP_LINKKEY] Normal Read Fail";
LOG_STRING char APP_LinkKeyReadAwsHistoryFail[] = "[APP_LINKKEY] Aws Read Fail";
LOG_STRING char APP_LinkKeyReadFcdHistoryFail[] = "[APP_LINKKEY] FCD Read Fail";
LOG_STRING char APP_LinkKeyReadMiscParaFail[] = "[APP_LINKKEY] MISC Para Read Fail";
LOG_STRING char APP_LinkKeySetHistorySoundLevel[] = "[APP_LINKKEY] linkkey scosdlv:%d, a2dpsdlv:%d, micScosdlv:%d";
LOG_STRING char APP_LinkKeyUpdateHistory[] = "[APP_LINKKEY] Update Link History:%d";

/* APP MCS Link Key */
LOG_STRING char APP_McsLinkKey_UpdateRemoteLinkKey_LogString[] = "[APPMcsLinkKey] Update Remote Link Key. defaultRole:0x%x Num:%d, pLinkKey:0x%x";
LOG_STRING char APP_McsLinkKey_AgentAddNormalLinkKey_LogString[] = "[APPMcsLinkKey] Agent Add LinkKey. BdAddr:0x%x%x, a2dpVol:%d, scoVol:%d, scoMic:%d";
LOG_STRING char APP_McsLinkKey_PartnerAddNormalLinkKey_LogString[] = "[APPMcsLinkKey] Partner Add LinkKey. BdAddr:0x%x%x, a2dpVol:%d, scoVol:%d, scoMic:%d";
LOG_STRING char APP_McsLinkKey_PartnerSendLinkKey_LogString[] = "[APPMcsLinkKey] Partner Send Link Key. local Num:%d";
LOG_STRING char APP_McsLinkKey_AgentSendLinkKey_LogString[] = "[APPMcsLinkKey] Agent Send Link Key. local Num:%d, remote Num:%d";
LOG_STRING char APP_McsLinkKey_GetAuthDeviceCfm_LogString[] = "[APPMcsLinkKey] Get Auth Device Cfm status:%d, BdAddr:0x%x%x, cnt:%d, Num:%d";
LOG_STRING char APP_McsLinkKey_AddAuthDeviceCfm_LogString[] = "[APPMcsLinkKey] Add Auth Device Cfm status:%d";
LOG_STRING char APP_McsLinkKey_GetLocalLinkKey_LogString[] = "[APPMcsLinkKey] Get Local Link Key. Num:%d, Sent Num:%d";
LOG_STRING char APP_McsLinkKey_SyncLinkKeyInd_LogString[] = "[APPMcsLinkKey] Sync Link Key Ind. length:%d, pData:0x%x";
LOG_STRING char APP_McsLinkKey_GetNullLinkKey_LogString[] = "[APPMcsLinkKey] Get NULL Link Key History. BdAddr:0x%x%x";
LOG_STRING char APP_McsLinkKey_SyncBleLinkKeyInd_LogString[] = "[APPMcsLinkKey] Sync BLE AMA Link Key Ind. length:%d, pData:0x%x role %d %d";
LOG_STRING char APP_McsLinkKey_SyncAmaDataInd_LogString[] = "[APPMcsLinkKey] Sync AMA data Ind. length:%d, pData:0x%x, isDone %d role %d %d";
LOG_STRING char APP_McsLinkKey_GetAuthListCfm_LogString[] = "[APPMcsLinkKey] SM_GET_AUTH_DEVICE_LIST_EX_CFM len:%d";
LOG_STRING char APP_McsLinkKey_AddAuthListCfm_LogString[] = "[APPMcsLinkKey] SM_ADD_AUTH_DEVICE_LIST_CFM num:%d, data: 0x04%x 0x04%x";


/* APP MCSync Inquiry*/
LOG_STRING char APP_MCSyncInquiryCancelCfm[] 				= "[MCSync] Inquiry Cancel confirm";
LOG_STRING char APP_MCSyncWriteInquiryModeCfm[] 			= "[MCSync] Write Inquiry mode confirm: status:%d";
LOG_STRING char APP_MCSyncSystemInquiryResult[] 			= "[MCSync] System Inquiry Result";
LOG_STRING char APP_MCSyncSystemInquiryStopInd[] 			= "[MCSync] System inquiry stop indication";
LOG_STRING char APP_MCSyncSystemWriteInquiryAccessCodeCfm[] = "[MCSync] System Write Inquiry Access Code confirmation";
LOG_STRING char APP_MCSyncInquiryLIAC[] 					= "[MCSync] Inquiry LIAC[%d], LIAC value:%x, Time:%d, Num:%d";
LOG_STRING char APP_MCSyncReqInquiryStatusCfm[] 			= "[MCSync] Request Inquiry Status confirmation:%d";
LOG_STRING char APP_MCSyncPairingExitState[] 				= "[MCSync] MCSync Pairing Exit State, pairing result:%d";
LOG_STRING char APP_MCSyncInquiryResultBdAddr[] 			= "[MCSync] Inquiry Result BdAddr:%x %x %x %x %x %x";
LOG_STRING char APP_MCSyncCompareRSSIValue[] 				= "[MCSync] Inquiry Result Found RSSI Value:%d, Exist RSSI Value:%d, RSSI threshold:%d";
LOG_STRING char APP_MCSyncStillInAWSState[] 				= "[MCSync] Still In AWS State";
LOG_STRING char APP_MCSyncDecideAgent[] 					= "[MCSync] Decide Role: Agent";
LOG_STRING char APP_MCSyncDecidePartner[] 					= "[MCSync] Decide Role: Partner";

LOG_STRING char APP_MCSyncAirPairingStartLog[] 				= "[MCSync] Air Pairing Start";
LOG_STRING char APP_MCSyncAirPairingReleaseAGLog[]			= "[MCSync] Air Pairing. Release AG";
LOG_STRING char APP_MCSyncAirPairingNoAGLog[]				= "[MCSync] Air Pairing. No AG";
LOG_STRING char APP_MCSyncAirPairingNoRoleModeLog[]			= "[MCSync] Air Pairing. No role mode";
LOG_STRING char APP_MCSyncAirPairingAGDetachLog[]			= "[MCSync] Air Pairing. AG detached";
LOG_STRING char APP_MCSyncAirPairingCfmStatusLog[]			= "[MCSync] Air Pairing, cfm:%d";
LOG_STRING char APP_MCSyncAirPairingRoleModeLeaveLog[]		= "[MCSync] Air Pairing. Role mode leaved";

/*APP Connection*/
LOG_STRING char APP_ConnectSetConnectedLog[] = "[APP_CONN] PM_CONNECT_CFM isInConn:%d ConnDevCnt:%d";
LOG_STRING char APP_ConnectConnectCfmLog[] = "[APP_CONN] PM_CONNECT_CFM PID:0x%x ConnProfileCnt:%d bda:0x%x%x";
LOG_STRING char APP_ConnectDisConnectCfmLog[] = "[APP_CONN] PM_DISCONNECT_CFM PID:0x%x";
LOG_STRING char APP_ConnectRegisterCfmLog[] = "[APP_CONN] PM_REGISTER_APP_CFM";
LOG_STRING char APP_ConnectUndefineMsgLog[] = "[APP_CONN] Undefined message = %d";
LOG_STRING char APP_ConnectNoLinkDetachLog[] = "[APP_CONN] No Link to Detach";
LOG_STRING char APP_ConnectAllProfileRegisteredLog[] = "[APP_CONN] All Profile Registered Cfm: isPowerOn:%d, isFOTA:%d";
LOG_STRING char APP_ConnectNeedToRHODelayLog[] = "[APP_CONN] SmtChgCse need to RHO delay";

/* APP HFP*/
LOG_STRING char APP_HFPDisConnCfmLogString[] = "[APP_HFP] In HFP State Disc Profile";
LOG_STRING char APP_HFPCallerNumIndLogString[] = "[APP_HFP] HFP_CALLER_NUM_IND";
LOG_STRING char APP_HFPRingIndLogString[] = "[APP_HFP] HFP_RING_IND";
LOG_STRING char APP_HFPPlusVgsLogString[] = "[APP_HFP] HFP_PLUS_VGS_IND - VGS : %d";
LOG_STRING char APP_HFPPlusVgmLogString[] = "[APP_HFP] HFP_PLUS_VGM_IND - VGM : %d";
LOG_STRING char APP_HFPServiceFailLogString[] = "[APP_HFP] SERVICE FAIL";
LOG_STRING char APP_HFPCallFailLogString[] = "[APP_HFP] CALL FAIL";
LOG_STRING char APP_HFPCallSetupFailLogString[] = "[APP_HFP] CALL SETUP FAIL";
LOG_STRING char APP_HFPCallHeldFailLogString[] = "[APP_HFP] CALL HELD FAIL";
LOG_STRING char APP_HFPSignalFailLogString[] = "[APP_HFP] SIGNAL FAIL";
LOG_STRING char APP_HFPRoamFailLogString[] = "[APP_HFP] ROAM FAIL";
LOG_STRING char APP_HFPBatchgFailLogString[] = "[APP_HFP] BATCHG FAIL";
LOG_STRING char APP_HFPAppleSiriLogString[] = "[APP_HFP] HFP_APPLE_SIRI_IND";
LOG_STRING char APP_HFPMsgLogString[] = " [APP_HFP] %s, id:0x%x";

LOG_STRING char APP_HFPFillRHODataErrorLogString[] = "[APP_HFP] Fill RHO data error";
LOG_STRING char APP_HFPAssignRHODataErrorLogString[] = "[APP_HFP] Assign RHO data error";
LOG_STRING char APP_HFPScoRHONotAllowMsgNumLogString[] = "[APP_HFP] HfpSco RHO Not Allow Msg Number:%d";
LOG_STRING char APP_HFPImgMediaRHONotAllowMsgNumLogString[] = "[APP_HFP] HfpImgMedia RHO Not Allow Msg Number:%d";




LOG_STRING char APP_HFPMsg[][MAX_LOG_STRING] =
{
	"HFP_START_SERVICE_CFM",
	"HFP_STOP_SERVICE_CFM",
	"HFP_CONNECT_IND",
	"HFP_DISCONNECT_CFM",
	"HFP_DISCONNECT_IND",
	"HFP_CONNECT_CFM",
	"HFP_AG_ERROR_CODE_IND",
	"HFP_AG_EXT_ERROR_IND",
	"HFP_SUSCRIBER_NUM_IND",
	"HFP_CALLER_NUM_IND",
	"HFP_CURRENT_CALL_LIST_IND",
	"HFP_INBAND_RINGTONE_IND",
	"HFP_RESPONSE_HOLD_IND",
	"HFP_RING_IND",
	"HFP_PLUS_VGS_IND",
	"HFP_PLUS_VGM_IND",
	"HFP_SERVICE_IND",
	"HFP_CALL_IND",
	"HFP_CALLSETUP_IND",
	"HFP_CALLHELD_IND",
	"HFP_SIGNAL_IND",
	"HFP_ROAM_IND",
	"HFP_BATCHG_IND",
	"HFP_APPLE_SIRI_IND",
	"HFP_UNKNOWN_RESULT_CODE_IND",
	"HFP_AT_ACCEPT_CALL_CFM",
	"HFP_AT_AG_ERROR_CODE_CFM",
	"HFP_AT_APL_EFM_CFM",
	"HSP_AT_BUTTON_PRESS_CFM",
	"HFP_AT_CALL_WAITING_CFM",
	"HFP_AT_CODEC_SELECT_CFM",
	"HFP_AT_INIT_SCO_CONN_CFM",
	"HFP_AT_NREC_CFM",
	"HFP_AT_REDIAL_CFM",
	"HFP_AT_TERMINATE_CALL_CFM",
	"HFP_AT_VGS_CFM",
	"HFP_AT_VGM_CFM",
	"HFP_AT_VOICE_DIAL_CFM",
	"HFP_AT_VENDOR_IND",
	"HFP_AT_VENDOR_TIMEOUT_IND",
	"HFP_AT_VENDOR_OK_IND",
	"HFP_AT_VENDOR_ERROR_IND",
};

LOG_STRING char APP_HFPStartServiceLogString[] = "[APP_HFP] HFP_StartService";
LOG_STRING char APP_HFPImgCallerIDLogString[] = "[APP_HFP] IncomingCall SetNum FAIL";
LOG_STRING char APP_HFPImgAudioVoiceLogString[] = "[APP_HFP] ImgAudioVoice:STOPNew";
LOG_STRING char APP_HFPScoLinkTypeLogString[] = "[APP_HFP] link type:[%s]";

LOG_STRING char APP_HFPScoLinkType[][MAX_LOG_STRING] =
{
	"SCO",
	"ACL",
	"eSCO",
	"SCO_ONLY_HV3"
};

LOG_STRING char APP_HFPScoDisIndErrorLogString1[] = "[APP_HFP] BT_SYNC_DISC_IND fail - BdAddress Null";
LOG_STRING char APP_HFPScoConnIndErrorLogString1[] = "[APP_HFP] BT_SYNC_CONNECT_IND reject - no resource";
LOG_STRING char APP_HFPScoConnIndErrorLogString2[] = "[APP_HFP] BT_SYNC_CONNECT_IND reject - wrong state %d";
LOG_STRING char APP_HFPScoConnIndAcceptLogString[] = "[APP_HFP] BT_SYNC_CONNECT_IND accept state %d";
LOG_STRING char APP_HFPScoHandlerLogString[] = "[APP_HFP] app_HfpSCOHandler - %s, id:%x";
LOG_STRING char APP_HFPScoHandle[][MAX_LOG_STRING] =
{
    "BT_SYNC_REGISTER_CFM",
    "BT_SYNC_UNREGISTER_CFM",
    "BT_SYNC_CONNECT_CFM",
    "BT_SYNC_CONNECT_IND",
    "BT_SYNC_DISCONNECT_CFM",
    "BT_SYNC_DISCONNECT_IND",
    "BT_SYNC_RENEGOTIATE_IND"
};
LOG_STRING char APP_HFPScoConnCfmString1[] = "[APP_HFP] BT_SYNC_CONNECT_CFM - status:%d, scoHandler:%d, linkType:%d, airMode:%d";
LOG_STRING char APP_HFPScoConnCfmString2[] = "[APP_HFP] BT_SYNC_CONNECT_CFM - LocalScoState:%d, AgentScoState:%d, sink:%d";
LOG_STRING char APP_HFPScoConnCfmErrorString1[] = "[APP_HFP] Set Sco connected Fail - LinkInfo NULL";
LOG_STRING char APP_HFPScoConnCfmAddLinkString1[] = "[APP_HFP] Sco Add Link State:%d, %d, %d, %d";
LOG_STRING char APP_HFPScoConnCfmAddLinkString2[] = "[APP_HFP] Reg Sco and Send DSP Cmd";
LOG_STRING char APP_HFPScoConnCfmAddLinkString3[] = "[APP_HFP] Reg AudioDev and Send DSP Cmd";
LOG_STRING char APP_HFPScoA2dpStreamHandlerExist1String[] = "[APP_HFP] A2dp stream handler exist1 ";
LOG_STRING char APP_HFPScoA2dpStreamHandlerNotExist1String[] = "[APP_HFP] A2dp stream handler Not exist1 ";

/*APP HFP RHO */


/*APP A2DP*/
LOG_STRING char APP_A2dpStartServiceCfmLogString[] = "[    APP][A2DP] Start Service Cfm : Status: 0x%x";
LOG_STRING char APP_A2dpStopServiceCfmLogString[] = "[    APP][A2DP] Stop Service Cfm : Status: 0x%x";
LOG_STRING char APP_A2dpSignalConnIndLogString[] = "[    APP][A2DP] Signal Connect Ind : BdAddr : 0x%x%x";
LOG_STRING char APP_A2dpSignalConnCfmLogString1[] = "[    APP][A2DP] Signal Connect Cfm : BdAddr : 0x%x%x, Status:0x%x";
LOG_STRING char APP_A2dpSignalConnCfmLogString2[] = "App_A2dp Chg Codec Signal Connection Cfm";
LOG_STRING char APP_A2dpSignalDisConnCfmLogString1[] = "[    APP][A2DP] Signal Disconnect Cfm : BdAddr : 0x%x%x, Status:0x%x";
LOG_STRING char APP_A2dpSignalDisConnCfmLogString2[] = "App_A2dp Signal Disconnect By Avdtp Close Cmd";
LOG_STRING char APP_A2dpMediaConnCfmLogString[] = "[    APP][A2DP] Media Connect Cfm : BdAddr : 0x%x%x, Status:0x%x";
LOG_STRING char APP_A2dpMediaDisConnCfmLogString1[] = "[    APP][A2DP] Media Disconnect Cfm: BdAddr : 0x%x%x, Status:0x%x , Codec Change State : 0x%x";
LOG_STRING char APP_A2dpMediaDisConnCfmLogString2[] = " Disconnect AVDTP Signal Connection";
LOG_STRING char APP_A2dpStartIndLogString[] = "[    APP][A2DP] Start Ind: BdAddr : 0x%x%x, AudioDevReg:%d, State:%d";
LOG_STRING char APP_A2dpIndLogString[] = "[    APP][A2DP] Rx Unknown Message : id: %d";
LOG_STRING char APP_A2dpCeltLogString[] = "Celt parameter - rate:%d, channels:%d, frameSize:%d, bytes_per_packet:%d, complexity:%d";
LOG_STRING char APP_A2dpDspPlayLogString[] = "[    APP][A2DP] Audioable BdAddr : 0x%x%x";
LOG_STRING char APP_A2dpMediaCodecChgLogString[] = "[    APP][A2DP]Chg Codec State : %d";
LOG_STRING char APP_A2dpCodecChgFunLogString1[] = "[    APP][A2DP]App Chg Codec Address : 0x%x%x, gAppChgCodec.state : %d";
LOG_STRING char APP_A2dpCodecChgFunLogString2[] = "[    APP][A2DP]Codec Change Begin State";
LOG_STRING char APP_A2dpFillRHODataErrorLogString1[] = "[    APP][A2DP] Fill RHO data error";
LOG_STRING char APP_A2dpAssignRHODataErrorLogString2[] = "[    APP][A2DP] Assign RHO data error";

LOG_STRING char APP_A2dpRegisterA2dpStartHandlerLogString[] = "[    APP][A2DP] Register a2dp start handler";
LOG_STRING char APP_A2dpSCOStreamHandlerNOTExistLogString[] = "[    APP][A2DP] SCO stream handler NOT exist";

/*APP CapTouch*/
LOG_STRING char APP_CapTouchInitString[] 							= "[CAPTOUCH] APP CapTouch Init OK";
LOG_STRING char APP_CapTouchCallbackResultString[] 					= "[CAPTOUCH] APP CapTouch Callback result, state:%d channel:%d";

/*APP VP/RT Sync*/
//LOG_STRING char APP_VPRT_MasterLogString[] 							= "[VPRT] Master timeToWait: %d, currentPicoClock:%d, VP: %s, RT: %s";
LOG_STRING char APP_VPRT_MasterLogString[] 							= "[VPRT] Set sync timer Master. CurrClk:%d, WaitTime:%d, StartClk:%d, EvtIdx:0x%x, VP:%s, RT:%s";
LOG_STRING char APP_VPRT_MasterNOTSyncBeepStopString[]				= "[VPRT] Master NOT Sync beep stop";
LOG_STRING char APP_VPRT_VPRTPlayingTimerString[]					= "[VPRT] VpRt Playing Timer: IsAgent:%d, IsPartner:%d";
LOG_STRING char APP_VPRT_VPRTBeepTimerString[]						= "[VPRT] VpRt Beep Timer: IsAgent:%d, IsPartner:%d";
LOG_STRING char APP_VPRT_PlayingVpRtDPCCallbackString[]				= "[VPRT] app_VpRt_PlayingVpRtDPCCallback. CurrClk:%d, eventIndex:0x%x";
LOG_STRING char APP_VPRT_StopVpRtDPCCallbackString[]				= "[VPRT] app_VpRt_StopVpRtDPCCallback. CurrClk:%d, eventIndex:0x%x";
LOG_STRING char APP_VPRT_PlayingBeepCallbackString[]				= "[VPRT] app_VpRt_PlayingBeepCallback. CurrClk:%d, eventIndex:0x%x";
LOG_STRING char APP_VPRT_SetOSDPCTimerString[]						= "[VPRT] Set OS DPC Timer, id:%d, CurrClk:%d, delay(ms):%d";
LOG_STRING char APP_VPRT_SetOSDPCStopTimerString[]					= "[VPRT] Set OS DPC stop Timer, id:%d, CurrClk:%d, delay(ms):%d, eventIndex:%d";
LOG_STRING char APP_VPRT_SetSyncTimerSlave1String[]					= "[VPRT] Set sync timer Slave. EvtIdx:%d, VP:%s, RT:%s";
LOG_STRING char APP_VPRT_SetSyncTimerSlave2String[]					= "[VPRT] Set sync timer Slave. CurrClk:%d, WaitTime:%d, StartClk:%d, timeTH:%d";


/*APP AVRCP*/
LOG_STRING char APP_AvrcpPlayStatusLogString[] = "CurrentPlayStatus:%d remotePlayStatus:%d";
LOG_STRING char APP_AvrcpDecideOpIdLogString[] = "Decide Operation: %s";
LOG_STRING char APP_AvrcpSendOpIdLogString[] = "Send Operation: %s";
LOG_STRING char APP_AvrcpGetAbsVolLogString[] = "AVRCP_GetSetAbsVol - BdAddr:0x%x%x, absVol:%d";
LOG_STRING char APP_AvrcpPassThroughIndLogString[] = "PassThrough Ind, OPID:%s";
LOG_STRING char APP_AvrcpGetPlayStausIndogString[] = "Get Play Status Rsp Ind - isSendPlayPause:%d, Play Status:%d";
LOG_STRING char APP_AvrcpRegNotifyRspIndLogString[] = "RegisterNotify Rsp Ind - %s";
LOG_STRING char APP_AvrcpNotifyErrorLogString[] = "Warning!!! Can't get Link Info!!!";
LOG_STRING char APP_AvrcpRegNotifyRspEvtID[][MAX_LOG_STRING] =
{
	"",
	"AVRCP_EVENT_ID_PLAYBACK_STATUS_CHANGED",
	"AVRCP_EVENT_ID_TRACK_CHANGED",
	"AVRCP_EVENT_ID_TRACK_REACHED_END",
	"AVRCP_EVENT_ID_TRACK_REACHED_START",
	"AVRCP_EVENT_ID_PLAYBACK_POS_CHANGED",
	"AVRCP_EVENT_ID_BATT_STATUS_CHANGED",
	"AVRCP_EVENT_ID_SYSTEM_STATUS_CHANGED",
	"AVRCP_EVENT_ID_PLAYER_APPLICATION_SETTING_CHANGED",
	"AVRCP_EVENT_ID_NOW_PLAYING_CONTENT_CHANGED",
	"AVRCP_EVENT_ID_AVAILABLE_PLAYERS_CHANGED",
	"AVRCP_EVENT_ID_ADDRESSED_PLAYER_CHANGED",
	"AVRCP_EVENT_ID_UIDS_CHANGED",
	"AVRCP_EVENT_ID_VOLUME_CHANGED"
};
LOG_STRING char APP_AvrcpPassThroughRspIndLogString[] = "PassThrough Rsp Ind: %d";

LOG_STRING char APP_AvrcpIndHandleLogString[] = "app_AvrcpIndHandler id - %s,%d,";
LOG_STRING char APP_AvrcpIndID[][MAX_LOG_STRING] =
{
	//Initialization, Connection Confirm
	"AVRCP_START_SERVICE_CFM",
	"AVRCP_STOP_SERVICE_CFM",
	"AVRCP_CONNECT_CFM",
	"AVRCP_DISCONNECT_CFM",
	//Initialization, Connection Indication
	"AVRCP_CONNECT_IND",
	//Received Command Indication -- to MMI
	"AVRCP_GET_CMD_UNITINFO_IND",
	"AVRCP_GET_CMD_SUBUNITINFO_IND",
	"AVRCP_GET_CMD_GETCAPS_IND",
	"AVRCP_GET_CMD_GETELEMENTATTRIBUTES_IND",
	"AVRCP_GET_CMD_REGISTERNOTIFICATION_IND",
	//AVRCP_GET_CMD_REGISTERNOTIFICATION_VOL_IND,
	"AVRCP_GET_CMD_SETABSOLUTEVOL_IND",
	"AVRCP_GET_CMD_UNKNOWNVENDORDEPENDENT_IND",
	"AVRCP_GET_CMD_PASSTHROUGH_IND",
	"AVRCP_GET_CMD_PASSTHROUGH_VENDORUNIQUE_IND",
	//Response Information Indication
	"AVRCP_GET_APPLICATION_SETTING_IND",
	"AVRCP_GET_PLAY_STATUS_IND",
	"AVRCP_GET_REGISTER_NOTIFY_IND",
	"AVRCP_GET_PASS_THROUGH_IND",
	//Get Response Confirm -- to MMI
	//Send Command
	"AVRCP_INTERNAL_SEND_CMD_UNITINFO",
	"AVRCP_INTERNAL_SEND_CMD_SUBUNITINFO",
	"AVRCP_INTERNAL_SEND_CMD_GETCAPS",
	"AVRCP_INTERNAL_SEND_CMD_GETELEMENTATTRIBUTES",
	"AVRCP_INTERNAL_SEND_CMD_REGISTERNOTIFICATION",
	"AVRCP_INTERNAL_SEND_CMD_SETABSOLUTEVOL",
	"AVRCP_INTERNAL_SEND_CMD_PASSTHROUGH",
	"AVRCP_INTERNAL_SEND_CMD_CONTNUERESPONSE",
	"AVRCP_INTERNAL_SEND_CMD_VENDORUNIQUE",
	"AVRCP_INTERNAL_SEND_CMD_GETPLAYSTATUS",
	"AVRCP_INTERNAL_SEND_CMD_LISTAPPATTRIBUTE",
	"AVRCP_INTERNAL_SEND_CMD_LISTAPPVALUE",
	"AVRCP_INTERNAL_SEND_CMD_GETAPPVALUE",
	"AVRCP_INTERNAL_SEND_CMD_SETAPPVALUE",
	"AVRCP_INTERNAL_SEND_CMD_GETAPPATTRIBUTETEXT",
	"AVRCP_INTERNAL_SEND_CMD_GETAPPVALUETEXT",
	//Send Response
	"AVRCP_INTERNAL_SEND_RSP_UNITINFO",
	"AVRCP_INTERNAL_SEND_RSP_SUBUNITINFO",
	"AVRCP_INTERNAL_SEND_RSP_GETCAPS",
	"AVRCP_INTERNAL_SEND_RSP_GETELEMENTATTRIBUTES",
	"AVRCP_INTERNAL_SEND_RSP_REGISTERNOTIFICATION_VOL",
	"AVRCP_INTERNAL_SEND_RSP_SETABSOLUTEVOL",
	"AVRCP_INTERNAL_SEND_RSP_VENDORDEPENDENTREJECT",
	"AVRCP_INTERNAL_SEND_RSP_PASSTHROUGH",
	"AVRCP_INTERNAL_SEND_RSP_GETPLAYSTATUS",
	"AVRCP_INTERNAL_SEND_RSP_LISTAPPATTRIBUTE",
	"AVRCP_INTERNAL_SEND_RSP_LISTAPPVALUE",
	"AVRCP_INTERNAL_SEND_RSP_GETCURRENTAPPVALUE",
	"AVRCP_INTERNAL_SEND_RSP_SETAPPVALUE",
	"AVRCP_INTERNAL_SEND_RSP_GETAPPATTRIBUTETEXT",
	"AVRCP_INTERNAL_SEND_RSP_GETAPPVALUETEXT",
	//Changed Response
	"AVRCP_INTERNAL_SEND_RSP_PLAYBACKSTATUSCHANGED",
	"AVRCP_INTERNAL_SEND_RSP_TRACKCHANGED",
	"AVRCP_INTERNAL_SEND_RSP_TRACKREACHEDEND",
	"AVRCP_INTERNAL_SEND_RSP_TRACKREACHEDSTART",
	"AVRCP_INTERNAL_SEND_RSP_PLAYBACKPOSCHANGED",
	"AVRCP_INTERNAL_SEND_RSP_SYSTEMSTATUSCHANGED",
	"AVRCP_INTERNAL_SEND_RSP_PLAYSTATUSCHANGED",
	"AVRCP_INTERNAL_SEND_RSP_PLAYERAPPSETTINGCHANGED",
	"AVRCP_INTERNAL_SEND_RSP_VOLCHANGED"
};

LOG_STRING char APP_AvrcpTimerLogString[] = "AVRCP Time Out, id : %s, %d";
LOG_STRING char APP_AvrcpTimerID[][MAX_LOG_STRING] =
{
	"",
	"APP_AVRCP_TIMER_SEND_GET_PLAY_STATUS_TO_PAUSE_MUSIC",
	"APP_AVRCP_TIMER_SEND_PAUSE_MUSIC",
	"APP_AVRCP_TIMER_QUERY_CURRENT_PLAY_STATUS",
	"APP_AVRCP_TIMER_MONITOR_PLAY_STATUS",
	"APP_AVRCP_TIMER_BACKUP_AND_PUSH_PLAY_STATUS",
	"APP_AVRCP_TIMER_CHECK_STREAMING_STATE_LATER"
};

/*NvKey Handler*/
LOG_STRING char NvKeyHandler_SetStatus[] = "[NvKey] Set Status:%x,%d";
LOG_STRING char NvKeyHandler_RmvStatus[] = "[NvKey] Rmv Status:%x,%d";

/*USB*/
LOG_STRING char USB_EmmcInitFailLogString[] = "[USB_DBG] eMMC Init Fail";
LOG_STRING char USB_EmmcInitPassLogString[] = "[USB_DBG] eMMC Init Pass";
LOG_STRING char USB_SdcInitFailLogString[] = "[USB_DBG] SDC Init Fail";
LOG_STRING char USB_SdcInitPassLogString[] = "[USB_DBG] SDC Init Pass";
LOG_STRING char USB_MassStorageInitFailLogString[] = "[USB_DBG] Mass Storage Init Fail";

/* BT LIB String */

/* L2cap */
LOG_STRING char L2CAP_TimeOutHandlerString[] = "[  L2CAP] L2capHandler Timeout handler cid:%x state:%x";
LOG_STRING char L2CAP_HandleConReqString[] = "[  L2CAP] Rx CONNECTION_REQUEST cid:%x PSM:%x";
LOG_STRING char L2CAP_L2CAP_Sig_Send_RejString[] = "[  L2CAP] Tx REJ_RESPONSE";
LOG_STRING char L2CAP_SendAclDisconnIndString[] = "[  L2CAP] Disconnect!! cid %x state %x";
LOG_STRING char L2CAP_Host_IpcMsgDispatchString[] = "[  L2CAP] Drop IPC pkt!!(No This Type)";
LOG_STRING char L2CAP_Sig_Send_ConReqString[] = "[  L2CAP] Tx CONNECTION_REQUEST MyCid:%x PSM:%x";
LOG_STRING char L2CAP_Sig_Send_ConRspString[] = "[  L2CAP] Tx CONNECTION_RESPONSE:%x MyCid:%x TheirCid:%x";
LOG_STRING char L2CAP_Sig_Send_ConfigReqString[] = "[  L2CAP] Tx CONFIG_REQUEST TheirCid:%x";
LOG_STRING char L2CAP_Sig_Send_ConfigRspString[] = "[  L2CAP] Tx CONFIG_RESPONSE MyCid:%x TheirCid:%x";
LOG_STRING char L2CAP_Sig_Send_InfoRspString[] = "[  L2CAP] Tx INFORMATION_RESPONSE";
LOG_STRING char L2CAP_Sig_Send_DisconnReqString[] = "[  L2CAP] Tx DISCONNECT_REQUEST MyCid:%x TheirCid:%x";
LOG_STRING char L2CAP_Sig_Send_DisconRspString[] = "[  L2CAP] Tx DISCONNECT_RESPONSE MyCid:%x TheirCid:%x";
LOG_STRING char L2CAP_Sig_Send_EchoReqString[] = "[  L2CAP] Tx ECHO_REQUEST";
LOG_STRING char L2CAP_Sig_Send_EchoRspString[] = "[  L2CAP] Tx ECHO_RESPONSE";
LOG_STRING char L2CAP_Sig_Send_InfoReqString[] = "[  L2CAP] Tx INFO_REQUEST";
LOG_STRING char L2CAP_Sig_Send_ConnUpdateReqString[] = "[  L2CAP] Tx CONN_UPDATE_REQUEST";
LOG_STRING char L2CAP_Sig_Send_ConnUpdateRspString[] = "[  L2CAP] Tx CONN_UPDATE_RESPONSE";
LOG_STRING char L2CAP_Sig_Handle_ConReq1String[] = "[  L2CAP] BT_L2CAP_CONNECT_IND bda:%x %x";
LOG_STRING char L2CAP_Sig_Handle_ConRspString[] = "[  L2CAP] Rx CONNECTION_RESPONSE MyCid:%x TheirCid:%x PSM:%x";
LOG_STRING char L2CAP_Sig_Handle_ConRsp1String[] = "[  L2CAP] BT_L2CAP_CONNECT_CFM BT_STATUS_GENERIC_FAIL";
LOG_STRING char L2CAP_Sig_Handle_ConfigReqString[] = "[  L2CAP] Rx CONFIG_REQUEST MyCid:%x";
LOG_STRING char L2CAP_Sig_Handle_DisconReqString[] = "[  L2CAP] Rx DISCONNECTION_REQUEST DCID: %x state:%x";
LOG_STRING char L2CAP_CheckStateString[] = "[  L2CAP] CheckState cid = %x state %x";
LOG_STRING char L2CAP_CheckState1String[] = "[  L2CAP] Set Sink, cid: %x, sink:%x";
LOG_STRING char L2CAP_CheckState2String[]= "[  L2CAP] L2cap More data reorder";
LOG_STRING char L2CAP_CheckState3String[]= "[  L2CAP] Warning!! Source Sink miss match";
LOG_STRING char L2CAP_SignalingString[] = "[  L2CAP] Source:%x L2SigSize:%d L2SigMap:%x";
LOG_STRING char L2CAP_Sig_Handle_ConfigRspString[] = "[  L2CAP] Rx CONFIG_RESPONSE MyCid:%x";
LOG_STRING char L2CAP_Sig_Handle_DisconRspString[] = "[  L2CAP] Rx DISCONNECTION_RESPONSE Mycid:%x";
LOG_STRING char L2CAP_Sig_Handle_InfoReqString[] = "[  L2CAP] Rx INFORMATION_REQUEST type:%x";
LOG_STRING char L2CAP_Sig_Handle_InfoRspString[] = "[  L2CAP] Rx INFORMATION_RESPONSE";
LOG_STRING char L2CAP_Sig_Handle_EchoReqString[] = "[  L2CAP] Rx ECHO_REQUEST";
LOG_STRING char L2CAP_Sig_Handle_EchoRspString[] = "[  L2CAP] Rx ECHO_RESPONSE";
LOG_STRING char L2CAP_Sig_Handle_ConnUpdateReqString[] = "[  L2CAP] Rx CONNECTION_PARAMETER_UPDATE_REQUEST";
LOG_STRING char L2CAP_Sig_Handle_ConnUpdateRspString[] = "[  L2CAP] Rx CONNECTION_PARAMETER_UPDATE_RESPONSE";
LOG_STRING char SinkCloseL2capString[] = "[  L2CAP] Close L2cap sink:%x call:%x";
LOG_STRING char SourceCloseL2capString[] = "[  L2CAP] Close L2cap source:%x call:%x";
LOG_STRING char SinkClaimL2capString[] = "[  L2CAP] Claim L2cap Fail sink:%x len:%d";
LOG_STRING char SinkClaimL2cap1String[] = "[  L2CAP] Claim L2cap Fail No Memory";
LOG_STRING char SourceL2capSDUDispatchString[] = "[  L2CAP] Drop L2 pkt cid:%d !!(No Source Found)";
LOG_STRING char SourceL2capFeedString[] = "[  L2CAP] Drop L2 pkt!! cid:%d (Length overflow)";
LOG_STRING char SourceL2capFeed1String[] = "[  L2CAP] Drop L2 pkt!!(No start before Conti)";
LOG_STRING char SourceL2capFeed2String[] = "[  L2CAP] Drop L2 pkt!!(Hci len %d > l2 len %d)";
LOG_STRING char StreamL2capSourceNewString[] = "[  L2CAP] L2capSourceNew source:%x cid:%x handle:%d call:%x";
LOG_STRING char StreamL2capSinkNewString[] = "[  L2CAP] L2capSinkNew sink:%x cid:%x handle:%d call:%x";
LOG_STRING char BT_INTERNAL_L2CAP_CONNECT_REQString[] = "[  L2CAP] l2cap null app!";
LOG_STRING char BT_INTERNAL_L2CAP_CONNECT_REQ1String[] = "[  L2CAP] l2cap null cid!!";
LOG_STRING char BT_INTERNAL_L2CAP_CONNECT_REQ2String[] = "[  L2CAP] l2cap connect req not null appHandler!";
LOG_STRING char BT_INTERNAL_L2CAP_CONNECT_REQ3String[] = "[  L2CAP] Connection Req cid:%x bda:%x %x";
LOG_STRING char L2CAP_ApplyAgentRhoData_String[] = "[  L2CAP] ApplyAgentRhoData before link:%d BdAddr:0x%x%x";
LOG_STRING char L2CAP_ApplyAgentRhoData2_String[] = "[  L2CAP] ApplyAgentRhoData rhoBdA BdAddr:0x%x%x";
LOG_STRING char L2CAP_GetRhoData_String[] = "[  L2CAP] GetRhoData idx:%d BdAddr:0x%x%x";

/* Sdp */
LOG_STRING char BtSdpOpenSearchRequestString[] = "[    SDP] BtSdpOpenSearchRequest bda: %x %x";
LOG_STRING char BtSdpCloseSearchRequestString[] = "[    SDP] BtSdpCloseSearchRequest bda: %x %x";
LOG_STRING char SdpClient_ResetChannelString[] = "[    SDP] Sdp clinet Reset channel bda: %x %x";
LOG_STRING char SdpClient_SendServiceSearchReqString[] = "[    SDP] Client Tx SERVICE_SEARCH_REQ";
LOG_STRING char SdpClient_SendServiceAttributeReqString[] = "[    SDP] Client Tx SERVICE_ATTRIBUTE_REQ";
LOG_STRING char SdpClient_SendServiceSearchAttributeReqString[] = "[    SDP] Client Tx SERVICE_SEARCH_ATTRIBUTE_REQ";
LOG_STRING char SdpClient_HandleErrorRspString[] = "[    SDP] Client Rx SDP_ERROR_RESPONSE";
LOG_STRING char SdpClient_HandleServiceSearchRspString[] = "[    SDP] Client Rx SDP_SERVICE_SEARCH_RESPONSE idx:%d";
LOG_STRING char SdpClient_HandleServiceAttributeRspString[] = "[    SDP] Client Rx SDP_SERVICE_ATTRIBUTE_RESPONSE idx:%d";
LOG_STRING char SdpClient_HandleServiceSearchAttributeRspString[] = "[    SDP] Client Rx SDP_SERVICE_SEARCH_ATTRIBUTE_RESPONSE idx:%d";
LOG_STRING char SdpClient_HandleL2cConnectCfmString[] = "[    SDP] Client BT_L2CAP_CONNECT_CFM bda: %x %x";
LOG_STRING char SdpClient_HandleL2cDisconnectIndString[] = "[    SDP] Client BT_L2CAP_DISCONNECT_IND sink: %x";
LOG_STRING char SdpClient_HandleL2cDisconnectCfmString[] = "[    SDP] Client BT_L2CAP_DISCONNECT_CFM sink:%x";
LOG_STRING char SDP_Client_L2capConnReqString[] = "[    SDP] Client L2cap connect req bda: %x %x";
LOG_STRING char SDP_Client_L2capConnReq0String[] = "[    SDP] Fail: Channel exist!!";
LOG_STRING char SDP_Client_L2capConnReq1String[] = "[    SDP] Fail: Channel conneting!!";
LOG_STRING char SDP_Client_L2capConnReq2String[] = "[    SDP] Fail: No Malloc resource!!";
LOG_STRING char SDP_Client_L2capConnReq3String[] = "[    SDP] Fail: No empty channel!!";
LOG_STRING char SDP_Client_L2capDisconnReqString[] = "[    SDP] Client L2cap disc req bda: %x %x";
LOG_STRING char SDP_Client_L2capDisconnReq1String[] = "[    SDP] Fail: No Link!!";
LOG_STRING char SDP_Client_L2capDisconnReq2String[] = "[    SDP] Fail: No Channel!!";
LOG_STRING char SDP_Client_L2capDisconnReq3String[] = "[    SDP] Fail: Error state!!";
LOG_STRING char SDP_Client_L2capDisconnReq4String[] = "[    SDP] Fail: req state ongoing!!";
LOG_STRING char SDP_Client_L2capDisconnReq5String[] = "[    SDP] Fail: keep current req information!!";
LOG_STRING char SDP_Client_ServiceSearchString[] = "[    SDP] Client ServiceSearch bda: %x %x";
LOG_STRING char SDP_Client_AttributeSearchString[] = "[    SDP] Client AttributeSearch bda: %x %x";
LOG_STRING char SDP_Client_ServiceSearchAttributeString[] = "[    SDP] Client ServiceSearchAttribute bda: %x %x";
LOG_STRING char SdpServer_SendErrorResponseString[] = "[    SDP] Tx Send Error Response";
LOG_STRING char SdpServer_HandleServiceSearchReqString[] = "[    SDP] Rx SERVICE_SEARCH_REQ";
LOG_STRING char SdpServer_HandleServiceSearchReq1String[] = "[    SDP] Tx Send Serviceh Search Response";
LOG_STRING char SdpServer_HandleServiceAttributeReqString[] = "[    SDP] Rx SERVICE_ATTRIBUTE_REQ idx:%d";
LOG_STRING char SdpServer_HandleServiceAttributeReq1String[] = "[    SDP] Tx Send Service Attribute Response";
LOG_STRING char SdpServer_HandleServiceSearchAttributeReqString[] = "[    SDP] Rx SERVICE_SEARCH_ATTRIBUTE_REQ idx:%d";
LOG_STRING char SdpServer_HandleServiceSearchAttributeReq1String[] = "[    SDP] Tx Send Service Search Attribute Response";
LOG_STRING char SdpServer_HandleL2cConnectIndString[] = "[    SDP] Server BT_L2CAP_CONNECT_IND bda: %x %x reply:%d";
LOG_STRING char SdpServer_HandleL2cConnectCfmString[] = "[    SDP] Server BT_L2CAP_CONNECT_CFM sink:%x bda: %x %x";
LOG_STRING char SdpServer_HandleL2cDisconnectIndString[] = "[    SDP] Server BT_L2CAP_DISCONNECT_IND sink %x";
LOG_STRING char SdpServer_HandleL2cDisconnectCfmString[] = "[    SDP] Server BT_L2CAP_DISCONNECT_CFM sink: %x";
LOG_STRING char SdpServer_HandleL2cRegisterCfmString[] = "[    SDP] Server BT_L2CAP_REGISTER_CFM";
LOG_STRING char SdpServer_HandleL2cUnregisterCfmString[] = "[    SDP] Server BT_L2CAP_UNREGISTER_CFM";


/* Gap */
LOG_STRING char BtUtilGetTicketString[] = "[    GAP] Current Ticket:%x My:%x";
LOG_STRING char Gap_Link_SetAttr_SniffLockString[] = "[    GAP] Sniff Lock idx:%d val:%d";
LOG_STRING char Gap_Link_SetAttr_DetachingString[] = "[    GAP] Detaching idx:%d val:%d";
LOG_STRING char Gap_Link_GetAttr_DetachingString[] = "[    GAP] Get Detaching idx:%d val:%d";
LOG_STRING char Gap_Link_SetAttr_ClearString[] = "[    GAP] Link clear call:%x idx:%d";
LOG_STRING char BT_INTERNAL_HCI_MODE_CHANGE_INDString[] = "[    GAP] MODE_CHANGE_IND ModeLock %x";
LOG_STRING char BT_INTERNAL_HCI_QOS_SETUP_COMPLETE_INDString[] = "[    GAP] QOS_SETUP_COMPLETE_IND %d";
LOG_STRING char BT_INTERNAL_HCI_CMD_SEND_CFMString[] = "[    GAP] Link Mode  Release Lock %d";
LOG_STRING char BT_INTERNAL_HCI_CMD_SEND_CFM1String[] = "[    GAP] Qos setup status %d";
LOG_STRING char BT_INTERNAL_SET_LINK_MODE_REQString[] = "[    GAP] Link Mode Current:%d Req:%d";
LOG_STRING char BT_INTERNAL_QOS_SETUP_REQString[] = "[    GAP] Qos SetUp Request handle:%x";
LOG_STRING char BT_INTERNAL_HCI_CMD_SEND_CFMLinkString[] = "[    GAP] Passive Connected";
LOG_STRING char BT_INTERNAL_HCI_CMD_SEND_CFMLink1String[] = "[    GAP] Passive Wait Complete";
LOG_STRING char BT_INTERNAL_GAP_PAGING_REQString[] = "[    GAP] GAP_PAGING Direct Pass cid:%x";
LOG_STRING char BT_INTERNAL_HCI_LINK_KEY_REQUEST_INDString[] = "[    GAP] LINK_KEY_REQUEST_NEGATIVE_REPLY";
LOG_STRING char GAP_detach_LinkString[] =  "[    GAP] detach 4.0 idx:%d";
LOG_STRING char GAP_detach_Link1String[] = "[    GAP] detach 3.0 idx:%d";
LOG_STRING char Security_DB_DeleteAllLinkKeyString[] = "[    GAP] DeleteAllLinkKey keyid:%x status:%x";
LOG_STRING char Security_DB_DeleteLinkKeyString[]= "[    GAP] DeleteLinkKey keyid:%x status:%x";
LOG_STRING char Security_DB_WriteLinkKeyString[] = "[    GAP] WriteLinkKey keyid:%x status:%x isEdr:%d";
LOG_STRING char BT_INTERNAL_HCI_CONNECT_COMPLETE_INDString[] = "[    GAP] Connection complete ind event!!";
LOG_STRING char BT_INTERNAL_HCI_CONNECT_COMPLETE_IND1String[] = "[    GAP] connect state:%d acllock:%x";
LOG_STRING char BT_INTERNAL_HCI_CONNECT_COMPLETE_IND2String[] = "[    GAP] Passive Trigger idx:%d";
LOG_STRING char Gap_Link_SetAttr_StateString[] = "[    GAP] GAP set link state:%x idx:%d call:%x";
LOG_STRING char Gap_ApplyAgentRhoData_String[] = "[    GAP] ApplyAgentRhoData aws_link:%x BdAddr:0x%x%x";
LOG_STRING char Gap_GetIdxByConnHdl_String[] = "[    GAP] linkIndex:%d connHandle:0x%x state:%d BdAddr:0x%x%x";
LOG_STRING char Gap_RhoNotAllow1_String[] = "HCI_GetStatus TX busy numAcl:%d initAcl:%d numQ:%d";
LOG_STRING char Gap_RhoNotAllow2_String[] = "HCI_GetStatus RX busy numQ:%d";
LOG_STRING char Gap_RhoNotAllow3_String[] = "HCI_GetStatus OTHER busy numQ:%d";


/* Rfcomm */
LOG_STRING char BtRfcommRegisterChannelString[] = "[ RFCOMM] Register CHL:%d framesize:%d";
LOG_STRING char BtRfcommUnregisterChannelString[] = "[ RFCOMM] UnRegister CHL:%d";
LOG_STRING char BtRfcommConnectRequestString[] = "[ RFCOMM] CONNECT_RQS:%d Bda:%x %x";
LOG_STRING char BtRfcommConnectResponseString[] = "[ RFCOMM] CONNECT_RSP:%d,%d Bda:%x %x";
LOG_STRING char BtRfcommRemoteLineStatueRequestString[] = "[ RFCOMM] RMT Line Status Rqs:%d";
LOG_STRING char BtRfcommDisconnectRequestString[] = "[ RFCOMM] Disc Rqs sink:%x";
LOG_STRING char BtRfcommDisconnectResponseString[] = "[ RFCOMM] Disc Rsp sink:%x";
LOG_STRING char BT_INTERNAL_RFCOMM_CONNECT_REQString[] = "[ RFCOMM] BT_RFCOMM_CLIENT_CONNECT_CFM status %d";
LOG_STRING char RfcommSessionClearString[] = "[ RFCOMM] RfcommSessionClear seidex:%d set idle call:%x";
LOG_STRING char RfcommSessionSetStateString[] = "[ RFCOMM] session %d (%s) (lock = %x) call:%x";
LOG_STRING char RfcommDlciSetStateString[] = "[ RFCOMM] dlci %d (%s) (lock = %x) call:%x";
LOG_STRING char RfcommUtil_TimerSetString[] = "[ RFCOMM] TimerSet t:%d seidx:%d dlci:%d call:%x";
LOG_STRING char RfcommUtil_TimerReleaseString[] = "[ RFCOMM] TimerRel seidx:%d dlci:%d call:%x";
LOG_STRING char RfcommUtil_SendServerCfmString[] = "[ RFCOMM] RfcommUtil_SendServerCfm seidx %d bd:%x %x";
LOG_STRING char RfcommUtil_ClearAllSessionDataString[] = "[ RFCOMM] clear all session seidx:%d call:%x";
LOG_STRING char RfcommHandlerString[] = "[ RFCOMM] BT_L2CAP_DISCONNECT_CFM";
LOG_STRING char RfcommHandler1String[] = "[ RFCOMM] BT_L2CAP_DISCONNECT_IND seidx:%d";
LOG_STRING char RfcommHandler2String[] = "[ RFCOMM] BT_L2CAP_CONNECT_IND seidx:%d bda:%x %x rsp:%d";
LOG_STRING char RfcommHandler3String[] = "[ RFCOMM] BT_L2CAP_CONNECT_CFM bda:%x %x";
LOG_STRING char RfcommHandler4String[] = "[ RFCOMM] BT_L2CAP_CONNECT_CFM seidx:%d";
LOG_STRING char RfcommFrame_HandleRemoteUIH_Dlci0String[] = "[ RFCOMM] CTRL_MSG_TYPE_PN seidx:%d";
LOG_STRING char RfcommFrame_HandleRemoteUIH_Dlci01String[] = "[ RFCOMM] CTRL_MSG_TYPE_MSC seidx:%d";
LOG_STRING char RfcommFrame_HandleRemoteUIH_Dlci02String[] = "[ RFCOMM] CTRL_MSG_TYPE_RPN seidx:%d";
LOG_STRING char RfcommFrame_HandleRemoteUIH_Dlci03String[] = "[ RFCOMM] CTRL_MSG_TYPE_RLS seidx:%d";
LOG_STRING char RfcommFrame_HandleRemoteDMString[] = "[ RFCOMM] seidx:%d state %d";
LOG_STRING char RfcommFrame_HandleRemoteDM1String[] = "[ RFCOMM] DM RFCOMM_SESSION_CONNECTING";
LOG_STRING char RfcommFrame_HandleRemoteDM2String[] = "[ RFCOMM] DM DLC_PN_SENT_WAIT_RSP,DLC_SABM_SENT_WAIT_UA";
LOG_STRING char RfcommFrame_HandleMoreDataString[] = "[ RFCOMM] CTRL_FIELD_SABM seidx:%d";
LOG_STRING char RfcommFrame_HandleMoreData1String[] = "[ RFCOMM] CTRL_FIELD_UA seidx:%d";
LOG_STRING char RfcommFrame_HandleMoreData2String[] = "[ RFCOMM] CTRL_FIELD_DM seidx:%d";
LOG_STRING char RfcommFrame_HandleMoreData3String[] = "[ RFCOMM] CTRL_FIELD_DISC seidx:%d";
LOG_STRING char RfcommFrame_HandleMoreData4String[] = "[ RFCOMM] session not found sink = %x";
LOG_STRING char RrcommMuxCtl_HandlePNString[] = "[ RFCOMM] Credit Init:%d";
LOG_STRING char RrcommMuxCtl_HandleMSCString[] = "[ RFCOMM] RrcommMuxCtl_HandleMSC seidx:%x";
LOG_STRING char RrcommMuxCtl_SendPNString[] = "[ RFCOMM] RrcommMuxCtl_SendPN seidx:%d";
LOG_STRING char RfcommOp_OpenChannel_1_ProcessL2CAPString[] = "[ RFCOMM] RfcommOp_OpenChannel_1_ProcessL2CAP";
LOG_STRING char RfcommOp_OpenChannel_1_ProcessL2CAP1String[] = "[ RFCOMM] state = %s";
LOG_STRING char RfcommOp_OpenChannel_2_ProcessDLCI0String[] = "[ RFCOMM] RfcommOp_OpenChannel_2_ProcessDLCI0 seidx:%d";
LOG_STRING char RfcommOp_OpenChannel_2_ProcessDLCI01String[] = "[ RFCOMM] RFCOMM_SESSION_CONNECTING_FAIL";
LOG_STRING char RfcommOp_OpenChannel_3_ProcessDLCIString[] = "[ RFCOMM] RfcommOp_OpenChannel_3_ProcessDLCI seidx%d";
LOG_STRING char RfcommOp_OpenChannel_3_ProcessDLCI1String[] = "[ RFCOMM] DLC_ESTABLISHING_FAIL REJECT_BY_REMOTE";
LOG_STRING char RfcommOp_OpenChannel_3_ProcessDLCI2String[] = "[ RFCOMM] DLC_ESTABLISHING_TIMEOUT";
LOG_STRING char RfcommOp_OpenChannel_3_ProcessDLCI3String[] = "[ RFCOMM] DLC_READY_FOR_DATA_COM (BT_STATUS_NO_RESOURCE)";
LOG_STRING char RfcommOp_OpenChannel_3_ProcessDLCI4String[] = "[ RFCOMM] BT_STATUS_ALREADY_EXISTED";
LOG_STRING char RfcommOp_OpenChannel_3_ProcessDLCI5String[] = "[ RFCOMM] Lock for no ACL";
LOG_STRING char RfcommOp_GrantOpenChannelString[] = "[ RFCOMM] GrantOpenChannel rsp:%d seidx:%d";
LOG_STRING char RfcommOp_GrantOpenChannel1String[] = "[ RFCOMM] GrantOpenChannel Not found";
LOG_STRING char StreamRfcommDlciCloseString[] = "[ RFCOMM] StreamRfcommDlciClose seidx:%d dlci:%d call:%x";
LOG_STRING char StreamRfcommSessionCloseString[] = "[ RFCOMM] StreamRfcommSessionClose seidx:%d call:%x";
LOG_STRING char StreamRfcommSinkNewString[] = "[ RFCOMM] SinkNew sink:%x seidx:%d dlci:%d call:%x";
LOG_STRING char StreamRfcommSourceNewString[] = "[ RFCOMM] SourceNew source:%x seidx:%d dlci:%d call:%x";
LOG_STRING char SinkRfcommSetupString[] = "[ RFCOMM] Sink Setup sink:%x isFC:%d Txcredit:%d handler:%x";
LOG_STRING char SourceRfcommSetupString[] = "[ RFCOMM] Source Setup source:%x isFC:%d Rxcredit:%d handler:%x";
LOG_STRING char RfcommSessionSetTxCreditString[] = "[ RFCOMM] SetTxCredit seidx:%d Txcredit:%d";

/* AirUpdate Dongle */
LOG_STRING char L2capAirohaAirUpdateHandlerString[] = "[AirUpdate] Payload %x %x %x %x";
LOG_STRING char L2CAP_AirUpdateCloseStreamHandlerString[]="[AirUpdate] AirUpdateCloseStreamHandler";

LOG_STRING char DebugRawDataPrintString[] = "[RawPrint][ID:%d] Print %d Bytes";
LOG_STRING char DebugRawDataPrint1String[] ="[RawPrint] Data %d: %x %x %x %x";


/* FOTA race cmd*/
LOG_STRING char RACE_CmdHandler_FOTA_commitString[] = "[FOTA] Write NVkey error code:%d";
LOG_STRING char RACE_CmdHandler_FOTA_commit1String[] = "[FOTA] Reset direct handler";
LOG_STRING char FotaResetHandlerString[] = "[FOTA] Reset direct handler";
LOG_STRING char RACE_CmdHandler_FOTA_QueryStateString[] = "[FOTA] Query state:%x";
LOG_STRING char writeFotaStateString[] = "[FOTA] Write state:%x";



/*AVCTP*/
LOG_STRING char AVCTP_INTERNAL_REG_REQ_STR1[] = "[  AVCTP] Req Register L2CAP, App:%x";
LOG_STRING char AVCTP_INTERNAL_REG_REQ_STR2[] = "[  AVCTP] Req Register L2CAP : Already Registered L2cap";
LOG_STRING char AVCTP_INTERNAL_REG_REQ_STR3[] = "[  AVCTP] Req Register L2CAP : Fail";

LOG_STRING char AVCTP_INTERNAL_UNREG_REQ_STR1[] = "[  AVCTP] Req UnRegister L2CAP";
LOG_STRING char AVCTP_INTERNAL_UNREG_REQ_STR2[] = "[  AVCTP] Req UnRegister L2CAP : Fail";

LOG_STRING char AVCTP_INTERNAL_CONN_REQ_STR1[] = "[  AVCTP] Not Register";
LOG_STRING char AVCTP_INTERNAL_CONN_REQ_STR2[] = "[  AVCTP] Send Connection Request App:%x, BdAddr:0x%x%x";
LOG_STRING char AVCTP_INTERNAL_CONN_REQ_STR3[] = "[  AVCTP] No Resource for New Link";

LOG_STRING char AVCTP_INTERNAL_CONN_RSP_STR1[] = "[  AVCTP] Accept Connection";
LOG_STRING char AVCTP_INTERNAL_CONN_RSP_STR2[] = "[  AVCTP] Reject Connection";
LOG_STRING char AVCTP_INTERNAL_CONN_RSP_STR3[] = "[  AVCTP] Wrong BdAddr";

LOG_STRING char AVCTP_INTERNAL_DISCONN_REQ_STR1[] = "[  AVCTP] Not Yet Registered";
LOG_STRING char AVCTP_INTERNAL_DISCONN_REQ_STR2[] = "[  AVCTP] Send Disconnection Request";
LOG_STRING char AVCTP_INTERNAL_DISCONN_REQ_STR3[] = "[  AVCTP] Disconnect Later";
LOG_STRING char AVCTP_INTERNAL_DISCONN_REQ_STR4[] = "[  AVCTP] Has Disconnected";
LOG_STRING char AVCTP_INTERNAL_DISCONN_REQ_STR5[] = "[  AVCTP] No This Link";

LOG_STRING char AVCTP_L2CAP_REG_CFM_STR1[] = "[  AVCTP] L2cap Register Cfm: %x";
LOG_STRING char AVCTP_L2CAP_REG_CFM_STR2[] = "[  AVCTP] L2cap Has Not Registered";

LOG_STRING char AVCTP_L2CAP_UNREG_CFM_STR[] = "[  AVCTP] L2cap Unregister Cfm: %x";

LOG_STRING char AVCTP_L2CAP_CONN_CFM_STR1[] = "[  AVCTP] L2cap Connect Cfm:%d CID:%d MTU:%d, Bdaddr:0x%x%x";
LOG_STRING char AVCTP_L2CAP_CONN_CFM_STR2[] = "[  AVCTP] No This link";

LOG_STRING char AVCTP_L2CAP_CONN_IND_STR1[] = "[  AVCTP] AVCTP L2cap Connect Ind Id:%d CID:%X, BdAddr:0x%x%x";
LOG_STRING char AVCTP_L2CAP_CONN_IND_STR2[] = "[  AVCTP] No Resource for New Link";

LOG_STRING char AVCTP_L2CAP_DISCONN_CFM_STR1[] = "[  AVCTP] Disconnect Cfm:%d";
LOG_STRING char AVCTP_L2CAP_DISCONN_CFM_STR2[] = "[  AVCTP] Disconnect link bdaddress:0x%x%x";
LOG_STRING char AVCTP_L2CAP_DISCONN_CFM_STR3[] = "[  AVCTP] No This Link";

LOG_STRING char AVCTP_L2CAP_DISCONN_IND_STR1[] = "[  AVCTP] L2cap Disconnect Ind:%d";

LOG_STRING char AVCTP_DATA_SINK_CLAIM_STR1[] = "[  AVCTP] SinkClaim: Too Big";
LOG_STRING char AVCTP_DATA_SINK_CLAIM_STR2[] = "[  AVCTP] SinkClaim: Invalid";
LOG_STRING char AVCTP_DATA_SINK_CLAIM_STR3[] = "[  AVCTP] Claim Size False";

LOG_STRING char AVCTP_DATA_SEND_SINGLE_PKT_STR[] = "[  AVCTP] Send Single Pkt Data";

LOG_STRING char AVCTP_DATA_RECEIVE_SINGLE_PKT_STR[] = "[  AVCTP] Rx Single Pkt PID:%x/%x";

LOG_STRING char AVCTP_DATA_HANDLER_STR1[] = "[  AVCTP] Rx More Data";
LOG_STRING char AVCTP_DATA_HANDLER_STR2[] = "[  AVCTP] No This Link";
LOG_STRING char AVCTP_DATA_HANDLER_STR3[] = "[  AVCTP] Not Connected";
LOG_STRING char AVCTP_DATA_HANDLER_STR4[] = "[  AVCTP] No Data or Length of Zero";
LOG_STRING char AVCTP_DATA_HANDLER_STR5[] = "[  AVCTP] pLinkInfo:%x pPkt:%x PktLen:%d";

/* AVDTP */
LOG_STRING char AVDTP_REQ_String[] = "[  AVDTP] Tx Req - %s. BdAddr:0x%x%x";
LOG_STRING char AVDTP_IND_String[] = "[  AVDTP] Rx Ind - %s. BdAddr:0x%x%x";
LOG_STRING char AVDTP_CFM_String[] = "[  AVDTP] Rx Cfm - %s: %d. BdAddr:0x%x%x";

LOG_STRING char AVDTP_ConIndNone_String[] = "[  AVDTP] avdtp_L2capConInd:None";
LOG_STRING char AVDTP_ConIndMedia_String[] = "[  AVDTP] avdtp_L2capConInd:Media";
LOG_STRING char AVDTP_ConIndReject_String[] = "[  AVDTP] avdtp_L2capConInd:Reject";


LOG_STRING char AVDTP_SendIND_String[] = "[  AVDTP] Tx Ind - %s. BdAddr:0x%x%x";
LOG_STRING char AVDTP_SendCFM_String[] = "[  AVDTP] Tx Cfm - %s: %d. BdAddr:0x%x%x";
LOG_STRING char A2DPStreamSBCNoPacket[] = "[Stream] SBC No Packet";
LOG_STRING char A2DPStreamAACNoPacket[] = "[Stream] AAC No Packet";

LOG_STRING char AVDTP_Tx_CMD_String[] = "[  AVDTP] Tx Pdu Cmd - %s. BdAddr:0x%x%x";
LOG_STRING char AVDTP_Tx_RSP_Accept_String[] = "[  AVDTP] Tx Pdu Rsp Accept - %s. BdAddr:0x%x%x";
LOG_STRING char AVDTP_Tx_RSP_Reject_String[] = "[  AVDTP] Tx Pdu Rsp Reject - %s. BdAddr:0x%x%x";

LOG_STRING char AVDTP_Rx_CMD_String[] = "[  AVDTP] Rx Pdu Cmd - %s, SigID:0x%x. BdAddr:0x%x%x";
LOG_STRING char AVDTP_Rx_RSP_Accept_String[] = "[  AVDTP] Rx Pdu Rsp Accept - %s. BdAddr:0x%x%x";
LOG_STRING char AVDTP_Rx_RSP_Reject_String[] = "[  AVDTP] Rx Pdu Rsp Reject - %s. BdAddr:0x%x%x";


LOG_STRING char AVDTP_REG_REQ_STR1[] = "[  AVDTP] Already Registered";
LOG_STRING char AVDTP_REG_REQ_STR2[] = "[  AVDTP] Register Failed";
LOG_STRING char AVDTP_UNREG_REQ_STR[] = "[  AVDTP] UnRegister L2CAP Fail";
LOG_STRING char AVDTP_MEDIA_CONN_REQ_STR[] = "[  AVDTP] Media Not Allow Connect Req";
LOG_STRING char AVDTP_MEDIA_DISCONN_REQ_STR[] = "[  AVDTP] Media Disconnect Req, Link state: %d";
LOG_STRING char AVDTP_MEDIA_CONN_CFM_STR[] = "[  AVDTP] MediaConnCfmHandler : No link";

LOG_STRING char AVDTP_MEDIA_NO_SOURCE_STR[] = "[  AVDTP] Media No Source";
LOG_STRING char AVDTP_MEDIA_NO_LINK_STR[] = "[  AVDTP] Media Cannot Find Link";
LOG_STRING char AVDTP_MEDIA_IS_MEDIA_PLAY_STR[] = "[  AVDTP] isMediaPlay:%d Qnum:%d BdAddr:0x%x%x";

LOG_STRING char AVDTP_REG_CFM_STR[] = "[  AVDTP] L2CAP Is Not Registered";
LOG_STRING char AVDTP_SIGNAL_CONN_CFM_STR1[] = "[  AVDTP] Signal Channel Disconnecting";
LOG_STRING char AVDTP_SIGNAL_CONN_CFM_STR2[] = "[  AVDTP] Signal Connection Cfm Handler No link";

LOG_STRING char AVDTP_SEND_FAIL_STR[] = "[  AVDTP] Send Failed";

LOG_STRING char AVDTP_ACCEPT_RSP_HEADER_STR[] = "[  AVDTP] Tx Pdu Rsp Accept MsgType:%d PktType:%d TransLabel:%d";
LOG_STRING char AVDTP_ACCEPT_REJ_HEADER_STR[] = "[  AVDTP] Tx Pdu Rsp Reject MsgType:%d PktType:%d TransLabel:%d";
LOG_STRING char AVDTP_RSP_ACCEPT_STR[] = "[  AVDTP] Rsp SigId:%d SigSourceSize:%d";
LOG_STRING char AVDTP_CMD_STR[] = "[  AVDTP] Cmd SigId:%d SigSourceSize:%d";

LOG_STRING char AVDTP_NO_SOURCE_STR[] = "[  AVDTP] No Source";
LOG_STRING char AVDTP_NO_PDU_STR[] = "[  AVDTP] No Pdu";
LOG_STRING char AVDTP_NO_LINK_INFO_STR[] = "[  AVDTP] Null pLinkInfo";
LOG_STRING char AVDTP_PDU_INFO_STR[] = "[  AVDTP] Rx Pdu TransLabel:%d SigId:%d MsgType:%d";

/*	AVRCP	*/
LOG_STRING char Avrcp_Opcode_String[][MAX_LOG_STRING] =
{
	"AVC_OPCODE_VENDOR_DEPENDENT",
	"AVC_OPCODE_UNIT_INFO",
	"AVC_OPCODE_SUBUNIT_INFO",
	"AVC_OPCODE_PASS_THROUGH",
	"AVC_UNKNOWN_OPCODE",
};

LOG_STRING char AVRCP_DATA_HANDLER_STR1[] = "[  AVRCP] More Data - No Data or Length of Zero!!!";
LOG_STRING char AVRCP_DATA_HANDLER_STR2[] = "[  AVRCP] More Data - Rx Cmd, Length:%d. BdAddr:0x%x%x";
LOG_STRING char AVRCP_DATA_HANDLER_STR3[] = "[  AVRCP] More Data - Rx Rsp, Length:%d. BdAddr:0x%x%x";

LOG_STRING char AVRCP_RX_CMD_STR1[] = "[  AVRCP] Rx Cmd - Invalid Command";
LOG_STRING char AVRCP_RX_CMD_STR2[] = "[  AVRCP] Rx Cmd - Opcode:%s,0x%x";
LOG_STRING char AVRCP_RX_CMD_STR3[] = "[  AVRCP] Rx Cmd - PDU ID:%s,0x%x";
LOG_STRING char AVRCP_RX_CMD_STR4[] = "[  AVRCP] Rx Cmd - operandID:%s,0x%x";
LOG_STRING char AVRCP_RX_CMD_STR5[] = "[  AVRCP] Rx Cmd - Result Code:0x%x";

LOG_STRING char AVRCP_RX_RSP_STR1[] = "[  AVRCP] Rx Rsp - Opcode:%s,0x%x";
LOG_STRING char AVRCP_RX_RSP_STR2[] = "[  AVRCP] Rx Rsp - PDU ID:%s,0x%x";
LOG_STRING char AVRCP_RX_RSP_STR3[] = "[  AVRCP] Rx Rsp - operandID:%s,0x%x, rsp:0x%x";

LOG_STRING char AVRCP_REG_CFM_STR[] = "[  AVRCP] Register Cfm:%x";
LOG_STRING char AVRCP_UNREG_CFM_STR[] = "[  AVRCP] UnRegister Cfm:%x";
LOG_STRING char AVRCP_CONN_CFM_STR[] = "[  AVRCP] Connect Cfm:%x";
LOG_STRING char AVRCP_DISCONN_CFM_STR[] = "[  AVRCP] Disconnect Cfm:%x";
LOG_STRING char AVRCP_CONN_IND_STR[] = "[  AVRCP] Connect Ind. BdAddr:0x%x%x";
LOG_STRING char AVRCP_CONN_IND_CONFLICT_STR[] = "[  AVRCP] Conflict";
LOG_STRING char AVRCP_CONN_IND_NORESOURCE_STR[] = "[  AVRCP] No Resource";

LOG_STRING char AVRCP_SDP_REG_CFM_STR[] = "[  AVRCP] SDP Reg Cfm, Role:0x%x Status:0x%x";
LOG_STRING char AVRCP_SDP_UNREG_CFM_STR[] = "[  AVRCP] SDP Unreg Cfm, Role:0x%x Status:0x%x";
LOG_STRING char AVRCP_SDP_OPEN_SEARCH_CFM_STR[] = "[  AVRCP] SDP Open Search Cfm, Status:0x%x";
LOG_STRING char AVRCP_SDP_CLOSE_SEARCH_CFM_STR[] = "[  AVRCP] SDP Close Search Cfm, Status:0x%x";
LOG_STRING char AVRCP_SDP_SERVICE_SEARCH_STR[] = "[  AVRCP] SDP Service Search Cfm, Status:0x%x";
LOG_STRING char AVRCP_SDP_ERROR_SRT1[] = "[  AVRCP] Unknown SDP Cfm, ID:0x%x";
LOG_STRING char AVRCP_SDP_ERROR_SRT2[] = "[  AVRCP] SDP Record Invalid Role";
LOG_STRING char AVRCP_SDP_ERROR_SRT3[] = "[  AVRCP] SDP Unregister Unknown Role";
LOG_STRING char AVRCP_TX_CMD_STR[] = "[  AVRCP] Tx Cmd: <%s> - %s";
LOG_STRING char AVRCP_TX_RSP_STR[] = "[  AVRCP] Tx Rsp: <%s> - %s";

LOG_STRING char AVRCP_TX_RESULT_STR[][MAX_LOG_STRING] =
{
	"Success",
	"Fail",
};

LOG_STRING char AVRCP_TX_CMD_RSP_STR[][MAX_LOG_STRING] =
{
	"Get Capabilities",//0,
	"Get Element Attributes",
	"Register Notification",
	"Set AbsoluteVolume",
	"Pass Through",
	"Vendor Unique",//5
	"Get PlayStatus",
	"Get Player Application",
	"Set Player Application",
	"Continue Response",
	"UnitInfo",//10,
	"SubunitInfo",
	"Register Notification Volume Interim",
	"Unknown Vendor Dependent",
	"Volume Changed",
};

LOG_STRING char AVRCP_PDU_ID_STR[][MAX_LOG_STRING] =
{
	"AVRCP_PDU_ID_GET_CAPABILITIES",
	"AVRCP_PDU_ID_GET_ELEMENT_ATTRIBUTES",
	"AVRCP_PDU_ID_REGISTER_NOTIFICATION",
	"AVRCP_PDU_ID_SET_ABSOLUTE_VOLUME",
	"AVRCP_PDU_ID_UNKNOWN",
};

LOG_STRING char AVRCP_OPID_STR[][MAX_LOG_STRING] =
{
	"AVC_OPERATION_POWER",				//0x00
	"AVC_OPERATION_VOL_UP",
	"AVC_OPERATION_VOL_DOWN",
	"AVC_OPERATION_MUTE",
	"AVC_OPERATION_PLAY",
	"AVC_OPERATION_STOP",				//0x05
	"AVC_OPERATION_PAUSE",
	"AVC_OPERATION_RECORD",
	"AVC_OPERATION_REWIND",
	"AVC_OPERATION_FAST_FORWARD",
	"AVC_OPERATION_EJECT",				//0x0A
	"AVC_OPERATION_FORWARD",
	"AVC_OPERATION_BACKWARD",
	//Airoha
	"AVC_OPERATION_INTERNAL_REWIND_RELEASE",
	"AVC_OPERATION_INTERNAL_FAST_FORWARD_RELEASE",

	"AVC_OPERATION_VENDOR_UNIQUE",		//0x0F

	"AVC_OPERATION_KEY_PLAY",			//0x10
	"AVC_OPERATION_KEY_PAUSE",
	"AVC_OPERATION_FORCE_PLAY",
	"AVC_OPERATION_GET_REPEAT_MODE",
	"AVC_OPERATION_GET_SHUFFLE_MODE",
	"AVC_OPERATION_GET_PLAY_STATUS",
	"AVC_OPERATION_SET_REPEAT_MODE",	//0x16
	"AVC_OPERATION_SET_SHUFFLE_MODE",

	"AVC_OPERATION_UNKNOWN"
};

/*Profile HFP*/
LOG_STRING char HFP_TIMEOUT_LOG_STR[] = "[    HFP] Time out, Timer:%s";
LOG_STRING char HSP_SDP_CFM_LOG_STR[] = "[    HSP] SDP %s CFM, ID:0x%x";
LOG_STRING char HFP_SDP_CFM_LOG_STR[] = "[    HFP] SDP %s CFM, ID:0x%x";
LOG_STRING char HSP_SDP_CFM_STATUS_STR[] = "[    HSP] SDP CFM, status : 0x%x";
LOG_STRING char HFP_SDP_CFM_STATUS_STR[] = "[    HFP] SDP CFM, status : 0x%x";
LOG_STRING char HFP_RFCOMM_LOG_STR[] = "[    HFP] Rx Rfcomm %s, id:0x%x";
LOG_STRING char HFP_RFCOMM_STATUS_STR[] = "[    HFP] Rx Rfcomm Msg, status: 0x%x";
LOG_STRING char HFP_RFCOMM_NO_LINKINFO_STR[] = "[    HFP] No pLinkInfo!!";
LOG_STRING char HFP_RFCOMM_ESTABLISH_SLC_STR[] = "[    HFP] hfp_EstablishSLC serverChannel:%d, remoteHfpScn:%d isPassive:%d sink:0x0%";
LOG_STRING char HFP_RFCOMM_CHANNEL[] = "[    HFP] HFP_CHANNEL";
LOG_STRING char HSP_RFCOMM_CHANNEL[] = "[    HSP] HSP_CHANNEL";
LOG_STRING char HFP_RFCOMM_CONN_IND_STR[] = "[    HFP] Connect Ind, Bdaddr: 0x%x%x";
LOG_STRING char HFP_RFCOMM_CONN_IND_CONFLICT_STR[] = "[    HFP] Rfcomm connect ind: Conflict";
LOG_STRING char HFP_RFCOMM_NO_RESOURCE_STR[] = "[    HFP] Rfcomm connect ind: No Resource";
LOG_STRING char HFP_RFCOMM_CONN_REQ_STR[] = "[    HFP] connect req";
LOG_STRING char HSP_RFCOMM_CONN_REQ_STR[] = "[    HSP] connect req";
LOG_STRING char HFP_REMOTE_BRSF_STR[] = "[    HFP] remoteBRSFfeature: 0x%x";
LOG_STRING char HFP_CLEAR_LINK_STR[] = "[    HFP] Clear link!!";
LOG_STRING char HFP_GET_TX_PTR_STR[] = "[    HFP] Get Tx Ptr - available size:%d";
LOG_STRING char HFP_REMOTE_CODEC_STR[] = "[    HFP] Remote Codec:<%s>, %d";
LOG_STRING char HFP_PROFILE_STATE_LOG_STR[] = "[    HFP] profile state:[%s], %d";
//LOG_STRING char HFP_SEND_AT_CMD_LOG_STR[] = "[    HFP] send [0x%x%x] -> [%s]";
LOG_STRING char HFP_CMD_STATE_LOG_STR[] = "[    HFP] hfp_ResultOKHandler : <%s>, 0x%x";
LOG_STRING char HFP_RESULT_CODE_LOG_STR[] = "[    HFP] hfp_ResultCodeHandler : <%s>, 0x%x";
LOG_STRING char HFP_PUSH_CMD_LOG_STR[] = "[    HFP] hfp_PushCmd : <%s>, 0x%x";
LOG_STRING char HFP_INTERNAL_CMD_LOG_STR[] = "[    HFP] hfp_InternalCmdHandler : <%s>, 0x%x";

LOG_STRING char HFP_TIMER_STR[][MAX_LOG_STRING] =
{
	"HFP_TIMER_SLC",
	"HFP_TIMER_ATCMD",
	"HFP_TIMER_BATXAPL",
	"HFP_TIMER_BATXEVENT",
	"HFP_TIMER_BATMONITOR",
	"HFP_TIMER_BVRA",
	"HFP_TIMER_START_SLC",
	"HFP UNKNOWN TIMER",
};

LOG_STRING char HFP_SDP_CFM_STR[][MAX_LOG_STRING] =
{
	"BT_SDP_REGISTER_CFM",
	"BT_SDP_UNREGISTER_CFM",
	"BT_SDP_OPEN_SEARCH_CFM",
	"BT_SDP_CLOSE_SEARCH_CFM",
	"BT_SDP_SERVICE_SEARCH_CFM",
	"BT_SDP_ATTRIBUTE_SEARCH_CFM",
	"BT_SDP_SERVICE_SEARCH_ATTRIBUTE_CFM",
	"BT_SDP_SERVER_CONNECT_IND",
	"BT_SDP_SERVER_DISCONNECT_IND",
	"HFP SDP UNKNOWN CFM",
};

LOG_STRING char HFP_RFCOMM_STR[][MAX_LOG_STRING] =
{
	"MESSAGE_MORE_DATA",
	"MESSAGE_MORE_SPACE",
	"BT_RFCOMM_REGISTER_CFM",
	"BT_RFCOMM_UNREGISTER_CFM",
	"BT_RFCOMM_CLIENT_CONNECT_CFM",
	"BT_RFCOMM_SERVER_CONNECT_CFM",
	"BT_RFCOMM_CONNECT_IND",
	"BT_RFCOMM_LINE_STATUS_CFM",
	"BT_RFCOMM_DISCONNECT_IND",
	"BT_RFCOMM_DISCONNECT_CFM",
	"HFP RFCOMM UNKNOWN MSG",
};

LOG_STRING char HFP_SCO_CODEC_STR[][MAX_LOG_STRING] =
{
	"SCO_CODEC_NONE",
	"SCO_CODEC_CVSD",
	"SCO_CODEC_MSBC",
};

LOG_STRING char HFP_PROFILE_STATE_STR[][MAX_LOG_STRING] =
{
	"PROFILE_DISCONNECTED",//0
	"PROFILE_CONNECTING_SDP",
	"PROFILE_CONNECTING_PROTOCOL",
	"PROFILE_CONNECTED",
	"PROFILE_DISCONNECTING",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"",
	"PROFILE_STATE_START",
};

LOG_STRING char HFP_CMD_STATE_STR[][MAX_LOG_STRING] =
{
	"HFP_CMD_STATE_IDLE",					//0
	"HSP_CMD_STATE_SLC_ESTABLISH",
	"HFP_CMD_STATE_SLC_ESTABLISH",
	"HFP_CMD_STATE_ATA",
	"HFP_CMD_STATE_ATD_NUMBER",
	"HFP_CMD_STATE_AT_APLEFM_ENABLE",		//5
	"HFP_CMD_STATE_AT_APLEFM_DISABLE",
	"HFP_CMD_STATE_AT_APLSIRI",
	"HFP_CMD_STATE_AT_BAC",
	"HFP_CMD_STATE_AT_BCC",
	"HFP_CMD_STATE_AT_BCS",				//10
	"HFP_CMD_STATE_AT_BIA",
	"HFP_CMD_STATE_AT_BIEV_BAT_SEND",
	"HFP_CMD_STATE_AT_BIND",
	"HFP_CMD_STATE_AT_BIND_EQUAL_QUES",
	"HFP_CMD_STATE_AT_BINP",				//15
	"HFP_CMD_STATE_AT_BLDN",
	"HFP_CMD_STATE_AT_BRSF",
	"HFP_CMD_STATE_AT_BTRH_QUES",
	"HFP_CMD_STATE_AT_BTRH_ACCEPT",
	"HFP_CMD_STATE_AT_BTRH_REJECT",		//20
	"HFP_CMD_STATE_AT_BVRA_ENABLE",
	"HFP_CMD_STATE_AT_BVRA_DISABLE",
	"HFP_CMD_STATE_AT_CHLD_EQUAL_QUES",
	"HFP_CMD_STATE_AT_CHLD",
	"HFP_CMD_STATE_AT_CHUP",				//25
	"HFP_CMD_STATE_AT_CIND_EQUAL_QUES",
	"HFP_CMD_STATE_AT_CIND_QUES",
	"HSP_CMD_STATE_AT_CKPD200",
	"HFP_CMD_STATE_AT_CLCC",
	"HFP_CMD_STATE_AT_CMEE_ENABLE",		//30
	"HFP_CMD_STATE_AT_CMEE_DISABLE",
	"HFP_CMD_STATE_AT_CMER",
	"HFP_CMD_STATE_AT_CNUM",
	"HFP_CMD_STATE_AT_CNUM_QUES",
	"HFP_CMD_STATE_AT_CLIP_ENABLE",		//35
	"HFP_CMD_STATE_AT_CLIP_DISABLE",
	"HFP_CMD_STATE_AT_CCWA_ENABLE",
	"HFP_CMD_STATE_AT_CCWA_DISABLE",
	"HFP_CMD_STATE_AT_CSCS",
	"HFP_CMD_STATE_AT_COPS",				//40
	"HFP_CMD_STATE_AT_COPS_QUES",
	"HFP_CMD_STATE_AT_IPHONE_BAT_SEND",
	"HFP_CMD_STATE_AT_NREC_ENABLE",
	"HFP_CMD_STATE_AT_NREC_DISABLE",
	"HFP_CMD_STATE_AT_VGS",				//45
	"HFP_CMD_STATE_AT_VGM",
	"HFP_CMD_STATE_AT_VTS",
	"HFP_CMD_STATE_AT_XAPL",
	"HFP_CMD_STATE_AT_XEVENT_BAT_INQ",
	"HFP_CMD_STATE_AT_XEVENT_BAT_SEND",
};

LOG_STRING char HFP_RESULT_CODE_STR[][MAX_LOG_STRING] =
{
	"HFP_RESULT_CODE_RING",										//0
	"HFP_RESULT_CODE_PLUS_BRSF",
	"HFP_RESULT_CODE_PLUS_CIND",
	"HFP_RESULT_CODE_PLUS_CHLD",
	"HFP_RESULT_CODE_PLUS_VGM",
	"HFP_RESULT_CODE_PLUS_VGS",									//5
	"HFP_RESULT_CODE_OK",
	"HFP_RESULT_CODE_ERROR",
	"HFP_RESULT_CODE_CIEV",
	"HFP_RESULT_CODE_PLUS_BVRA",
	"HFP_RESULT_CODE_PLUS_COPS",									//10
	"HFP_RESULT_CODE_PLUS_BTRH",
	"HFP_RESULT_CODE_PLUS_BSIR",
	"HFP_RESULT_CODE_PLUS_CNUM",
	"HFP_RESULT_CODE_PLUS_CME",
	"HFP_RESULT_CODE_PLUS_CLCC",									//15
	"HFP_RESULT_CODE_PLUS_CLIP",
	"HFP_RESULT_CODE_PLUS_CCWA",
	"HFP_RESULT_CODE_PLUS_BINP",
	"HFP_RESULT_CODE_PLUS_XAPL",
	"HFP_RESULT_CODE_PLUS_BCS",									//20
	"HFP_RESULT_CODE_PLUS_BIND",
	"HFP_RESULT_CODE_PLUS_APLSIRI",
	"HFP_RESULT_CODE_NO_CARRIER",									//23
	"HFP_RESULT_CODE_BUSY",
	"HFP_RESULT_CODE_NO_ANSWER",
	"HFP_RESULT_CODE_DELAYED	",
	"HFP_RESULT_CODE_BLACKLISTED",
	"HFP_ERROR_RESULT_CODE_END",
};

LOG_STRING char HFP_PUSH_CMD_STR[][MAX_LOG_STRING] =
{
	"HFP_CMD_IDLE",
	"HFP_CMD_SEND",
	"HFP_CMD_POP_INTERNAL_CMD",
	"HFP_CMD_COUNT",

	"HFP_CMD_INTERNAL_POP_CMD",
	"HFP_CMD_INTERNAL_START",
	"HFP_CMD_INTERNAL_ENABLE_CALL_WAITING_NOTIFICAITON",	//0x06
	"HFP_CMD_INTERNAL_SELECT_CHAR_SET_UTF8",				//0x07
	"HFP_CMD_INTERNAL_ENABLE_CLI_NOTIFICATION",				//0x08
	"HFP_CMD_INTERNAL_SET_AG_NREC_OFF",						//0x09
	"HFP_CMD_INTERNAL_ACTIVATE_INDICATOR",					//0x0A
	"HFP_CMD_INTERNAL_XAPL",								//0x0B
	"HFP_CMD_INTERNAL_XEVENT_BATTERY_INQUIRY",				//0x0C
	"HFP_CMD_INTERNAL_IPHONEACCEV",							//0x0D
	"HFP_CMD_INTERNAL_XEVENT_BATTERY_SEND",					//0x0E
	"HFP_CMD_INTERNAL_BIEV_SEND",							//0x0F
	"HFP_CMD_INTERNAL_SLC_VGS_CMD",							//0x10
	"HFP_CMD_INTERNAL_END",									//0x11
	"HFP UNKNOWN CMD"
};

/*Stream A2dp*/
LOG_STRING char A2DPStreamReadBufLogString[] = "[Stream] A2dp SourceReadBuf Length(%d) != FrameSize(%d)";
LOG_STRING char A2DPStreamDropLogString[] = "[Stream] A2DP Drop:%d,%d";
LOG_STRING char A2DPStreamSBCErrorLogString[] = "[Stream] Wrong SBC SyncWord!!!!";
LOG_STRING char A2DPStreamSBCFrameErrorLogString[] = "[Stream] SBC packet wrong length!!!!!!!!!!!!!!!!!!";

LOG_STRING char PM_ClearInfoLogString[] = "[      PM] Clear Info!!!!!!";
LOG_STRING char PM_NoProfileLoadLogString[] = "[      PM] No Profile Load !!!!!!";
LOG_STRING char PM_ActiveDiscProfileLogString[] = "[      PM] Active Disc BdAddr:0x%x%x, profileId:0x%x";
LOG_STRING char PM_BuildInProfileLogString[] = "[      PM] BuiltIn Profile:0x%x";
LOG_STRING char PM_EnterSniffModeLogString[] = "[      PM] BtSetLinkMode:LINK_MODE_SNIFF, BdAddr:0x%x%x";
LOG_STRING char PM_ExitSniffModeLogString[] = "[      PM] BtSetLinkMode:LINK_MODE_ACTIVE, BdAddr:0x%x%x";
LOG_STRING char PM_SniffDelayTimerLogString[] = "[      PM] Sniff Delay timeout: SNIFF_DELAY_TIME_ID, BdAddr:0x%x%x, state:%d, Mask:0x%x";
LOG_STRING char PM_CheckRemoteTimerLogString[] = "[      PM] CHECK_REMOTE_AG_ACCEPT_ENTER_SNIFF_TIMER_ID";
LOG_STRING char PM_SniffDisableLogString[] = "[      PM] SniffDisable:BdAddr:0x%x%x, reason:%d, beforeMask:0x%x, afterMask:0x%x, state:%d";
LOG_STRING char PM_SniffEnableLogString[] = "[      PM] SniffEnable :BdAddr:0x%x%x, reason:%d, beforeMask:0x%x, afterMask:0x%x, state:%d";
LOG_STRING char PM_SetModeCfmLogString[] = "[      PM] Sniff Set Mode Cfm Status:%d, BdAddr:0x%x%x";
LOG_STRING char PM_ModeChangeExitLogString[] = "[      PM] Sniff Mode Change Ind: BdAddr:0x%x%x, status:%d, mode:%d, Mask:0x%x";
LOG_STRING char PM_LoadProfileLogString1[] = "[      PM] PM_LoadProfile assert: Profile Loaded!";
LOG_STRING char PM_LoadProfileLogString2[] = "[      PM] PM_LoadProfile assert: Full links, no resource";
LOG_STRING char PM_LoadProfileLogString3[] = "[      PM] PM_LoadProfile assert: profileDesc is NULL";
LOG_STRING char PM_ActivateProfileLogString1[] = "[      PM] PM_ActivateProfile assert 1";
LOG_STRING char PM_ActivateProfileLogString2[] = "[      PM] PM_ActivateProfile assert 2";
LOG_STRING char PM_SetLinkPolicyDisableLogString[] = "[      PM] BtSetLinkPolicy:Disable All LM Mode, BdAddr:0x%x%x";
LOG_STRING char PM_SetLinkPolicyEnableLogString[] = "[      PM] BtSetLinkPolicy:Enable Sniff Mode, BdAddr:0x%x%x";
LOG_STRING char PM_ReconnectTimerHandlerString[] = "[      PM] Reconn Handler id:%d, Msg:0x%x, id_ext:0x%x";
LOG_STRING char PM_PushReconnectMissionString[] = "[      PM] Push Reconn id:%d, Msg:0x%x, pLinkInfo:0x%x";
LOG_STRING char PM_RhoActivateProfileErrorString1[] = "[      PM] RHO Activate profile profileInfo:0x%x, already loaded";
LOG_STRING char PM_RhoActivateProfileErrorString2[] = "[      PM] RHO Activate profile profileDesc NULL";
LOG_STRING char PM_ProfileIdLoadString[] = "[      PM] Is Profile Loaded, ProfileDesc:0x%x";
LOG_STRING char PM_SetLinkStateLogString[] = "[      PM] Set link state:%d => %d";
LOG_STRING char PM_ConflictStateMachineLogString[] = "[PM_ConnConflict] Current State:[%s] Event:[%s]";
LOG_STRING char PM_ConflictClearInfoLogString[] = "[PM_ConnConflict] Clear state info";
LOG_STRING char PM_ConflictReconnectLogString[] = "[PM_ConnConflict] Trigger reconnect bda:%x %x";
LOG_STRING char PM_RHOStartingSetReconnectAgainString[] = "[      PM] RHO Starting, Set reconnect timer again, profileID:%d";





LOG_STRING char PM_ConflictStateLogString[][MAX_LOG_STRING] =
{
	"IDLE",
	"SDP_CONN_NOT_ALLOW_WAIT",
	"SDP_CONN_EXIST_WAIT",
	"ACL_OPEN_WAIT",
};

LOG_STRING char PM_ConflictEventLogString[][MAX_LOG_STRING] =
{
	"SDP_CONN_NOT_ALLOW",
	"SDP_CONN_ALREADY_EXIST",
	"CONN_NOT_ALLOW_TIMER_EXPIRE",
	"CONN_EXIST_TIMER_EXPIRE",
	"ACL_OPEN",
	"ENCRIPTION_ON",
	"ACL_IDLE_TIMER_EXPIRE",
	"ACL_CLOSE",
	"ACTIVE_RECONNECT",
	"CLEAR_INFO",
};



LOG_STRING char APP_LedSetRepeatLogStr[] = "[APP_LED] Set Repeat:%d,%d";
LOG_STRING char APP_LedSetAddTimeLogStr[] = "[APP_LED] Set Add Time:%d,%d";
LOG_STRING char APP_LedSetT4TimeLogStr[] = "[APP_LED] Set T4 Time:%d,%d";
LOG_STRING char APP_LedHandlerLogStr[] = "[APP_LED] HDL:%d,%d";
LOG_STRING char APP_LedSetT3TimeLogStr[] = "[APP_LED] Set Repeat Time3:%d,%d";
LOG_STRING char APP_LedSetT4Time2LogStr[] = "[APP_LED] Set T4 Time2:%d,%d";
LOG_STRING char APP_LedSetRepeat2LogStr[] = "[APP_LED] Set Repeat Time2:%d,%d";
LOG_STRING char APP_LedSetT4Time3LogStr[] = "[APP_LED] Set T4 Time3:%d,%d";
LOG_STRING char APP_LedResumeBGLogStr[] = "[APP_LED] Resume BG";
LOG_STRING char APP_LedInitFailLogStr[] = "[APP_LED] Init Fail:%d,%d";
LOG_STRING char APP_LedInitSuccessLogStr[] = "[APP_LED] LED:%d,%d,%d";


/* Sound Level Component */
LOG_STRING char APP_VolComponentLogString[][MAX_LOG_STRING] =
{
	"COMPONENT_SCO_WB",
	"COMPONENT_SCO_NB",
	"COMPONENT_A2DP",
	"COMPONENT_LINEIN",
	"COMPONENT_VPRT",
	"COMPONENT_MIC_SCO",
	"COMPONENT_MP3",
	"COMPONENT_MIC_A2DP",
	"COMPONENT_AIROTHRU_SPK",
	"COMPONENT_AIROTHRU_MIC",
};

/* PEQ Component */
LOG_STRING char APP_PeqComponentLogString[][MAX_LOG_STRING] =
{
	"COMPONENT_A2DP",
	"COMPONENT_LINEIN",
	"COMPONENT_MP3"
};

/* PEQ Phase */
LOG_STRING char APP_PeqPhaseLogString[][MAX_LOG_STRING] =
{
	"DSP_PEQ_USER",
	"DSP_PEQ_SPEAKER",
};


/*Key Event*/
LOG_STRING char APP_KeyIndexLogString[][MAX_LOG_STRING] =
{
	"KEY1",
	"KEY2",
	"KEY3",
	"KEY4",
	"KEY5",
	"KEY6",
	"KEY7",
	"KEY8",
	"KEY9",
	"KEY10",
	"TOTAL_KEY_NUM",//10
	"KEYALL",
	"KEYNONE",
	"KEY_PWR",
	"KEY_COMB_34",//14
	"KEY_COMB_23",//15
	"KEY_COMB_13",//16
	"KEY_COMB_24",//17
	"KEY_COMB_14",//18
	"KEY_COMB_12",//19
	"KEY_COMB_123",//20
	"KEY_COMB_124",//21
	"KEY_COMB_134",//22
	"KEY_COMB_234",//23
	"KEY_COMB_1234"//24
};

LOG_STRING char APP_ActionLogString[][MAX_LOG_STRING] =
{
	"TAP",
	"PRESS",
	"PRESS_RELEASE",
	"LONGPRESS",
	"LONGPRESS_RELEASE",
	"DOUBLE",
	"TRIPLE",
	"LONGLONGPRESS",
	"LONGLONGPRESS_RELEASE",
	"EXTREMELY_LONGPRESS",
	"EXTREMELY_LONGPRESS_RELEASE",
	"REPEAT",
	"DOWN",
	"UP",
	"BUTTON_SEQUENCE1_TIMEOUT"
};

LOG_STRING char APP_KeyEventLogString[][MAX_LOG_STRING] =
{
	"INVALID",
	"RECONNECT_USER_INIT",
	"DISCOVERABLE",
	"NONDISCOVERABLE",
	"CONNECTED_TO_DISCOVERABLE",
	"CONNECTED_TO_CONNECTABLE",
	"NFC_DISCOVREABLE",
	"CONFIRMATION_ACCEPT",
	"CONFIRMATION_REJECT",
	"DEBUG_KEY_TOGGLE",
	"VOICEUP",
	"VOICEDN",
	"BUZZER_MUTE_TOGGLE",
	"TOGGLE_VOLUME",
	"VOLUME_ORIENTATION_NORMAL",
	"VOLUME_ORIENTATION_INVERT",
	"TOGGLE_LED",
	"ENABLE_LED",
	"DISABLE_LED",
	"CANCEL_LED_INDICATION",
	"MEDIA_TRIGGER_1",
	"MEDIA_TRIGGER_2",
	"POWER_ON_THEN_ENTERDISCOVERABLE",
	"POWER_ON",
	"POWER_OFF",
	"RESET",
	"RESET_PAIRED_DEVICES",
	"MAX_DEVICE_ALLOWED_UP",
	"MAX_DEVICE_ALLOWED_DOWN",
	"MAX_DEVICE_ALLOWED_TOGGLE",
	"RECONNECT_AFTER_POWER_ON",
	"VOICE_PROMPT_TOGGLE",
	"VOICE_PROMPT_ENABLE",
	"VOICE_PROMPT_DISABLE",
	"VOICE_PROMPT_LANG_CHANGE",
	"VOICE_PROMPT_LANG_SELECT",
	"VOICE_PROMPT_LANG_CONFIRM",
	"TEST_VOICE_PROMPT_PLAY",
	"TEST_VOICE_PROMPT_NEXT",
	"BUTTONLOCKON",
	"BUTTONLOCKOFF",
	"BUTTONLOCKTOGGLE",
	"VOICE_COMMAND_ENABLE",
	"MICUP",
	"MICDN",
	"MIC_MUTE_TOGGLE",
	"MIC_MUTE_ON",
	"MIC_MUTE_OFF",
	"AIR_ENTER_AIR_PAIRING",
	"AIR_EXIT_AIR_PAIRING",
	"AUDIO_TRANSFER",
	"SET_VOICE_RECOGNITION",
	"RDIAL",
	"DIALMEM",
	"DIALNUM",
	"CNLOUTGOING",
	"REJCALL",
	"REJCALL_SECOND_PHONE",
	"ONHOLD_CALL",
	"ACPCALL",
	"ENDCALL",
	"3WAYRELNUDUB",
	"3WAYRELNACP",
	"3WAYRELNACP_X",
	"3WAYHOLDNACP",
	"3WAYHOLDNACP_X",
	"3WAYADD",
	"3WAYCALLTRANSFER",
	"HSP_BUTTON_PRESSED",
	"DISABLE_NREC",
	"GETCALLNUM",
	"QUERY_CALL_LIST",
	"SEND_DTMF",
	"ATTACH_LAST_VOICE_TAG_RECORDED",
	"SEND_CLIP",
	"SET_VOICE_RECOGNITION_SECONDARY",
	"RDIAL_SECONDARY",
	"SET_VOICE_RECOGNITION_CANCEL",
	"SET_VOICE_RECOGNITION_SECONDARY_CANCEL",
	"SIRI_START_OR_CONTINUE",
	"SIRI_END",
	"SIRI_START_OR_CONTINUE_SECONDARY",
	"SIRI_END_SECONDARY",
	"AVRCP_PLAY",
	"AVRCP_STOP",
	"AVRCP_PAUSE",
	"AVRCP_RECORD",
	"AVRCP_REWIND_PUSH",
	"AVRCP_FAST_FORWARD_PUSH",
	"AVRCP_EJECT",
	"AVRCP_FORWARD",
	"AVRCP_BACKWARD",
	"AVRCP_REWIND_RELEASE",
	"AVRCP_FAST_FORWARD_RELEASE",
	"AVRCP_REPEAT_MODE_CHANGE",
	"AVRCP_SHUFFLE_MODE_CHANGE",
	"AVRCP_ACTIVE_TOGGLE",
	"PEQ_MODE_CHANGE",
	"FM_POWERON",
	"FM_POWEROFF",
	"SEEKUP",
	"SEEKDOWN",
	"TUNEUP",
	"TUNEDN",
	"FM_MUTETOGGLE",
	"ENTER_LINEIN_MODE",
	"EXIT_LINEIN_MODE",
	"LINEIN_MUTE_TOGGLE",
	"ENTER_TESTMODE",
	"SWITCH_TEST_MODE_CHANNEL",
	"SWITCH_TEST_MODE_POWER",
	"SWITCH_TEST_MODE_STATE",
	"SWITCH_TEST_MODE_TX_PACKET_TYPE",
	"SCO_SWITCH",
	"AIR_ENTER_AIR_SECURE_PAIRING",
	"MULTI_A2DP_PLAY_MODE_TOGGLE",
	"CHECK_STATUS_OF_CONNECTION",
	"WHAT_CAN_I_SAY",
	"LEFT_CHANNEL",
	"RIGHT_CHANNEL",
	"STEREO_CHANNEL",
	"VOICE_COMMAND_CANCEL",
	"VOICE_MAKE_A_CALL",
	"CHECK_STATUS",
	"CHANGE_SOUND_EFFECT",
	"CONTROL_DBB_ON_OFF",
	"CONTROL_MIC_A2DP_MODE",
	"SELFIE",
	"ENABLE_DUT_MODE_COMMAND",
	"MIC_L_ENABLE",
	"MIC_R_ENABLE",
	"MIC_TO_SPK_ENABLE",
	"MIC_TO_SPK_DISABLE",
	"ENABLE_EC_NR",
	"DISABLE_EC_NR",
	"2K_TONE_ENABLE",
	"2K_TONE_DISABLE",
	"SWITCH_STEREO_MONO",
	"SWITCH_SELFIE",
	"AIROTHRU",
	"ROLE_CHANGE",
	"MP3_POWERON",
	"MP3_POWEROFF",
	"MP3_PLAY",
	"MP3_STOP",
	"MP3_PAUSE",
	"MP3_FORWARD",
	"MP3_BACKWARD",
	"ANC_SWITCH",
	"RESET_TO_FACTORY",
	"ANC_ON",
	"ANC_OFF",
	"DSP_RESET",
	"MCSync_CONNECT",
	"MCSync_DISCONNECT",
	"MCSync_ENABLEDISCOVERABLE",
	"MCSync_DISABLEDISCOVERABLE",
	"MCSync_RHO",
	"REPORT_BATTERY_STATUS",
	"SPEECH_TOGGLE",
	"SPEECH_START", //160
	"SPEECH_STOP",//161
	"VAD_ON",
	"VAD_OFF",
	"GAME_MODE_ON",
	"GAME_MODE_OFF",
	"GAME_MODE_TOGGLE",
	"TOTAL_NO"
};

/*State*/
LOG_STRING char APP_StateLogString[][MAX_LOG_STRING] =
{
	"OFF",
	"CONDISCABLE",
	"CONNECTABLE",
	"CONNECTED",
	"HFP_INCOMMING",
	"HFP_OUTGOING",
	"HFP_CALLACTIVE",
	"HFP_CALLACTIVE_WITHOUT_SCO",
	"HFP_CAIMG",
	"HFP_CAOGG",
	"HFP_CAMULTY",
	"FAKEON",
	"FAKEOFF",
	"DETACHING_LINK",
	"TEST_MODE",
	"FM",
	"LINE_IN",
	"UPDATING",
	"UPDATED_OK",
	"UPDATED_FAIL",
	"VOICE_PROMPT_LANG_SELECT",
	"TWS_PAIRING",
	"INQUIRY",
	"MP_STATE",
	"MP3",
	"STATE_RESERVED2",
	"STATE_RESERVED3",
	"STATE_RESERVED4",
	"STATE_RESERVED5",
	"STATE_RESERVED6",
	"STATE_RESERVED7",
	"TOTAL_STATE_NO"
};

/*Media Event*/
//Start from "MEDIA_EVT_KEY_BASE (0x0001)"
LOG_STRING char APP_MediaEvent1LogString[][MAX_LOG_STRING] =
{
	//0
	"",
	//0x0001
	"KEY_RECONNECT_USER_INIT",
	"KEY_DISCOVERABLE",
	"KEY_NONDISCOVERABLE",
	"KEY_CONNECTED_TO_DISCOVERABLE",
	"KEY_CONNECTED_TO_CONNECTABLE",
	"KEY_NFC_DISCOVREABLE",
	"KEY_CONFIRMATION_ACCEPT",
	"KEY_CONFIRMATION_REJECT",
	"KEY_DEBUG_KEY_TOGGLE",
	"KEY_VOICEUP",
	"KEY_VOICEDN",
	"KEY_BUZZER_MUTE_TOGGLE",
	"KEY_TOGGLE_VOLUME",
	"KEY_VOLUME_ORIENTATION_NORMAL",
	"KEY_VOLUME_ORIENTATION_INVERT",

	//0x001x
	"KEY_TOGGLE_LED",
	"KEY_ENABLE_LED",
	"KEY_DISABLE_LED",
	"KEY_CANCEL_LED_INDICATION",
	"KEY_MEDIA_TRIGGER_1",
	"KEY_MEDIA_TRIGGER_2",
	"KEY_POWER_ON_THEN_ENTERDISCOVERABLE",
	"KEY_POWER_ON",
	"KEY_POWER_OFF",
	"KEY_RESET",
	"KEY_RESET_PAIRED_DEVICES",
	"KEY_MAX_DEVICE_ALLOWED_UP",
	"KEY_MAX_DEVICE_ALLOWED_DOWN",
	"KEY_MAX_DEVICE_ALLOWED_TOGGLE",
	"KEY_RECONNECT_AFTER_POWER_ON",
	"KEY_VOICE_PROMPT_TOGGLE",

	//0x002x
	"KEY_VOICE_PROMPT_ENABLE",
	"KEY_VOICE_PROMPT_DISABLE",
	"KEY_VOICE_PROMPT_LANG_CHANGE",
	"KEY_VOICE_PROMPT_LANG_SELECT",
	"KEY_VOICE_PROMPT_LANG_CONFIRM",
	"KEY_TEST_VOICE_PROMPT_PLAY",
	"KEY_TEST_VOICE_PROMPT_NEXT",
	"KEY_BUTTONLOCKON",
	"KEY_BUTTONLOCKOFF",
	"KEY_BUTTONLOCKTOGGLE",
	"KEY_VOICE_COMMAND_ENABLE",
	"KEY_MICUP",
	"KEY_MICDN",
	"KEY_MIC_MUTE_TOGGLE",
	"KEY_MIC_MUTE_ON",
	"KEY_MIC_MUTE_OFF",

	//0x003x
	"KEY_AIR_ENTER_AIR_PAIRING",
	"KEY_AIR_EXIT_AIR_PAIRING",
	"KEY_AUDIO_TRANSFER",
	"KEY_SET_VOICE_RECOGNITION",
	"KEY_RDIAL",
	"KEY_DIALMEM",
	"KEY_DIALNUM",
	"KEY_CNLOUTGOING",
	"KEY_REJCALL",
	"KEY_REJCALL_SECOND_PHONE",
	"KEY_ONHOLD_CALL",
	"KEY_ACPCALL",
	"KEY_ENDCALL",
	"KEY_3WAYRELNUDUB",
	"KEY_3WAYRELNACP",
	"KEY_3WAYRELNACP_X",

	//0x004x
	"KEY_3WAYHOLDNACP",
	"KEY_3WAYHOLDNACP_X",
	"KEY_3WAYADD",
	"KEY_3WAYCALLTRANSFER",
	"KEY_HSP_BUTTON_PRESSED",
	"KEY_DISABLE_NREC",
	"KEY_GETCALLNUM",
	"KEY_QUERY_CALL_LIST",
	"KEY_SEND_DTMF",
	"KEY_ATTACH_LAST_VOICE_TAG_RECORDED",
	"KEY_SEND_CLIP",
	"KEY_RESERVED1",
	"KEY_RESERVED2",
	"KEY_SET_VOICE_RECOGNITION_CANCEL",
	"KEY_RESERVED3",
	"KEY_SIRI_START_OR_CONTINUE",

	//0x005x
	"KEY_SIRI_END",
	"KEY_RESERVED4",
	"KEY_RESERVED5",
	"KEY_AVRCP_PLAY",
	"KEY_AVRCP_STOP",
	"KEY_AVRCP_PAUSE",
	"KEY_AVRCP_RECORD",
	"KEY_AVRCP_REWIND_PUSH",
	"KEY_AVRCP_FAST_FORWARD_PUSH",
	"KEY_AVRCP_EJECT",
	"KEY_AVRCP_FORWARD",
	"KEY_AVRCP_BACKWARD",
	"KEY_AVRCP_REWIND_RELEASE",
	"KEY_AVRCP_FAST_FORWARD_RELEASE",
	"KEY_AVRCP_REPEAT_MODE_CHANGE",
	"KEY_AVRCP_SHUFFLE_MODE_CHANGE",

	//0x006x
	"KEY_AVRCP_ACTIVE_TOGGLE",
	"KEY_PEQ_MODE_CHANGE",
	"KEY_FM_POWERON",
	"KEY_FM_POWEROFF",
	"KEY_SEEKUP",
	"KEY_SEEKDOWN",
	"KEY_TUNEUP",
	"KEY_TUNEDN",
	"KEY_FM_MUTETOGGLE",
	"KEY_ENTER_LINEIN_MODE",
	"KEY_EXIT_LINEIN_MODE",
	"KEY_LINEIN_MUTE_TOGGLE",
	"KEY_ENTER_TESTMODE",
	"KEY_SWITCH_TEST_MODE_CHANNEL",
	"KEY_SWITCH_TEST_MODE_POWER",
	"KEY_SWITCH_TEST_MODE_STATE",

	//0x007x
	"KEY_SWITCH_TEST_MODE_TX_PACKET_TYPE",
	"KEY_SCO_SWITCH",
	"KEY_AIR_ENTER_AIR_SECURE_PAIRING",
	"KEY_MULTI_A2DP_PLAY_MODE_TOGGLE",
	"KEY_CHECK_STATUS_OF_CONNECTION",
	"KEY_WHAT_CAN_I_SAY",
	"KEY_LEFT_CHANNEL",
	"KEY_RIGHT_CHANNEL",
	"KEY_STEREO_CHANNEL",
	"KEY_VOICE_COMMAND_CANCEL",
	"KEY_VOICE_MAKE_A_CALL",
	"KEY_CHECK_STATUS",
	"KEY_CHANGE_SOUND_EFFECT",
	"KEY_CONTROL_DBB_ON_OFF",
	"KEY_CONTROL_MIC_A2DP_MODE",
	"KEY_SELFIE",

	//0x008x
	"KEY_ENABLE_DUT_MODE_COMMAND",
	"KEY_MIC_L_ENABLE",
	"KEY_MIC_R_ENABLE",
	"KEY_MIC_TO_SPK_ENABLE",
	"KEY_MIC_TO_SPK_DISABLE",
	"KEY_ENABLE_EC_NR",
	"KEY_DISABLE_EC_NR",
	"KEY_2K_TONE_ENABLE",
	"KEY_2K_TONE_DISABLE",
	"KEY_SWITCH_STEREO_MONO",
	"KEY_SWITCH_SELFIE",
	"KEY_AIROTHRU",
	"KEY_ROLE_CHANGE",
	"KEY_MP3_POWERON",
	"KEY_MP3_POWEROFF",
	"KEY_MP3_PLAY",

	//0x009x
	"KEY_MP3_STOP",
	"KEY_MP3_PAUSE",
	"KEY_MP3_FORWARD",
	"KEY_MP3_BACKWARD",
	"KEY_ANC_SWITCH",
	"KEY_RESET_TO_FACTORY",
	"KEY_ANC_ON",
	"KEY_ANC_OFF",
	"DSP_RESET",
	"AWSMCE_CONNECT",
	"AWSMCE_DISCONNECT",
	"AWSMCE_ENABLEDISCOVERABLE",
	"AWSMCE_DISABLEDISCOVERABLE",
	"AWSMCE_RHO",
	"REPORT_BATTERY_STATUS",
	"SPEECH_TOGGLE",

	//0x00Ax
	"SPEECH_START",
	"SPEECH_STOP",
	"VAD_ON",
	"VAD_OFF",
	"GAME_MODE_ON",
	"GAME_MODE_OFF",
	"GAME_MODE_TOGGLE",
};

//Start from "MEDIA_EVT_SYSTEM_BASE (0x9000)"
LOG_STRING char APP_MediaEvent2LogString[][MAX_LOG_STRING] =
{
	//0x900X	Battery
	"BAT_LOW",
	"BAT_FULL",				//battery voltage is over full_voltage", i.e.", fake charge-complete signal
	"BAT_CHGCPL",			//charge complete
	"BAT_RECHG",			//recharge
	"BAT_CHGROUT",			//charger pull out
	"BAT_CHGRIN",			//charger plug in
	"BAT_CHGTO",			//charge TO
	"BAT_HW_CHGTO",			//hw detects charging TO
	"BATTERY_INTERVAL_0",
	"BATTERY_INTERVAL_1",
	"BATTERY_INTERVAL_2",
	"BATTERY_INTERVAL_3",
	"BAT_LOW_LED",
	"BAT_LOW_RING",
	"BAT_SECURE_TEMP",
	"BAT_RISKY_TEMP",
	//0x901X
	"BAT_OK",
	"BAT_DISCOUNT_TEMP",
	"POWER_ON",
	"POWER_ON_UNDER_CHECKPOINT1",
	"POWER_OFF",
	"POWER_OFF_UNDER_CHECKPOINT1",
	"POWER_OFF_IN_SHUTDOWN_LOW_BAT",
	"MUTE_REMINDER",
	"ENTER_TESTMODE_STATE",
	"OFF_STATE",
	"FG_LED_DISPLAY_OVER",
	"RESET_COMPLETE",
	"FM_VOLUME_REACH_MAX",
	"FM_VOLUME_REACH_MIN",
	"FM_NOT_BUSY",
	"LINEIN_VOLUME_REACH_MAX",
	//0x902X
	"LINEIN_VOLUME_REACH_MIN",
	"VOICE_PROMPT_LANG_CHANGE",
	"VOICE_PROMPT_LANG_SELECT",
	"VOICE_PROMPT_LANG_CONFIRM",
	"ENTER_LINE_IN_MODE",
	"EXIT_LINE_IN_MODE",
	"MUTE_ON",
	"MUTE_OFF",
	"FM_MUTE_ON",
	"FM_MUTE_OFF",
	"FM_ENABLE",
	"POWER_OFF_UNDER_CHECKPOINT2",
	"POWER_OFF_UNDER_CHECKPOINT3",
	"POWER_ON_UNDER_CHECKPOINT2",
	"POWER_ON_UNDER_CHECKPOINT3",
	"VOICE_COMMAND_FAIL",
	//0x903X
	"VOICE_COMMAND_MULTILAYER_TRIGGER",
	"RESERVED1",
	"MIC_UPDN",
	"CALLER_ID", //0x9033
};

//Start from "MEDIA_EVT_CONNECTION_BASE (0xA000)"
LOG_STRING char APP_MediaEvent3LogString[][MAX_LOG_STRING] =
{
	//0xA00X		Indication Events
	"SLC_CONNECTED",
	"2_SLC_CONNECTED",
	"3_SLC_CONNECTED",
	"4_SLC_CONNECTED",
	"SLC_DISCONNECTED",
	"PAIRING_SUCCESSFUL",
	"PAIRING_FAIL",
	"LINK_LOSS",
	"END_OF_CALL",
	"RINGTONE",
	"RECONNECT_FAILED",  //0xA0
	"NETWORK_NOT_PRESENT",
	"NETWORK_PRESENT",
	"PINCODE_REQUEST",
	"CONFIRMATION_REQUEST",
	"CALL_CONNECTED",
	//0xA01X
	"AUDIO_LINK_OPEN",
	"AUDIO_LINK_CLOSE",
	"CONNECTABLE_TIMEOUT",
	"HFP_ERROR_RECEIVED",
	"REFRESH_ENCRYPTION",
	"ENTER_CTX_TEST_MODE",
	"ENTER_DISCOVERABLE",
	"EXIT_DISCOVERABLE",
	"ENTER_INCOMING",
	"EXIT_INCOMING",
	"PHONE_IS_TOO_FAR_1",
	"PHONE_IS_TOO_FAR_2",
	"RINGTONE_2",
	"VOLUME_REACH_MAX",
	"VOLUME_REACH_MIN",
	"REDIAL_SUCCESSFUL_EVT",
	//0xA02X
	"A2DP_VOLUME_REACH_MAX",
	"A2DP_VOLUME_REACH_MIN",
	"MISSED_CALL_REMINDER1",
	"MISSED_CALL_REMINDER2",
	"A2DP_ENABLE",
	"A2DP_DISABLE",
	"VOICE_DIAL_ENABLE",
	"REDIAL_ENABLE",
	"RINGTONE_IN_CALL",
	"RINGTONE2_IN_CALL",
	"TWS_ENTER_PAIRING",
	"TWS_EXIT_PAIRING",
	"TWS_DURING_PAIRING",
	"TWS_LEFT_CHANNEL",
	"TWS_RIGHT_CHANNEL",
	"TWS_RELAY_ONLY",
	//0xA03X
	"TWS_FOLLOWER",
	"SIRI_STARTING",
	"SIRI_CONTINUE",
	"SIRI_END",
	"KEY_FIND_MY_ACCESSORY",
	"TWS_DISCONNECTED",
	"AG_CNLOUTGOING",
	"INCOMING_CALL_ENDED",
	"ANC_ON",
	"ANC_OFF",
	"MP3_POWERON",
	"SPECIAL_CONNECTED",
	"SPECIAL_DISCONNECTED",
	"PLAYING_BEEP_SYNC",
	//reserve for UART cmd to play voice prompt
	"UART_CMD_RESERVE", //0xA038
};

LOG_STRING char APP_VPLogString[][MAX_LOG_STRING] =
{
	"ZERO",
	"ONE",
	"TWO",
	"THREE",
	"FOUR",
	"FIVE",
	"SIX",
	"SEVEN",
	"EIGHT",
	"NINE",
	"VOICE_PROMPT_LANG_CHANGE",
	"VOICE_PROMPT_ON",
	"VOICE_PROMPT_OFF",
	"MULTI_POINT_MODE_ON",
	"MULTI_POINT_MODE_OFF",
	"MUTE_ON",
	"MUTE_OFF",
	"POWER_ON",
	"POWER_OFF",
	"PAIRING",
	"PAIRING_SUCCESSFUL",
	"CONNECTED",
	"SECOND_DEVICE_CONNECTED",
	"DEVICE_DISCONNECTED",
	"INCOMING_CALL",
	"CALL_REJECTED",
	"CALL_CANCELLED",
	"CALL_ENDED",
	"RE_DIALING",
	"LOW_BATTERY",
	"BATTERY_IS_HIGH",
	"BATTERY_IS_MEDIAN",
	"BATTERY_IS_LOW",
	"VOLUME_MAXIMUM",
	"PAUSE",
	"LINE_IN_MODE",
	"BLUETOOTH_MODE",
	"FM_MODE",
	"SEEK_UP",
	"SEEK_DOWN",
	"LEFT_CHANNEL",
	"RIGHT_CHANNEL",
	"WHAT_CAN_I_SAY",
	"CONNECTION_STATUS",
	"CHECK_BATTERY",
	"CANCEL",
	"VOICE_PROMPT_EXAMPLE",
	"TAKE_THE_CALL",
	"REJECT",
	"REJECT_PHONE_CALL",
	"PAIRING_FOR_VC",
	"LAST_CALL_OUT",
	"VOICE_DIAL_FOR_VC",
	"VOICE_COMMAND_EXAMPE_SET0",
	"VOICE_COMMAND_EXAMPE_SET1",
	"VOICE_COMMAND_EXAMPE_SET2",
	"MAKE_A_CALL",
	"CHECK_STATUS",
	"RING_BACK",
	"BEEP",
	"INCOMING_CALL_ENDED",
	"CALLER_ID",
	"NUMBER",
	"CALLER_ID_PREFIX",
	"CALLER_ID_SUFFIX",
	"VOLUME_MINIMUM",
};

LOG_STRING char APP_RTLogString[][MAX_LOG_STRING] =
{
	"SHORT_1_NOTE_1",
	"SHORT_1_NOTE_2",
	"SHORT_1_NOTE_3",
	"SHORT_1_NOTE_4",
	"SHORT_2_NOTE",
	"MEDIAN_1_NOTE",
	"LONG_1_NOTE_HIGH",
	"LONG_1_NOTE_LOW",
	"VERYLONG_1_NOTE_HIGH",
	"VERYLONG_1_NOTE_LOW",
	"RISING_2_NOTE",
	"RISING_4_NOTE",
	"FALLING_2_NOTE",
	"FALLING_4_NOTE",
	"LONG_RING_A",
	"LONG_RING_B",
	"LONG_RING_C",
	"USER_DEFINED_A"
};

LOG_STRING char APP_VPRTLogString[][MAX_LOG_STRING] =
{
	"VP",
	"RT"
};

LOG_STRING char APP_ProfileLogString[][MAX_LOG_STRING] =
{
		//APP Profile Descriptor
		"",//0x0
		"HEADSET",//SCN_HEADSET,
		"HANDSFREE",//SCN_HANDSFREE,
		"SERIAL_PORT",//SCN_SERIAL_PORT,
		"LCIF",//SCN_LCIF,
		"IAP2",//SCN_IAP2,
		"SONGPAL_ANDROID",// = SCN_SONGPAL_ANDROID,
		"SONGPAL_IAP2",// = SCN_SONGPAL_IAP2,
		"OBJECT_PUSH",// = SCN_OBJECT_PUSH,
		"SIM_ACCESS",// = SCN_SIM_ACCESS,
		"PHONEBOOK_ACCESS",// = SCN_PHONEBOOK_ACCESS,
		"MESSAGE_ACCESS",// = SCN_MESSAGE_ACCESS,
		"MESSAGE_NOTIFICATION",// = SCN_MESSAGE_NOTIFICATION,
		"AIR_APP",// = SCN_AIR_APP,
		"",//0x0E
		"",//0x0F
		"",//0x10
		"",//0x11
		"",//0x12
		"",//0x13
		"",//0x14
		"",//0x15
		"",//0x16
		"",//0x17
		"",//0x18
		"",//0x19
		"",//0x1A
		"",//0x1B
		"",//0x1C
		"",//0x1D
		"",//0x1E
		"",//0x1F
		"",//0x20
		"SDAP",//0x21,
		"A2DP",//0x22,
		"AVRCP",//0x23,
#ifdef HID_Profile
		"HID",// = 0x24,
#else
		"",//0x24
#endif
		"MCSync",//0x25
		"",//0x26
		"",//0x27
		"",//0x28
		"",//0x29
		"",//0x2A
		"",//0x2B
		"",//0x2C
		"",//0x2D
		"",//0x2E
		"",//0x2F
		//SDAP Service Record
		"PNP",// = 0x30,
		"A2DP_SOURCE",//0x31,
		"A2DP_SINK",//0x32,
		"AVRCP_TG",//0x33,
		"AVRCP_CT",//0x34,
		"MPS"//0x35,
};

LOG_STRING char APP_BatStatusLogString[][MAX_LOG_STRING] =
{
	"BAT_WELL",	//CHARGER_OUT
	"BAT_LOW",	//CHARGER_OUT
	"BAT_CHARGER_IN",
	"BAT_CHARGER_RECHARGE",
	"BAT_CHARGING_FULL"
};

LOG_STRING char APP_CallHoldActiveLogString[][MAX_LOG_STRING] =
{
	"No call in Hold",
	"1 Active, others Hold",
	"All Hold"
};

LOG_STRING char APP_CallActiveLogString[][MAX_LOG_STRING] =
{
	"Call no Active",
	"Call Active,"
};

LOG_STRING char APP_CallSetupLogString[][MAX_LOG_STRING] =
{
	"CALLSETUP_NO_CALSETUP",
	"CALLSETUP_INCOMMING",
	"CALLSETUP_OUTGOING",
	"CALLSETUP_REMOTE_ALERTED",
};

LOG_STRING char APP_VoiceCommandLogString[][MAX_LOG_STRING] =
{
	"Stop_by_user",
	"Trigger_Bits:",
	"action_index",
	"event_bits",
	"Database_open_failed",
	"Database_address",  //5
	"Database_size",
	"MODE:",
	"DefaultIdentificationMode",
	"Top_state:",
	"EMPTY:", //10
	"Trigger_state_not_match",
	"Get_invalid_VC_dababase",
	"Media_event_actionIndex:",
	"table_index:",
	"VoiceCommand_Results:", //15
	"vc_Identification_Mode",
	"Get_Invalid_results",
	"Default_Mode",
	"EMPTY",
	"keyTriggerEvent", //20
	"NoVoiceCommandIdentified"
};

/* Audio Type */
LOG_STRING char APP_AudioTypeLogString[][MAX_LOG_STRING] =
{
	"AUDIO_NONE",
	"AUDIO_SCO",
	"AUDIO_A2DP",
	"AUDIO_ADDA",
	"AUDIO_VP",
	"AUDIO_RT",
	"AUDIO_MP3",
	"AUDIO_AIROTHRU",
	"AUDIO_LINEIN",
	"AUDIO_AMA",
	"AUDIO_STREAM_NO",
	"AUDIO_FAKE_EVT"
};


/* BT LIB String */

LOG_STRING char Rfcomm_Session_state_String[][MAX_LOG_STRING] =
{
    "RFCOMM_IDLE",
    "RFCOMM_L2CAP_CONNECTING",
    "RFCOMM_L2CAP_INCOMMING",
    "RFCOMM_L2CAP_ESTABLISHED",
    "RFCOMM_SESSION_CONNECTING",
    "RFCOMM_SESSION_ESTABLISHED",
    "RFCOMM_SESSION_DISC0_SENT_WAIT_UA",
    "RFCOMM_SESSION_JUST_CLOSED",
    "RFCOMM_L2CAP_DISCONNECTING",
    "RFCOMM_L2CAP_CONNECTING_FAIL",
    "RFCOMM_SESSION_CONNECTING_TIMEOUT",
    "RFCOMM_SESSION_CONNECTING_FAIL"
};

LOG_STRING char Rfcomm_Dlci_state_String[][MAX_LOG_STRING] =
{
    "DLC_NOT_ESTABLISHED",
    "DLC_ESTABLISHING_TIMEOUT",
    "DLC_ESTABLISHING_FAIL",
    "DLC_PN_RSP_SENT_WAIT_SABM",
    "DLC_PASSIVE_ESTABLISHED",
    "DLC_PN_SENT_WAIT_RSP",
    "DLC_PN_DONE",
    "DLC_SABM_SENT_WAIT_UA",
    "DLC_ACTIVE_ESTABLISHED",
    "DLC_MSC_SENT_WAIT_RSP",
    "DLC_MSC_ONEWAY_OK",
    "DLC_READY_FOR_DATA_COM",
    "DLC_DISC_SENT_WAIT_UA"
};

/* APP Audio DSP A2dp*/
LOG_STRING char APP_DSPA2dpNoSourceLogString[] = "[AUDIO DSP A2DP] A2dp Stream No Source";
LOG_STRING char APP_DSPA2dpNoSinkLogString[] = "[AUDIO DSP A2DP] A2dp Stream No Sink";
LOG_STRING char APP_DSPA2dpSbcDecoderLogString[] = "[AUDIO DSP A2DP] A2dp Stream SBC Decoder";
LOG_STRING char APP_DSPA2dpAacDecoderLogString[] = "[AUDIO DSP A2DP] A2dp Stream AAC Decoder";
LOG_STRING char APP_DSPA2dpCeltDecoderLogString[] = "[AUDIO DSP A2DP] A2dp Stream CELT Decoder";
LOG_STRING char APP_DSPA2dpCodecNotSupportLogString[] = "[AUDIO DSP A2DP] A2dp Stream Codec Not Support:%d";
LOG_STRING char APP_DSPA2dpNoTransformLogString[] = "[AUDIO DSP A2DP] A2dp Stream No Transform";
LOG_STRING char APP_DSPA2dpDspStopLogString[] = "[AUDIO DSP A2DP] A2dp Stream DSP Stop";
LOG_STRING char APP_DSPA2dpSourceTransformExistLogString[] = "[AUDIO DSP A2DP] A2dp Source Transform Exist";
LOG_STRING char APP_DSPA2dpSinkTransformExistLogString[] = "[AUDIO DSP A2DP] A2dp Sink Transform Exist";
LOG_STRING char APP_DSPA2dpSampleRateCodecString[] = "[AUDIO DSP A2DP] A2dp Codec:[%d], fsRate:[%d]";
LOG_STRING char APP_DSPA2dpChannelSelNvkeyErrorLogString[] = "[AUDIO DSP A2DP] Channel Selection Nvkey Error";
LOG_STRING char APP_DSPA2dpChannelSelNvkeyValueLogString[] = "[AUDIO DSP A2DP] Audio Channel Select Mode (HW/SW):%d, SW Channel Selection Value:%d, HW GPIO number:%d";
LOG_STRING char APP_DSPA2dpSWChannelSetting[] 				= "[AUDIO DSP A2DP] SW Channel setting:%d";
LOG_STRING char APP_DSPA2dpHWChannelSetting[] 				= "[AUDIO DSP A2DP] HW Channel setting";
LOG_STRING char APP_DSPA2dpNotMatchModeString[] 			= "[AUDIO DSP A2DP] Not Match Mode";
LOG_STRING char APP_DSPA2dpNotEnableChannelSelString[] 		= "[AUDIO DSP A2DP]Not Enable Channel Selection, Channel Setting:%d";
LOG_STRING char APP_DSPA2dpHWModeAudioChannelSettingString[]= "[AUDIO DSP A2DP]HW Mode, GPIO H audo channel value:%d, GPIO L audo channel value:%d";
LOG_STRING char APP_DSPA2dpSetAudioSelectString[] = "[AUDIO DSP A2DP]Set DSP Audio Select:%d";

LOG_STRING char APP_DSPA2dpFillRHODataErrorSetting[] 		= "[AUDIO DSP A2DP] Fill RHO data error";
LOG_STRING char APP_DSPA2dAssignRHODataErrorSetting[] 		= "[AUDIO DSP A2DP] Assign RHO data error";

LOG_STRING char APP_DSPA2dEnterA2dpStreamHandlerLogString[] = "[AUDIO DSP A2DP]Enter A2dp stream handler";
LOG_STRING char APP_DSPA2dcallSCOOpenHandlerLogString[] = "[AUDIO DSP A2DP]call SCO open handler";
LOG_STRING char APP_DSPA2dpSetPartnerInitWaitValueLogString[] = "[AUDIO DSP A2DP][Partner Later Join] Partner Set Initial Wait Value: %d";
LOG_STRING char APP_DSPA2dpSetPartnerLaterJoinLogString1[] = "[AUDIO DSP A2DP][Partner Later Join] Partner Set Later Join log string one";
LOG_STRING char APP_DSPA2dpSetPartnerLaterJoinLogString2[] = "[AUDIO DSP A2DP][Partner Later Join] Partner Set Later Join log string two";
LOG_STRING char APP_DSPA2dpSetPartnerLaterJoinLogString3[] = "[AUDIO DSP A2DP][Partner Later Join] Partner Set Later Join log string three";
LOG_STRING char APP_DSPA2dpOutOfSyncLogString[] 			= "[AUDIO DSP A2DP] a2dp out of sync, address: 0x%x%x";
LOG_STRING char APP_DSPA2dpOutOfSyncReInitDoneLogString[] 	= "[AUDIO DSP A2DP] a2dp out of sync, re-init done";




/* APP Audio DSP MP3*/
LOG_STRING char APP_DSPMP3HaveFilesInDriveLogString[] = "[MP3] There are Files in Drive";
LOG_STRING char APP_DSPMP3NoFileInDriveLogString[] = "[MP3] There is NO File in Drive";
LOG_STRING char APP_DSPMP3EmmcInitLogString[] = "[MP3] eMMC Init";
LOG_STRING char APP_DSPMP3SdcInitLogString[] = "[MP3] SDC Init";
LOG_STRING char APP_DSPMP3F2ParentRootLogString[] = "[MP3] FolderToParent: This Dir is root";
LOG_STRING char APP_DSPMP3F2ChildFailLogString[] = "[MP3] FolderToChild: Fail";
LOG_STRING char APP_DSPMP3FindEndFolderNoFolderLogString[] = "[MP3] FindEndFolder: No folder in this Dir";
LOG_STRING char APP_DSPMP3FindEndFolderUnknowErrorLogString[] = "[MP3] FindEndFolder: Unknown error";
LOG_STRING char APP_DSPMP3FNextRootLogString[] = "[MP3] FolderNext: This Dir is root";
LOG_STRING char APP_DSPMP3FNextRoot2LogString[] = "[MP3] FolderNext: This Dir is root 2";
LOG_STRING char APP_DSPMP3FNextRoot3LogString[] = "[MP3] FolderNext: This Dir is root 3";
LOG_STRING char APP_DSPMP3FNextUnknowErrorLogString[] = "[MP3] FolderNext: Unknown error";
LOG_STRING char APP_DSPMP3FPrevLogString[] = "[MP3] FolderPrev: This Dir is root";
LOG_STRING char APP_DSPMP3FPrevAFolderExistLogString[] = "[MP3] FolderPrev: At least a folder exist";
LOG_STRING char APP_DSPMP3FPrevUnknowErrorLogString[] = "[MP3] FolderPrev: Unknown error";
LOG_STRING char APP_DSPMP3FindTrackErrorLogString[] = "[MP3] Find Track Error:%d";
LOG_STRING char APP_DSPMP3NoMp3FileLogString[] = "[MP3] No MP3 File";
LOG_STRING char APP_DSPMP3FileSeekLogString[] = "[MP3] FileSeek[%d]";
LOG_STRING char APP_DSPMP3OpenFileFailLogString[] = "[MP3] OpenFile: Type:%d Fail";
LOG_STRING char APP_DSPMP3FileMountLogString[] = "[MP3] File Mount:%d";
LOG_STRING char APP_DSPMP3NoSourceLogString[] = "[MP3] Stream No Source";
LOG_STRING char APP_DSPMP3NoSinkLogString[] = "[MP3] Stream No Sink";
LOG_STRING char APP_DSPMP3CreateStreamPauseLogString[] = "[MP3] Create Stream but Pause";
LOG_STRING char APP_DSPMP3NoTransformLogString[] = "[MP3] Stream No Transform";
LOG_STRING char APP_DSPMP3TransformOkLogString[] = "[MP3] Stream Transform OK";
LOG_STRING char APP_DSPMP3DspStopLogString[] = "[MP3] Stream Dsp Stop";
LOG_STRING char APP_DSPMP3SourceExistLogString[] = "[MP3] Source Transform Exist";
LOG_STRING char APP_DSPMP3SinkExistLogString[] = "[MP3] Sink Transform Exist";
LOG_STRING char APP_DSPMP3NvkeyErrorLogString[] = "[MP3] NVKey Error!";

LOG_STRING char APP_DSPRtSetEventFailPlayingLogString[] = "[RT] Set Event Fail. RT is playing";
LOG_STRING char APP_DSPRtSetEventFailNotFoundEvtTableLogString[] = "[RT] Set Event Fail. Not found event table";
LOG_STRING char APP_DSPRtSetEventFailNotFoundIdLogString[] = "[RT] Set Event Fail. Not found RTid[0x%X]";
LOG_STRING char APP_DSPRtSetEventOkLogString[] = "[RT] Set Event:0x%X";
LOG_STRING char APP_DSPRtNoEventLogString[] = "[RT] Stream No Event";
LOG_STRING char APP_DSPRtNoSourceLogString[] = "[RT] Stream No Source";
LOG_STRING char APP_DSPRtNoSinkLogString[] = "[RT] Stream No Sink";
LOG_STRING char APP_DSPRtNoTransformLogString[] = "[RT] Stream No Transform";
LOG_STRING char APP_DSPRtTransformOkLogString[] = "[RT] Stream Transform OK";
LOG_STRING char APP_DSPRtDspStopLogString[] = "[RT] Stream DSP Stop";
LOG_STRING char APP_DSPRtSourceTransformExistLogString[] = "[RT] Source Transform Exist";
LOG_STRING char APP_DSPRtSinkTransformExistLogString[] = "[RT] Sink Transform Exist";
LOG_STRING char APP_DSPRtSourceEndLogString[] = "[RT] Source End";
LOG_STRING char APP_DSPRtSinkEndLogString[] = "[RT] Sink End";

LOG_STRING char APP_DSPScoTxTransformCloseLogString[] = "[SCO] Tx Transform Close";
LOG_STRING char APP_DSPScoTxSourceTransformExistLogString[] = "[SCO] Tx Source Transform Exist";
LOG_STRING char APP_DSPScoTxSinkTransformExistLogString[] = "[SCO] Tx Sink Transform Exist";
LOG_STRING char APP_DSPScoTxLightMonoModeOnLogString[] = "[SCO] Tx Light Mono Mode On";
LOG_STRING char APP_DSPScoTxNoSourceLogString[] = "[SCO] Tx No Source";
LOG_STRING char APP_DSPScoTxCvsdLogString[] = "[SCO] Tx CVSD";
LOG_STRING char APP_DSPScoTxMsbcLogString[] = "[SCO] Tx mSBC";
LOG_STRING char APP_DSPScoTxNoSinkLogString[] = "[SCO] Tx No Sink";
LOG_STRING char APP_DSPScoTxNoTransformLogString[] = "[SCO] Tx No Transform";
LOG_STRING char APP_DSPScoTxTransformOkLogString[] = "[SCO] Tx Transform OK";
LOG_STRING char APP_DSPScoRxTransformCloseLogString[] = "[SCO] Rx Transform Close";
LOG_STRING char APP_DSPScoRxSourceTransformExistLogString[] = "[SCO] Rx Source Transform Exist";
LOG_STRING char APP_DSPScoRxSinkTransformExistLogString[] = "[SCO] Rx Sink Transform Exist";
LOG_STRING char APP_DSPScoRxNoSourceLogString[] = "[SCO] Rx No Source";
LOG_STRING char APP_DSPScoRxNoSinkLogString[] = "[SCO] Rx No Sink";
LOG_STRING char APP_DSPScoRxCvsdLogString[] = "[SCO] Rx CVSD";
LOG_STRING char APP_DSPScoRxMsbcLogString[] = "[SCO] Rx mSBC";
LOG_STRING char APP_DSPScoRxNoTransformLogString[] = "[SCO] Rx No Transform";
LOG_STRING char APP_DSPScoRxTransformOkLogString[] = "[SCO] Rx Transform OK";
LOG_STRING char APP_DSPScoErrorCodecLogString[] = "[SCO] Error Codec:[%d]";
LOG_STRING char APP_DSPScoEnterSCOStreamHandlerLogString[] = "[SCO] Enter SCO stream handler";
LOG_STRING char APP_DSPScoCallA2dpStartHandlerHandlerLogString[] = "[SCO] call a2dp start handler";
LOG_STRING char APP_DSPScoEnterSCOOpenHandlerLogString[] = "[SCO] Enter SCO Open handler";
LOG_STRING char APP_DSPScoRxSideToneEnableLogString[] = "[SCO] Rx Side Tone Enable";
LOG_STRING char APP_DSPScoRxSideToneDisableLogString[] = "[SCO] Rx Side Tone Disable";



LOG_STRING char APP_DSPSideToneExcessVolLogString[] = "[Side Tone] Excess Volume Range";
LOG_STRING char APP_DSPSideToneNoSourceLogString[] = "[Side Tone] No Source";
LOG_STRING char APP_DSPSideToneNoSinkLogString[] = "[Side Tone] No Sink";
LOG_STRING char APP_DSPSideToneOnLogString[] = "[Side Tone] On Vol:%d";
LOG_STRING char APP_DSPSideToneOffLogString[] = "[Side Tone] Off";
LOG_STRING char APP_DSPSideToneCloseDaLogString[] = "[Side Tone] Close DA";
LOG_STRING char APP_DSPSideToneCloseAdLogString[] = "[Side Tone] Close AD";

LOG_STRING char APP_DSPVcPathExistLogString[] = "[VC] Stream path has existed";
LOG_STRING char APP_DSPVcNoSourceLogString[] = "[VC] Stream No Source";
LOG_STRING char APP_DSPVcNoSinkLogString[] = "[VC] Stream No Sink";
LOG_STRING char APP_DSPVcPathNotExistLogString[] = "[VC] Stream path not exist";
LOG_STRING char APP_DSPVcTransformOkLogString[] = "[VC] Stream Transform OK";
LOG_STRING char APP_DSPVcTransformNotOkLogString[] = "[VC] Stream Transform Not OK";
LOG_STRING char APP_DSPVcTransformHasExistedLogString[] = "[VC] Stream Transform has existed";
LOG_STRING char APP_DSPVcSourceTransformExistLogString[] = "[VC] Stream Source Transform Exist";
LOG_STRING char APP_DSPVcSinkTransformExistLogString[] = "[VC] Stream Sink Transform Exist";

LOG_STRING char APP_DSPVpSetEventFailPlayingLogString[] = "[VP] Set Event Fail. isPlay:%d VPid[0x%X]";
LOG_STRING char APP_DSPVpSetEventFailNoLangLogString[] = "[VP] Set Event Fail. No language[%d]";
LOG_STRING char APP_DSPVpSetEventFailNoIdLogString[] = "[VP] Set Event Fail. Not found VPid[0x%X]";
LOG_STRING char APP_DSPVpSetEventOkLogString[] = "[VP] Set Event:0x%X";
LOG_STRING char APP_DSPVpGetFileIdNoteLogString[] = "[VP] SetEvent:%d CurrentEvt:%d PlayedCnt:%d/%d";
LOG_STRING char APP_DSPVpGetFileIdLogString[] = "[VP] Get File ID: 0x%x";
LOG_STRING char APP_DSPVpNoFileIdTableLogString[] = "[VP] No File ID Table";
LOG_STRING char APP_DSPVpEventEndLogString[] = "[VP] Stream VP Event End";
LOG_STRING char APP_DSPVpNoThisFileLogString[] = "[VP] Stream No This File";
LOG_STRING char APP_DSPVpNoSourceLogString[] = "[VP] Stream No Source";
LOG_STRING char APP_DSPVpNoSinkLogString[] = "[VP] Stream No Sink";
LOG_STRING char APP_DSPVpNoTransformLogString[] = "[VP] Stream No Transform";
LOG_STRING char APP_DSPVpTransformOkLogString[] = "[VP] Stream Transform OK";
LOG_STRING char APP_DSPVpNextEndLogString[] = "[VP] Stream Next End";
LOG_STRING char APP_DSPVpNextErrorLogString[] = "[VP] Stream Next Error";
LOG_STRING char APP_DSPVpNextNoFileLogString[] = "[VP] Stream Next No File";
LOG_STRING char APP_DSPVpNextOkLogString[] = "[VP] Stream Next OK";
LOG_STRING char APP_DSPVpDspStopLogString[] = "[VP] Stream Dsp Stop";
LOG_STRING char APP_DSPVpSourceTransformExistLogString[] = "[VP] Source Transform Exist";
LOG_STRING char APP_DSPVpSinkTransformExistLogString[] = "[VP] Sink Transform Exist";
LOG_STRING char APP_DSPVpSourceEndLogString[] = "[VP] Source End";
LOG_STRING char APP_DSPVpSinkEndLogString[] = "[VP] Sink End";
LOG_STRING char APP_DSPVpInitFailLogString[] = "[VP] Init Fail";

/* APP AUDIO BIST*/
LOG_STRING char APP_AudioBist_SilenceStartLogString[] 	= "[APP AUDIO BIST] CP BIST[Silence] Start";
LOG_STRING char APP_AudioBist_SilenceStopLogString[] 	= "[APP AUDIO BIST] CP BIST[Silence] Stop";
LOG_STRING char APP_AudioBist_ResultPassString[] 		= "[APP AUDIO BIST] Result Pass";
LOG_STRING char APP_AudioBist_ResultFailLogString[] 	= "[APP AUDIO BIST] Result Fail: %s Pull High";
LOG_STRING char APP_AudioBist_ADDANoSourceLogString[] 	= "[APP AUDIO BIST] ADDA No source";
LOG_STRING char APP_AudioBist_ADDANoSinkLogString[] 	= "[APP AUDIO BIST] ADDA No sink";
LOG_STRING char APP_AudioBist_ADDANoTransformLogString[] 	= "[APP AUDIO BIST] ADDA No transform";
LOG_STRING char APP_AudioBist_ADDATransformOKLogString[] 	= "[APP AUDIO BIST] ADDA Transform OK";
LOG_STRING char APP_AudioBist_ADDATransformExistedLogString[] 	= "[APP AUDIO BIST] ADDA Transform existed";
LOG_STRING char APP_AudioBist_I2STransformExistedLogString[] 	= "[APP AUDIO BIST] I2S Transform existed";
LOG_STRING char APP_AudioBist_I2SRoleErrorLogString[] 	= "[APP AUDIO BIST] I2S Role error: %d/%d";
LOG_STRING char APP_AudioBist_I2SNoSourceLogString[] 	= "[APP AUDIO BIST] I2S No source";
LOG_STRING char APP_AudioBist_I2SNoSinkLogString[] 	= "[APP AUDIO BIST] I2S No sink";
LOG_STRING char APP_AudioBist_I2SNoTransformLogString[] 	= "[APP AUDIO BIST] I2S No transform";
LOG_STRING char APP_AudioBist_I2STransformOKLogString[] 	= "[APP AUDIO BIST] I2S transform OK";
LOG_STRING char APP_AudioBist_SPDIFTransformExistedLogString[] 	= "[APP AUDIO BIST] SPDIF Transform existed";
LOG_STRING char APP_AudioBist_SPDIFNoSourceLogString[] 				= "[APP AUDIO BIST] SPDIF No source";
LOG_STRING char APP_AudioBist_SPDIFNoSinkLogString[] 	= "[APP AUDIO BIST] SPDIF No sink";
LOG_STRING char APP_AudioBist_SPDIFTransformOKLogString[] 	= "[APP AUDIO BIST] SPDIF transform OK";
LOG_STRING char APP_AudioBist_SPDIFNoTransformLogString[] 	= "[APP AUDIO BIST] SPDIF No transform";
LOG_STRING char APP_AudioBist_CPBistInvalidModeLogString[] 	= "[APP AUDIO BIST] CP BIST[%d] Invalid Mode";
LOG_STRING char APP_AudioBist_CPBistStartLogString[] 	= "[APP AUDIO BIST] CP BIST[%s] Start";
LOG_STRING char APP_AudioBist_CPBistForceStopLogString[] 	= "[APP AUDIO BIST] CP BIST[%s] Force Stop";
LOG_STRING char APP_AudioBist_CPBistStopLogString[] 	= "[APP AUDIO BIST] CP BIST[%s] Stop";
LOG_STRING char APP_AudioBist_hiiiiiiiiiiiiLogString[] 	= "[APP AUDIO BIST] hiiiiiiiiiiiiiiiiiiiiiii";
LOG_STRING char APP_AudioBist_CPBistTimeoutLogString[] 	= "[APP AUDIO BIST] CP BIST[%s] Timeout";
LOG_STRING char APP_AudioBist_CPBistTestLogString[] 	= "[APP AUDIO BIST] APP_AudioBIST_TestCmd";
LOG_STRING char APP_AudioBist_ThresholdSNPLogString[] 	= "[APP AUDIO BIST] Threshold SNP:%d/%d THD_N:%d/%d";
LOG_STRING char APP_AudioBist_BistResultLogString[] 	= "[APP AUDIO BIST] CP BIST Result[%s]: SNP:%d THD_N:%d";


/* APP Audio MIC Test*/
LOG_STRING char APP_AudioMic_NoMicToSpkTransformLogString[] 	= "[APP AUDIO MIC Test] NO mic to spk transform";
LOG_STRING char APP_AudioMic_MictoSpkExistedLogString[] 		= "[APP AUDIO MIC Test] mic to spk existed";
LOG_STRING char APP_AudioMic_MictoSpkNoSourceLogString[] 		= "[APP AUDIO MIC Test] mic to spk no source";
LOG_STRING char APP_AudioMic_MictoSpkNoSinkLogString[] 			= "[APP AUDIO MIC Test] mic to spk no sink";
LOG_STRING char APP_AudioMic_MictoSpkNoTransLogString[] 		= "[APP AUDIO MIC Test] No Transform ";
LOG_STRING char APP_AudioMic_MictoSpkTransOKLogString[] 		= "[APP AUDIO MIC Test] Transform OK";
LOG_STRING char APP_AudioMic_MictoSpkTransCloseLogString[] 		= "[APP AUDIO MIC Test] Transform Close";
LOG_STRING char APP_AudioMic_MictoSpkSourceSinkCloseLogString[] = "[APP AUDIO MIC Test] Source Sink Close";

LOG_STRING char APP_DSPAmaAudioPathInitFailLogString[] 		= "[AUDIO DSP AMA] Audio Path Init Failed";
LOG_STRING char APP_DSPAmaAudioPathParaLogString[] 			= "[AUDIO DSP AMA] Audio Path PARA: %x %x %x %x %x";
LOG_STRING char APP_DSPAmaAudioSourceSinkExistLogString[] 	= "[AUDIO DSP AMA] Audio Source and Sink Exist";
LOG_STRING char APP_DSPAmaStreamStartLogString[] 			= "[AUDIO DSP AMA] Ama Stream Start - bdaddr : 0x%x%x";
LOG_STRING char APP_DSPAmaStreamStopLogString[] 			= "[AUDIO DSP AMA] Ama Stream Stop";
LOG_STRING char APP_DSPAma2MicEnableLogString[] 			= "[AUDIO DSP AMA] 2-MIC enable";
LOG_STRING char APP_DSPAma1MicEnableLogString[] 			= "[AUDIO DSP AMA] 1-MIC enable";





LOG_STRING char A2DP_Rx_CMD_String[] = "[   A2DP] Rx Cmd - %s. BdAddr:0x%x%x, State:%d, Substate:%d";
LOG_STRING char A2DP_Tx_RSP_Accept_String[] = "[   A2DP] Tx Rsp Accept - %s. BdAddr:0x%x%x";
LOG_STRING char A2DP_Tx_RSP_Reject_String[] = "[   A2DP] Tx Rsp Reject - %s. BdAddr:0x%x%x, Error:0x%x";
LOG_STRING char A2DP_Rx_RSP_Accept_String[] = "[   A2DP] Rx Rsp Accept - %s. BdAddr:0x%x%x, State:%d, Substate:%d";
LOG_STRING char A2DP_Rx_RSP_Reject_String[] = "[   A2DP] Rx Rsp Reject - %s. BdAddr:0x%x%x, State:%d, Substate:%d";

LOG_STRING char A2DP_Tx_Discover_Data_String[] = "[   A2DP] Tx Rsp Accept - Discover. seidNum:%d, tsep:0x%x, 0x%x, PreferSeid:0x%x";
LOG_STRING char A2DP_Tx_GetCap_Data_String[] = "[   A2DP] Tx Rsp Accept - GetCapability. acpSeid:%d, delayReportSize:%d, capSize:%d";
LOG_STRING char A2DP_Tx_SetConfig_Data_String[] = "[   A2DP] Tx Rsp Accept - SetConfiguration. acpSEID:%d, intSEID:0x%x";
LOG_STRING char A2DP_Tx_GetConfig_Data_String[] = "[   A2DP] Tx Rsp Accept - GetConfiguration. Set SCMS:%d, DelayReport:%d, localSEID:%d";
LOG_STRING char A2DP_Tx_Reconfig_Data_String[] = "[   A2DP] Tx Rsp Accept - Reconfiguration. acpSEID:%d";
LOG_STRING char A2DP_Tx_CMD_String[] = "[   A2DP] Tx Cmd - %s. BdAddr:0x%x%x, State:%d, Substate:%d, diffDelay:%d";
LOG_STRING char A2DP_CODEC_String[] = "[   A2DP] Set Codec - %s. BdAddr:0x%x%x";
LOG_STRING char A2DP_SBC_String[] = "SBC";
LOG_STRING char A2DP_AAC_String[] = "AAC";
LOG_STRING char A2DP_CELT_String[] = "CELT";
LOG_STRING char A2DP_Vendor_String[] = "Vendor Codec";
LOG_STRING char A2DP_SCMS_String[] = "[   A2DP] Set SCMS:%d, DelayReport:%d, BdAddr:0x%x%x";
LOG_STRING char A2DP_REQ_String[] = "[   A2DP] Tx Req - %s. BdAddr:0x%x%x. MTU:%d";
LOG_STRING char A2DP_IND_String[] = "[   A2DP] Rx Ind - %s. BdAddr:0x%x%x";
LOG_STRING char A2DP_CFM_String[] = "[   A2DP] Rx Cfm - %s: %d. BdAddr:0x%x%x";
LOG_STRING char A2DP_RSP_String[] = "[   A2DP] Tx Rsp - %s: %s. BdAddr:0x%x%x";
LOG_STRING char A2DP_StateSubState_String[] = "[   A2DP] BdAddr:0x%x%x, State:%d, Substate:%d";
LOG_STRING char A2DP_EstMediaChannelTime_String[] = "[   A2DP] NvKeyEstMediaChannelTime:%d mS";
LOG_STRING char A2DP_IsMediaPlay_String[] = "[   A2DP] Set IsMediaPlay:%d. BdAddr:0x%x%x";
LOG_STRING char A2DP_DiscoverCmdPara_String[] = "[   A2DP] Tx Discover Cmd tsep:%d. preferSeid:%d";
LOG_STRING char A2DP_CommonTimeOut_String[] = "[   A2DP] Common Time out BdAddr:0x%x%x, State:%d, Substate:%d";
LOG_STRING char A2DP_SEID_String[] = "[   A2DP] Seid [%d] :tsep %d, in-Use:%d, mediaType:%d; target tsep:%d; count:%d";
LOG_STRING char A2DP_GetCapaCmdPara_String[] = "[   A2DP] Tx %s Cmd Seid:%d";
LOG_STRING char A2DP_SetConfig_String[] = "[   A2DP] Tx %s Cmd remote Seid:%d, local Seid:%d";
LOG_STRING char A2DP_GetConfigSize_String[] = "[   A2DP] Get config size:%d";
LOG_STRING char A2DP_GetConfigData_String[] = "[   A2DP] Get config Data:%d";
LOG_STRING char A2DP_SetMediaPlay_String[] = "[   A2DP] Set isMediaPlay:%d, BdAddr:0x%x%x";
LOG_STRING char A2DP_GetAACInfo_String[] = "[   A2DP] Get AAC Index info, role:%x, sampleRate1:%x, sampleRate2:%x";
LOG_STRING char A2DP_GetSBCInfo_String[] = "[   A2DP] Get SBC Index info, role:%x, sampleRate:%x";


LOG_STRING char Connect_String[] = "Connect";
LOG_STRING char Disconnect_String[] = "Disconnect";
LOG_STRING char MediaConnect_String[] = "Media Connect";
LOG_STRING char MediaDisconnect_String[] = "Media Disconnect";
LOG_STRING char Register_String[] = "Register";
LOG_STRING char UnRegister_String[] = "UnRegister";
LOG_STRING char NoApp_String[] = "No App";
LOG_STRING char NoResource_String[] = "No Resource";
LOG_STRING char Success_String[] = "Success";
LOG_STRING char Conflict_String[] = "Conflict";
LOG_STRING char AppReject_String[] = "App Reject";
LOG_STRING char Unknown_ID_String[] = "Unknown ID";
LOG_STRING char Accept_ID_String[] = "Accept";

LOG_STRING char AVDTP_SignalIDString[][MAX_LOG_STRING] ={
	"Unsupport",
	"Discover",
	"Get Capabilities",
	"Set Configuration",
	"Get Configuration",
	"Reconfigure",
	"Open",
	"Start",
	"Close",
	"Suspend",
	"Abort",
	"Security Control",
	"Get All Capabilities",
	"Delay Report",
};

/* AWS MCE*/
LOG_STRING char MCSync_IFhandler_String[] = "[MCSync] Get IFPkt, Type(%d)(%s) Length(%d)";

LOG_STRING char MCSync_IFType_String[][MAX_LOG_STRING] =
{
	"IF_TYPE_NONE",
	"IF_TYPE_A2DP",
	"IF_TYPE_SCO",
	"IF_TYPE_APP",
	"IF_TYPE_REPORT_RESET",
	"IF_TYPE_ROLE_HANDOVER",
	"IF_TYPE_PARTNER_SELECTION",
	"IF_TYPE_MIC_SELECTION",
	"IF_TYPE_RACE",
};

LOG_STRING char MCSYNC_SendIFPkt_StartString[] = "[MCSync] Start Sending IF Packet type:%s(0x%x), opCode:%s(0x%x), Result:(%d)";
LOG_STRING char MCSYNC_SendIFPkt_ErrorString1[] = "[MCSync] Send IF - invalid value or length";
LOG_STRING char MCSYNC_SendIFPkt_ErrorString2[] = "[MCSync] Send IF - ClaimSize(%d), SinkSlack:(%d)";
LOG_STRING char MCSync_IFPkt_APP_LogString[] = "[MCSync] APP Type - OpCode(%d)(%s):";
LOG_STRING char MCSYNC_SendIFPkt_AACCodecSetting[] = "[MCSync] AAC CodecSetting: %x %x %x %x %x %x";
LOG_STRING char MCSYNC_SendIFPkt_SBCCodecSetting[] = "[MCSync] SBC CodecSetting: %x %x %x %x";
LOG_STRING char MCSYNC_SendIFPkt_SyncSCO[] = "[MCSync] Send Sync SCO - speakSound:%d, micSound:%d, scoState:%d, topState:%d";
LOG_STRING char MCSYNC_SendIFPkt_SyncLED1[] = "[MCSync] Send Sync LED - patternIdx:%d, overWriteTime:%d, isOverWrite:%d, clockToStart:%d, action:%d";
LOG_STRING char MCSYNC_SendIFPkt_SyncLED3[] = "[MCSync] Send Sync LED - ptnType0:%d, ptnType1:%d, ptnType2:%d";
LOG_STRING char MCSYNC_SendIFPkt_SyncDSP1[] = "[MCSync] Send Sync DSP - clockToStart:%d, Length:%d";
LOG_STRING char MCSYNC_SendIFPkt_SyncDSP2[] = "[MCSync] Send Sync DSP - data0:%d, data1:%d, data2:%d";
LOG_STRING char MCSYNC_SendIFPkt_SyncCallerID[] = "[MCSync] Caller ID:%d";
LOG_STRING char MCSYNC_SendIFPkt_SyncCallerInfo[] = "[MCSync]Caller IF Opcode:%d, Length:%d";
LOG_STRING char MCSYNC_SendIFPkt_SyncA2DP[] = "[MCSync][Partner] A2DP CID:0x%x, codec:%d, SCMS:%d, BdAddr:0x%x%x";
LOG_STRING char MCSYNC_SendIFPkt_SyncSBCCodecType[] = "[MCSync][Partner] SBC Codec info:%d %d %d %d";
LOG_STRING char MCSYNC_SendIFPkt_SyncAACCodecType[] = "[MCSync][Partner] AAC Codec info:%d %d %d %d %d %d";
LOG_STRING char MCSync_SendIFPkt_SyncPowerOff[] = "[MCSync] Send Sync PowerOff, reason:(%d)";
LOG_STRING char MCSync_GetNormalLinkString[] = "[MCSync] Get Normal BdAddr:0x%x%x";
LOG_STRING char MCSync_GetSpecialLinkString[] = "[MCSync] Get Special BdAddr:0x%x%x";
LOG_STRING char MCSync_GetNullLinkString[] = "[MCSync] Get Null BdAddr:NULL!!!";
LOG_STRING char MCSYNC_SendIFPkt_SyncVPRT[] = "[MCSync] Send Sync VPRT - CurrentClock:%d, overWriteTime:%d, EvtId:0x%x, rtId:%d, vpId:%d";
LOG_STRING char MCSync_SlaveGetSyncVpRtIndexString[] = "[MCSync] Slave RtIndex:%d, VpIndex:%d";
LOG_STRING char MCSync_SlaveGetSyncInfoString[] = "[MCSync] Slave Event index: %d, currentPickClock:%d, overwriteTime:%d";
LOG_STRING char MCSync_PartnerGetCallerIDLengthString[] = "[MCSync] Partner end, caller ID length:%d";
LOG_STRING char MCSync_PartnerGetCallerIDNumberString[] = "[MCSync] Partner end, caller ID Number:%d";
LOG_STRING char MCSync_AgentSendCallerIDNumberString[] = "[MCSync] Agent end, caller ID Number:%d";
LOG_STRING char MCSync_CallerIdAddrString[] = "[MCSync] Caller ID addr:%x %x %x %x %x %x";
LOG_STRING char MCSYNC_SendIFPkt_SyncLinkList[] = "[MCSync] Send Sync Link List - length:%d, data0:0x%x, data1:0x%x, data2:0x%x";
LOG_STRING char MCSYNC_SendIFPkt_SyncBleLinkList[] = "[MCSync] Send Sync Ble Link List - length:%d, data0:0x%x, data1:0x%x, data2:0x%x";
LOG_STRING char MCSYNC_SendIFPkt_SyncAmaData[] = "[MCSync] Send Sync Ama Data - length:%d, data0:0x%x, data1:0x%x, data2:0x%x";
LOG_STRING char MCSYNC_SendIFPkt_SyncReconnectState[] = "[MCSync] Send Sync Reconnect State. type:%d, BdAddr:0x%x%x";
LOG_STRING char MCSYNC_SendIFPkt_SyncReconnectMask[] = "[MCSync] Send Sync Not Reconnect Mask:0x%x";


LOG_STRING char MCSync_IF_AppOpcode_String[][MAX_LOG_STRING] =
{
	"MCSync_APP_SYNC_STATE",
	"MCSync_APP_SYNC_KEY_ACTION",
	"MCSync_APP_SYNC_ANC",
	"MCSync_APP_SYNC_VP_IS_ENABLE",
	"MCSync_APP_SYNC_AIROTHRU",
	"MCSync_APP_SYNC_LED",
	"MCSync_APP_SYNC_AGNUM",
	"MCSync_APP_SYNC_VPRT",
	"MCSync_APP_SYNC_STOP_VPRT",
	"MCSYNC_APP_SYNC_VPRT_PLAY_LATER",
	"MCSync_APP_SYNC_CALLER_ID",
	"MCSync_APP_SYNC_PEQ_REALTIME",
	"MCSync_APP_SYNC_BDADDR",
	"MCSync_APP_SYNC_VP_LANG_INDEX",
	"MCSync_APP_SYNC_DSP",
	"MCSync_APP_SYNC_RHO_PARA",
	"MCSYNC_APP_SYNC_SMT_CHG_CSE",
	"MCSync_APP_SYNC_POWEROFF",
	"MCSync_APP_SYNC_KEYCODE_ACTION",
	"MCSync_APP_SYNC_RHO_STATE",
	"MCSYNC_APP_SYNC_SMART_CHARGE_CASE_STATE",
	"MCSYNC_APP_SYNC_LINK_LIST",
	"MCSYNC_APP_SYNC_RECONNECT_STATE",
	"MCSYNC_APP_SYNC_RECONNECT_MASK",
	"MCSYNC_APP_SYNC_GFP",
	"MCSYNC_APP_SYNC_FCD",
	"MCSYNC_APP_SYNC_CLEAR_LINK_KEY",
	"MCSYNC_APP_SYNC_BLE_LINK_LIST",
	"MCSYNC_APP_SYNC_AMA_DATA",
	"MCSYNC_APP_SYNC_GENERAL_DATA",
	"MCSYNC_APP_SYNC_IN_EAR_DETECTION_STATUS",
	"MCSync_APP_OPCODE_UNKNOW",
};

/* APP MCSync */
LOG_STRING char MCSync_SYNC_A2DP_String1[] = "[APP MCSync][Partner] : Sync A2DP, absVol(%d), sound(%d), peqIndex(%d), codec(%d), isGameMode(%d), numofAg(%d)";
LOG_STRING char MCSync_SYNC_A2DP_String2[] = "[APP MCSync][Partner] : Sync A2DP, state(%d), streaming(%d), Addr(0x%x%x)";
LOG_STRING char MCSync_SYNC_A2DP_String3[] = "[APP MCSync][Partner] : Sync A2DP, sampleRate Index :%d";
LOG_STRING char MCSync_SYNC_A2DP_AAC_SampleRate_String[] = "[APP MCSync][Partner] : Sync A2DP, AAC sampleRate1:%x, sampleRate2:%x";
LOG_STRING char MCSync_SYNC_A2DP_SBC_SampleRate_String[] = "[APP MCSync][Partner] : Sync A2DP, SBC sampleRate:%x";
LOG_STRING char MCSync_SYNC_SCO_String[] = "[APP MCSync][Partner] : Sync SCO, speakSound(%d), micSound(%d), scoState(%d), topState(%d)";
LOG_STRING char MCSync_SYNC_AgentState_String[] = "[APP MCSync][Partner] Sync Agent State(%d)(%s)";
LOG_STRING char MCSync_SYNC_RhoState_String[] = "[APP MCSync][Partner] Sync RHO State(%d)";
LOG_STRING char MCSync_SYNC_SmartChargeCaseState_String[] = "[APP MCSync][Agent] Sync Partner SmartChgCase State(%d)";
LOG_STRING char MCSync_SYNC_ClientKeyCode_String[] = "[APP MCSync][Agent] Sync Key Code : Partner keyEventCode(0x%x)(%s), Partner supportedState(0x%x)";
LOG_STRING char MCSync_SYNC_ANC_String[] = "[APP MCSync][Partner] : Sync ANC, status(%d)";
LOG_STRING char MCSync_SYNC_Airothru_String[] = "[APP MCSync][Partner] : Sync AiroThru, status(%d)";
LOG_STRING char MCSync_SYNC_LED_String1[] = "[APP MCSync][Partner] : Sync LED, patternIndex(%d), patternType(%d), loopTimes(%d)";
LOG_STRING char MCSync_SYNC_LED_String2[] = "[APP MCSync][Partner] : Sync LED, overwrtieTime(%d), isOverwrite(%d), clock(%d)";
LOG_STRING char MCSync_SYNC_AGNUM_String[] = "[APP MCSync][Partner] : Sync Num Of AG, numOfAG(%d)";
LOG_STRING char MCSync_SYNC_VPRT_String1[] = "[APP MCSync][Partner] : Sync VPRT, eventIndex(%d), currentPicoClock(%d)";
LOG_STRING char MCSync_SYNC_VPRT_String2[] = "[APP MCSync][Partner] : Sync VPRT, rtIndex(%d), vpIndex(%d), overwriteTime(%d)";
LOG_STRING char MCSync_SYNC_DSP_String1[] = "[APP MCSync][Partner] : Sync DSP, clockToStart(%d), length(%d)";
LOG_STRING char MCSync_SYNC_DSP_String2[] = "[APP MCSync][Partner] : Sync DSP, para0(%d), para1(%d), para2(%d)";
LOG_STRING char MCSync_SYNC_RHO_PARA_String[] = "[APP MCSync][Agent] : Sync RHO Para, batPercent(%d), rssi(%d)";
LOG_STRING char MCSync_SYNC_VPRT_DelayIndString1[] = "[APP MCSync][Partner] : Delay Ind Sync VPRT, eventIndex(%d), currentPicoClock(%d)";
LOG_STRING char MCSync_SYNC_VPRT_DelayIndString2[] = "[APP MCSync][Partner] : Delay Ind Sync VPRT, rtIndex(%d), vpIndex(%d), overwriteTime(%d)";
LOG_STRING char MCSync_RHO_NVKEY_INIT_FAIL_String[] = "[APP MCSync] nvkey init FAIL";
LOG_STRING char MCSync_RHO_DOMN_HANDLER_String[] = "[APP MCSync] RHO Dominator id:%d";
LOG_STRING char MCSync_RHO_DOMN_PARA_String[] = "[APP MCSync] RHO Dominator BatPercent:%d, RSSI:%d";
LOG_STRING char MCSync_RHO_NEEDED_PARA_String1[] = "[APP MCSync] RHO for %s: agent%d, partner:%d";
LOG_STRING char MCSync_RHO_NEEDED_PARA_String2[] = "[APP MCSync] RHO for %s: thre:%d, GapThre:%d";
LOG_STRING char MCSync_RHO_NEEDED_RESULT_String[] = "[APP MCSync] RHO Status:%s, Reason:%s";
LOG_STRING char MCSync_SYNC_VPRT_PlayLaterInd[] = "[APP MCSync] : Sync VPRT Play Later Ind. eventIndex(%d), clockToStart(%d)";
LOG_STRING char MCSync_SYNC_VPRT_PlayLater[] = "[APP MCSync] : Sync VPRT Play Later. eventIndex(%d), waitTime(%d), clockToStart(%d)";
LOG_STRING char MCSync_SYNC_SCOEvtIndA2dpStreamHandlerExist_String[] = "[APP MCSync][Partner] SCO evt ind A2dp stream handler exist";
LOG_STRING char MCSync_SYNC_SCOEvtIndA2dpStreamHandlerNotExist_String[] = "[APP MCSync][Partner] SCO evt ind A2dp stream handler Not exist";

LOG_STRING char MCSync_RHO_STATUS_String[][MAX_LOG_STRING] =
{
	"Not Allowed",
	"Not Cared",
	"Needed",
};

LOG_STRING char MCSync_RHO_REASON_String[][MAX_LOG_STRING] =
{
	"Battery",
	"RSSI",
};

LOG_STRING char MCSync_RHO_NEEDED_FOR_POWEROFF_String[] = "[APP MCSync] RHO for Power Off :%d, %d, %d, %d";
LOG_STRING char MCSync_RHO_NEEDED_FOR_CHARGIN_CASE_String[] = "[APP MCSync] RHO for Charging Case: %d, %d, %d, %d";
LOG_STRING char MCSync_IdleTimerCtlString[] = "[APP MCSync][Agent] AWS Idle Timer Ctl (%d)";
LOG_STRING char MCSync_SYNCPoweroffToPartnerString[] = "[APP MCSync][Agent] Sync PowerOff to Partner(%d)";
LOG_STRING char MCSync_SetAWSIdleTimerString[] = "[APP MCSync][Agent] Set AWS Idle Timer:%d s";
LOG_STRING char MCSync_AwsIdleTimerString[] = "[APP MCSync][Agent] AWS Idle Timer Time out, PowerOff!!";
LOG_STRING char MCSync_SyncKeyEventString[] = "[APP MCSync][Partner] Sync Key Event:%s";
LOG_STRING char MCSync_SPConnectedCfmCancelIdleTimerString [] = "[MCSync][Agent] SP connected, Cancel AWS Idle Timer";
LOG_STRING char MCSync_SPDisconnectedSetIdleTimerString[] = "[MCSync][Agent](with Partner) SP Disconnected, Set AWS Idle Timer";
LOG_STRING char MCSync_PartnerDisconnectedCancelIdleTimerString[] = "[MCSync][Agent] Partner Disconnected, Cancel AWS Idle Timer";
LOG_STRING char MCSync_PartnerConnectedSetIdleTimerString[] = "[MCSync][Agent] Partner Connected, Set AWS Idle Timer";
LOG_STRING char MCSync_SyncAgentPowerOffString[] = "[MCSync][Partner] Sync Agent - PowerOff, reason(%d)";
LOG_STRING char MCSync_KeyEvent_Slink_String[] = "KeyEventHandler isspecial bdAddr:0x%x%x";
LOG_STRING char MCSync_SyncKeyEventIsNotPartner[] = "[APP MCSync] Keyevent : it's not Partner!!";
LOG_STRING char MCSync_NotSyncPowerOffString[] = "[APP MCSync] [Partner] not sync power off to Agent";
LOG_STRING char MCSync_PairingInitState[] = "[MCSync] Air Pairing Init State, default Role:0x%x";
LOG_STRING char MCSync_AppAwsRHONotAllowMsgNumberString[] = "[APP MCSync] AwsSystem RHO Not Allow Msg Number:%d";
LOG_STRING char MCSync_AppAwsRHOFillDataFailString[] = "[APP MCSync] Fill RHO data error";
LOG_STRING char MCSync_AppAwsRHOAssignDataFailString[] = "[APP MCSync] Assign RHO data error";
LOG_STRING char MCSync_AppAwsDecideRoleString1[] = "[APP_MCSync] Target Address == Local Address";
LOG_STRING char MCSync_AppAwsDecideRoleString2[] = "[APP_MCSync] Role is Agent";
LOG_STRING char MCSync_AppAwsDecideRoleString3[] = "[APP_MCSync] Role is Partner";
LOG_STRING char MCSync_APP_RoleModeChangeCfm_String[] = "[APP_MCSync] Role Mode Change Cfm. status:%d, defaultRole:0x%x";
LOG_STRING char MCSync_APP_ReconnectStateInd_String[] = "[APP_MCSync] Reconnect State Ind. type:%d, BdAddr:0x%x%x";
LOG_STRING char MCSync_APP_ReconnectMaskInd_String[] = "[APP_MCSync] Reconnect Mask Ind. notReconnMask:0x%x";

/* AWS MCE Profile */
LOG_STRING char MCSync_RegisterCfm_String[] = "[MCSync] Register Cfm status:%d";
LOG_STRING char MCSync_ConnectCfm_String[] = "[MCSync] Connect Cfm status:%d, Bdaddr:0x%x%x";
LOG_STRING char MCSync_StatusChangeInd_String[] = "[MCSync] Status Change Ind role:0x%x, Status %d, PowerStatus:%d, Bdaddr:0x%x%x";
LOG_STRING char MCSync_StatusChangeInd_StringFail[] = "[MCSync] Status Change Ind Fail";
LOG_STRING char MCSync_EnableDiscoverable_String[] = "[MCSync] EnableDiscoverable IsRoleChanging:%d, PowerStatus:%d, Bdaddr:0x%x%x, linkRole:%d";
LOG_STRING char MCSync_DisconnectInd_String[] = "[MCSync] Disconnect Ind Bdaddr:0x%x%x, currentRole:%d";
LOG_STRING char MCSync_SetRoleCfm_String[] = "[MCSync] Set Role Cfm role:0x%x, status:%d";
LOG_STRING char MCSync_GetCurrentPicoClockCfm_String[] = "[MCSync] Get Current Pico Clock Cfm status:%d, event:%d, clock:0x%x";
LOG_STRING char MCSync_RoleChangeInd_String[] = "[AWS MCE] RHO role change ind Status:%d, Role:0x%x";
LOG_STRING char MCSync_ReadAFHCfm_String[] = "[AWS MCE] ReadAFHCfm Status:%d enable:%d";
LOG_STRING char MCSync_WriteLocalBdAddrCfm_String[] = "[AWS MCE] WriteLocalBdAddrCfm Status:%d";
LOG_STRING char MCSync_WriteLocalBdAddr_String[] = "[AWS MCE] WriteLocalBdAddr:0x%x%x, role:0x%x";
LOG_STRING char MCSync_WriteLocalBdAddr_String2[] = "[AWS MCE] WriteLocalBdAddr Cfm, Status:%d, Role:0x%x, BdAddr:0x%x%x";
LOG_STRING char MCSync_GapHandlerUndefinedId_String[] = "[MCSync] GAP Handler Undefined ID:%d";
LOG_STRING char MCSync_ConnectCfmHandlerAssertString1[] = "[MCSync] MCSync_ConnectCfmHandler assert 1";
LOG_STRING char MCSync_ConnectCfmHandlerAssertString2[] = "[MCSync] MCSync_ConnectCfmHandler assert 2";
LOG_STRING char MCSync_ConnectCfmHandlerAssertString3[] = "[MCSync] MCSync_ConnectCfmHandler assert 3";
LOG_STRING char MCSync_CancelConnectionString[] = "[MCSync] Send Cancel Connection. Role:0x%x, BdAddr:0x%x%x";
LOG_STRING char MCSync_DisconnectMCSyncProfileString[] = "[MCSync] Disconnect MCSync Profile. Role:0x%x, BdAddr:0x%x%x";
LOG_STRING char MCSync_DirectlySetBdAddrString[] = "[MCSync] Air Pairing Partner Directly Set Device BdAddr. Role:0x%x, Agent BdAddr:0x%x%x";
LOG_STRING char MCSync_DisconnectSpecialLinkString[] = "[MCSync] Disconnect Special Link. Role:0x%x, BdAddr:0x%x%x";
LOG_STRING char MCSync_SetSingleHeadSetModeStateLogString[] = "[MCSync] Set Single Headset Mode State:%d";
LOG_STRING char MCSync_CancelConnectionCfmLogString[] = "[MCSync] Cancel Connection Cfm. Status:%d";
LOG_STRING char MCSync_IsAbleToConnectAwsLinkNotAllowLogString1[] = "[MCSync] IsAbleToConnectAwsLink not allow 1";
LOG_STRING char MCSync_IsAbleToConnectAwsLinkNotAllowLogString2[] = "[MCSync] IsAbleToConnectAwsLink not allow 2";
LOG_STRING char MCSync_IsAbleToConnectAwsLinkNotAllowLogString3[] = "[MCSync] IsAbleToConnectAwsLink not allow state:%d";
LOG_STRING char MCSync_SetMcsyncStateLogString[] = "[MCSync] Set MCSync state:%d => %d";
LOG_STRING char MCSync_ActivateProfileLogString[] = "[MCSync] Profile connected SetAgentSlave: BdAddr:0x%x%x";
LOG_STRING char MCSync_ActivateProfileLogString2[] = "[MCSync] Profile connected read AFH: BdAddr:0x%x%x";
LOG_STRING char MCSync_PartnerModeRoleChanging_String[] = "[MCSync] Partner Mode. Role Changing";
LOG_STRING char MCSync_PartnerModeStateNotNone_String[] = "[MCSync] Partner Mode. State:%d";
LOG_STRING char MCSync_PartnerModeNotAgent_String[] = "[MCSync] Partner Mode. Not Agent";
LOG_STRING char MCSync_PartnerModeNoPartnerBdAddr_String[] = "[MCSync] Partner Mode. No Partner BdAddr";
LOG_STRING char MCSync_PartnerModeAgNotDisconnected_String[] = "[MCSync] Partner Mode. AG Not Disconnected. AG state:%d";
LOG_STRING char MCSync_PartnerModeMCSyncConnected_String[] = "[MCSync] Partner Mode. Agent connected:%d";
LOG_STRING char MCSync_PartnerModeChangeStart_String[] = "[MCSync] Recovery Start Changing to Partner";
LOG_STRING char MCSync_AgentModeRoleChanging_String[] = "[MCSync] Agent Mode. Role Changing";
LOG_STRING char MCSync_AgentModeStateNotNone_String[] = "[MCSync] Agent Mode. State:%d";
LOG_STRING char MCSync_AgentModeNotPartner_String[] = "[MCSync] Agent Mode. Not Partner";
LOG_STRING char MCSync_AgentModeNoAgentBdAddr_String[] = "[MCSync] Agent Mode. No Agent BdAddr";
LOG_STRING char MCSync_AgentModeAgNotDisconnected_String[] = "[MCSync] Agent Mode. AG Not Disconnected:%d";
LOG_STRING char MCSync_AgentModeMCSyncConnected_String[] = "[MCSync] Agent Mode. Partner connected:%d";
LOG_STRING char MCSync_AgentModeChangeStart_String[] = "[MCSync] Recovery Start Changing to Agent";
LOG_STRING char MCSync_NvKeyInit_String[] = "[MCSync] NvKey Init. defaultRole:0x%x, localBdAddr:0x%x%x";
LOG_STRING char MCSync_NvKeyInit_String2[] = "[MCSync] NvKey Init. AgentBdAddr:0x%x%x, PartnerBdAddr:0x%x%x";

/* APP RHO */
LOG_STRING char APP_RHO_InitLogString[] = "[RHO] Init";
LOG_STRING char APP_RHO_GetNextActionReachEndLogString[] = "[RHO] GetNextAction reach end";
LOG_STRING char APP_RHO_ClearTxPacketLogString[] = "[RHO] Clear RHO Tx packet info";
LOG_STRING char APP_RHO_ClearRxPacketLogString[] = "[RHO] Clear RHO Rx packet info";
LOG_STRING char APP_RHO_FlowErrorLogString[] = "[RHO] FlowError: %d";
LOG_STRING char APP_RHO_NotAllowLogString[] = "[RHO] Not allow. ID:%d";
LOG_STRING char APP_RHO_LockFailedLogString[] = "[RHO] Lock failed. ID:%d";
LOG_STRING char APP_RHO_UnlockFailedLogString[] = "[RHO] Unlock failed. ID:%d";
LOG_STRING char APP_RHO_NewAgentDoneLogString[] = "[RHO] New Agent Done";
LOG_STRING char APP_RHO_CheckActionRelatedToRHOLogString[] = "[RHO] Start Checking Actions Related to RHO ";
LOG_STRING char APP_RHO_PowerOffAfterRhoLogString[] = "[RHO] Need to Power off after RHO";
LOG_STRING char APP_RHO_DeepSleepAfterRhoLogString[] = "[RHO] Need to Enter Deep sleep after RHO";
LOG_STRING char APP_RHO_PowerOffChargerCaseLogString[] = "[RHO] Need to Power off for charger case";
LOG_STRING char APP_RHO_ApplyPartnerDataLogString[] = "[RHO] Apply partner data";
LOG_STRING char APP_RHO_ApplyAgentDataLogString[] = "[RHO] Apply agent data";
LOG_STRING char APP_RHO_ApplyDataFailedLogString[] = "[RHO] Apply data failed. pData:0x%x length:%d";
LOG_STRING char APP_RHO_ApplyDataModuleLogString[] = "[RHO] Apply data Module ID/Idx:%d/%d Len:%d";
LOG_STRING char APP_RHO_ApplyDataWarningLogString[] = "[RHO] Apply data Warning!! %d/%d";
LOG_STRING char APP_RHO_CheckFotaLogString[] = "[RHO] Start fail: FOTAing";
LOG_STRING char APP_RHO_CheckRoleLogString[] = "[RHO] IsAgent:%d, withPartner:%d";
LOG_STRING char APP_RHO_CheckAgNumLogString[] = "[RHO] Link error. Num:%d";
LOG_STRING char APP_RHO_CheckFlowLogString[] = "[RHO] Start fail: Processing action:%d";
LOG_STRING char APP_RHO_CheckAgLinkLogString[] = "[RHO] Get AG bdAddr:0x%x%x";
LOG_STRING char APP_RHO_CheckAgNoLinkLogString[] = "[RHO] Error. No AG, ServiceBdaddr:0x%x%x";
LOG_STRING char APP_RHO_SetRhoFinishOkLogString[] = "[RHO] Set RHO finish OK";
LOG_STRING char APP_RHO_SetRhoFinishFailedLogString[] = "[RHO] Set RHO finish failed";
LOG_STRING char APP_RHO_CancelRhoCfmRetryLogString[] = "[RHO] Cancel RHO cfm. Do after:%d ms, retry:%d";
LOG_STRING char APP_RHO_CancelRhoCfmStopRetryLogString[] = "[RHO] Cancel RHO cfm. Stop retry RHO";
LOG_STRING char APP_RHO_CancelRhoCfmFailedLogString[] = "[RHO] Cancel RHO cfm FAIL. id:0x%x, status:0x%x";
LOG_STRING char APP_RHO_FlowWaitHandlerLogString[] = "[RHO] RhoFlowWaitHandler id:%d, action:%d";
LOG_STRING char APP_RHO_IsAllowRetryLogString[] = "[RHO] Is allow retry:%d after %d ms";
LOG_STRING char APP_RHO_IsAllowRetryStopLogString[] = "[RHO] Is allow stop retry";
LOG_STRING char APP_RHO_LockStopPrepareLogString[] = "[RHO] Have to stop prepare and do again later";
LOG_STRING char APP_RHO_GetDataLengthLogString[] = "[RHO] Get data module ID:%d Size:%d";
LOG_STRING char APP_RHO_GetDataTotalSizeLogString[] = "[RHO] Get data Size:%d";
LOG_STRING char APP_RHO_GetDataNoMemLogString[] = "[RHO] Get data no memory. Size:%d";
LOG_STRING char APP_RHO_GetDataFailedLogString[] = "[RHO] Get data failed. ModuleId:%d";
LOG_STRING char APP_RHO_GetDataWarningLogString[] = "[RHO] Get data Warning!! 0x%x/%x";
LOG_STRING char APP_RHO_SendRhoPacketLogString[] = "[RHO] Send RHO packet len %d";
LOG_STRING char APP_RHO_SendRhoPacketNullLogString[] = "[RHO] Send RHO packet NULL";
LOG_STRING char APP_RHO_ActionFlowLogString[] = "[RHO] Action Flow Handler: Flow:%d, Action:%d";
LOG_STRING char APP_RHO_ActionFlowWaitLogString[] = "[RHO] Action Flow Handler: Wait";
LOG_STRING char APP_RHO_ActionFlowErrorLogString[] = "[RHO] Action Flow Handler: Error";
LOG_STRING char APP_RHO_FlowProcessLogString[] = "[RHO] RhoFlowProcessHandler";
LOG_STRING char APP_RHO_FlowProcessNextLogString[] = "[RHO] RhoFlowProcessHandler Next";
LOG_STRING char APP_RHO_CurrentRoleNoneLogString[] = "[RHO] Current role NONE";
LOG_STRING char APP_RHO_CurrentRolePartnerLogString[] = "[RHO] Current role PARTNER";
LOG_STRING char APP_RHO_CurrentRoleAgentLogString[] = "[RHO] Current role AGENT";
LOG_STRING char APP_RHO_CurrentRoleUnknownLogString[] = "[RHO] Current role Unknown";
LOG_STRING char APP_RHO_CfmTimeoutLogString[] = "[RHO] Confirm timeout";
LOG_STRING char APP_RHO_StartLogString[] = "[RHO] Start";
LOG_STRING char APP_RHO_RecordRxPacketLogString[] = "[RHO] Record Rx RHO packet. Length:%d";
LOG_STRING char APP_RHO_RecordRxPacketNoAgentLogString[] = "[RHO] Record Rx RHO packet. Null Agent BdAddr";
LOG_STRING char APP_RHO_RoleChangeIndToPartnerLogString[] = "[RHO] RoleChangeInd: Agent to Partner. status:%d";
LOG_STRING char APP_RHO_AgentChangeToPartnerOkLogString[] = "[RHO] Agent change to Partner OK";
LOG_STRING char APP_RHO_RoleChangeIndToAgnetLogString[] = "[RHO] RoleChangeInd: Partner to Agent. status:%d";
LOG_STRING char APP_RHO_PartnerChangeToAgentOkLogString[] = "[RHO] Partner change to Agent OK";
LOG_STRING char APP_RHO_SetStateLogString[] = "[RHO] Set state:%d";
LOG_STRING char APP_RHO_SetStartClockLogString[] = "[RHO] Start Clock:%d";
LOG_STRING char APP_RHO_SetEndClockLogString[] = "[RHO] End Clock:%d, Processing time:%d ms";
LOG_STRING char APP_RHO_TimeCalculateErrorLogString[] = "[RHO] Time calculate error";
LOG_STRING char APP_RHO_PartnerDoneLogString[] = "[RHO] New Partner Done";
LOG_STRING char APP_RHO_ForceStopLogString[] = "[RHO] Force Stop. action:%d";

LOG_STRING char APP_RHO_MODULE_String[][MAX_LOG_STRING] =
{
	"Ctl Data",
	"Audio DSP",
	"Link Info",
	"Test Mode",
	"Race Cmd",
	"Power Off",
	"Pairing",
	"System",
	"Sniff",
	"Qos",
	"PEQ",
	"HFP",
	"Connection",
	"Aws Mce",
	"AVRCP",
	"A2DP" ,
	"AIRAPP"
};

LOG_STRING char APP_RHO_RM_PartnerConfigLogString[] = "[APP_LINKINFO] New Partner Sco Sink:0x%d, Bda:0x%x%x";
LOG_STRING char APP_RHO_RM_PartnerConfigNoLinkLogString[] = "[APP_LINKINFO] normal NULL no link";
LOG_STRING char APP_RHO_RM_IsAllowLogString[] = "[APP] %s RHO Not Allow Msg Number:%d";
LOG_STRING char APP_RHO_RM_AssignDataLogString[] = "[APP] Assign RHO data OK. bdAddr:0x%x%x";
LOG_STRING char APP_RHO_RM_AssignDataErrorLogString[] = "[APP] Assign RHO data error";
LOG_STRING char APP_RHO_RM_AssignDataMemErrorLogString[] = "[APP] Assign RHO memory error";
LOG_STRING char APP_RHO_RM_FillDataOkLogString[] = "[APP] Fill RHO data OK. bdAddr:0x%x%x";
LOG_STRING char APP_RHO_RM_FillDataErrorLogString[] = "[APP] Fill RHO data error";
LOG_STRING char APP_RHO_RM_FillDataMemErrorLogString[] = "[APP] Fill RHO memory error";
LOG_STRING char APP_RHO_RM_AssignErrorLogString[] = "[APP] Assign RHO error: %s";
LOG_STRING char APP_RHO_RM_FillErrorLogString[] = "[APP] Fill RHO error: %s";
LOG_STRING char APP_RHO_RM_ScoSinkErrorLogString[] = "[APP_LINKINFO] New Agent Sco Sink Error";
LOG_STRING char APP_RHO_RM_ScoSinkLogString[] = "[APP_LINKINFO] New Agent Sco Sink:0x%x, BdAddr:0x%x%x";
LOG_STRING char APP_RHO_RM_LinkInfoNoLinkLogString[] = "[APP_LINKINFO] Assign RHO data no Link";
LOG_STRING char APP_RHO_RM_LinkInfoNoDataLogString[] = "[APP_LINKINFO] Assign RHO data error";
LOG_STRING char APP_RHO_RM_LinkInfoStateErrorLogString[] = "[APP_LINKINFO] AG Link State number error";
LOG_STRING char APP_RHO_RM_LinkInfoFillNoLinkLogString[] = "[APP_LINKINFO] Fill RHO data no AG Link";
LOG_STRING char APP_RHO_RM_LinkInfoFillNoDataLogString[] = "[APP_LINKINFO] Fill RHO data error";
LOG_STRING char APP_RHO_RM_CtlAssignNoDataLogString[] = "[APP_CTL] Assign RHO data error";
LOG_STRING char APP_RHO_RM_CtlFillNoDataLogString[] = "[APP_CTL] Fill RHO data error";

/* AVCTP RHO */
LOG_STRING char MCSync_AVCTP_APPLY_PARTNER_String[] = "[RHO_AVCTP] Apply Partner linkinfo:%d";
LOG_STRING char MCSync_AVCTP_APPLY_AGENT_String1[] = "[RHO_AVCTP] Apply Agent linkinfo:%d, length:%d";
LOG_STRING char MCSync_AVCTP_APPLY_AGENT_String2[] = "[RHO_AVCTP] Apply Agent No Memory:%d";
LOG_STRING char MCSync_AVCTP_APPLY_AGENT_String3[] = "[RHO_AVCTP] Apply Agent remain len:%d, msgNum:%d, bdaddr:0x%x%x";
LOG_STRING char MCSync_AVCTP_AGENT_GETDATA_String1[] = "[RHO_AVCTP] Agent Get Data Status Buffer:%d, linkinfo:%d";
LOG_STRING char MCSync_AVCTP_AGENT_GETDATA_String2[] = "[RHO_AVCTP] Agent Get Data QNum:%d, bdaddr:0x%x%x";
LOG_STRING char MCSync_AVCTP_AGENT_GETDATA_String3[] = "[RHO_AVCTP] Agent Get Data length:%d";
LOG_STRING char MCSync_AVCTP_AGENT_GETDATA_String4[] = "[RHO_AVCTP] Agent Get Data Msg Number:%d";
LOG_STRING char MCSync_AVCTP_AGENT_RECORDMSG_String1[] = "[RHO_AVCTP] Agent Record Msg Length:%d, RecordData:%d";
LOG_STRING char MCSync_AVCTP_AGENT_RECORDMSG_String2[] = "[RHO_AVCTP] Agent Record Msg No Memory:%d";
LOG_STRING char MCSync_AVCTP_AGENT_RECORDMSG_String3[] = "[RHO_AVCTP] Agent Record Msg Push Fail:%d";
LOG_STRING char MCSync_AVCTP_AGENT_RECORDMSG_String4[] = "[RHO_AVCTP] Agent Record Msg QMsg Length:%d";

/* AVDTP RHO */
LOG_STRING char MCSync_AVDTP_APPLY_PARTNER_String[] = "[RHO_AVDTP] Apply Partner linkinfo:%d";
LOG_STRING char MCSync_AVDTP_APPLY_AGENT_String1[] = "[RHO_AVDTP] Apply Agent linkinfo:%d, length:%d";
LOG_STRING char MCSync_AVDTP_APPLY_AGENT_String2[] = "[RHO_AVDTP] Apply Agent No Memory:%d";
LOG_STRING char MCSync_AVDTP_APPLY_AGENT_String3[] = "[RHO_AVDTP] Apply Agent remain len:%d, msgNum:%d, bdaddr:0x%x%x";
LOG_STRING char MCSync_AVDTP_AGENT_GETDATA_String1[] = "[RHO_AVDTP] Agent Get Data Status Buffer:%d, linkinfo:%d";
LOG_STRING char MCSync_AVDTP_AGENT_GETDATA_String2[] = "[RHO_AVDTP] Agent Get Data QNum:%d, bdaddr:0x%x%x";
LOG_STRING char MCSync_AVDTP_AGENT_GETDATA_String3[] = "[RHO_AVDTP] Agent Get Data length:%d";
LOG_STRING char MCSync_AVDTP_AGENT_GETDATA_String4[] = "[RHO_AVDTP] Agent Get Data Msg Number:%d";
LOG_STRING char MCSync_AVDTP_AGENT_RECORDMSG_String1[] = "[RHO_AVDTP] Agent Record Msg Length:%d, RecordData:%d";
LOG_STRING char MCSync_AVDTP_AGENT_RECORDMSG_String2[] = "[RHO_AVDTP] Agent Record Msg No Memory:%d";
LOG_STRING char MCSync_AVDTP_AGENT_RECORDMSG_String3[] = "[RHO_AVDTP] Agent Record Msg Push Fail:%d";
LOG_STRING char MCSync_AVDTP_AGENT_RECORDMSG_String4[] = "[RHO_AVDTP] Agent Record Msg QMsg Length:%d";

/* A2DP RHO */
LOG_STRING char MCSync_A2DP_NEWAGENT_ASSIGN_String1[] = "[RHO_A2DP] New Agent assign rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_A2DP_NEWAGENT_ASSIGN_String2[] = "[RHO_A2DP] New Agent assign data ok:0x%x%x, loaded:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_FILL_String1[] = "[RHO_A2DP] Old Agent fill: rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_FILL_String2[] = "[RHO_A2DP] Old Agent fill data ok:0x%x%x";
LOG_STRING char MCSync_A2DP_NEWPARTNER_APPLY_String[] = "[RHO_A2DP] New Partner apply linkinfo:%d, unloaded:%d";
LOG_STRING char MCSync_A2DP_NEWAGENT_APPLY_String[] = "[RHO_A2DP] New Agent apply length:%d, a2dpData:0x%x";
LOG_STRING char MCSync_A2DP_NEWAGENT_APPLY_ERROR_String1[] = "[RHO_A2DP] New Agent assign data error";
LOG_STRING char MCSync_A2DP_NEWAGENT_APPLY_ERROR_String2[] = "[RHO_A2DP] New Agent send msg no memory:%d";
LOG_STRING char MCSync_A2DP_NEWAGENT_APPLY_ERROR_String3[] = "[RHO_A2DP] New Agent msg length error:%d";
LOG_STRING char MCSync_A2DP_NEWAGENT_APPLY_SUCCESS_String[] = "[RHO_A2DP] New Agent apply OK:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_GETDATA_ERROR_String1[] = "[RHO_A2DP] Old Agent Get Data error: No buffer";
LOG_STRING char MCSync_A2DP_OLDAGENT_GETDATA_ERROR_String2[] = "[RHO_A2DP] Old Agent Get Data error: Fill data fail";
LOG_STRING char MCSync_A2DP_OLDAGENT_GETDATA_ERROR_String3[] = "[RHO_A2DP] Old Agent Get Data error: remaining Qlength:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_GETDATA_POPQ_String[] = "[RHO_A2DP] Old Agent Get Data popQ:%d, %d";
LOG_STRING char MCSync_A2DP_OLDAGENT_GETDATA_LENGTH_String[] = "[RHO_A2DP] Old Agent Get Data length:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_IS_ALLOW_String[] = "[RHO_A2DP] Old Agent IsAllow Msg Num:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_RECORDMSG_String1[] = "[RHO_A2DP] Old Agent Record Msg length:%d, recordData:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_RECORDMSG_String2[] = "[RHO_A2DP] Old Agent Record Msg total Qlength:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_RECORDMSG_ERROR_String1[] = "[RHO_A2DP] Old Agent Record Msg error: no memory:%d";
LOG_STRING char MCSync_A2DP_OLDAGENT_RECORDMSG_ERROR_String2[] = "[RHO_A2DP] Old Agent Record Msg error: push fail:%d";

/* AVRCP RHO */
LOG_STRING char MCSync_AVRCP_NEWAGENT_ASSIGN_String1[] = "[RHO_AVRCP] New Agent assign rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_AVRCP_NEWAGENT_ASSIGN_String2[] = "[RHO_AVRCP] New Agent assign ok:0x%x%x, loaded:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_FILL_String1[] = "[RHO_AVRCP] Old Agent fill rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_FILL_String2[] = "[RHO_AVRCP] Old Agent fill ok:0x%x%x";
LOG_STRING char MCSync_AVRCP_NEWPARTNER_APPLY_String[] = "[RHO_AVRCP] New Partner apply linkinfo:%d, unloaded:%d";
LOG_STRING char MCSync_AVRCP_NEWAGENT_APPLY_String[] = "[RHO_AVRCP] New Agent apply length:%d, avrcpData:0x%x";
LOG_STRING char MCSync_AVRCP_NEWAGENT_APPLY_ERROR_String1[] = "[RHO_AVRCP] New Agent assign data error";
LOG_STRING char MCSync_AVRCP_NEWAGENT_APPLY_ERROR_String2[] = "[RHO_AVRCP] New Agent send msg no memory:%d";
LOG_STRING char MCSync_AVRCP_NEWAGENT_APPLY_ERROR_String3[] = "[RHO_AVRCP] New Agent msg length error:%d";
LOG_STRING char MCSync_AVRCP_NEWAGENT_APPLY_SUCCESS_String[] = "[RHO_AVRCP] New Agent apply OK:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_GETDATA_ERROR_String1[] = "[RHO_AVRCP] Old Agent Get Data error: No buffer";
LOG_STRING char MCSync_AVRCP_OLDAGENT_GETDATA_ERROR_String2[] = "[RHO_AVRCP] Old Agent Get Data error: Fill data fail";
LOG_STRING char MCSync_AVRCP_OLDAGENT_GETDATA_ERROR_String3[] = "[RHO_AVRCP] Old Agent Get Data error: remaining Qlength:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_GETDATA_POPQ_String[] = "[RHO_AVRCP] Old Agent Get Data popQ:%d, %d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_GETDATA_LENGTH_String[] = "[RHO_AVRCP] Old Agent Get Data length:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_IS_ALLOW_String[] = "[RHO_AVRCP] Old Agent IsAllow Msg Num:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_RECORDMSG_String1[] = "[RHO_AVRCP] Old Agent Record Msg length:%d, recordData:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_RECORDMSG_String2[] = "[RHO_AVRCP] Old Agent Record Msg total Qlength:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_RECORDMSG_ERROR_String1[] = "[RHO_AVRCP] Old Agent Record Msg error: no memory:%d";
LOG_STRING char MCSync_AVRCP_OLDAGENT_RECORDMSG_ERROR_String2[] = "[RHO_AVRCP] Old Agent Record Msg error: push fail:%d";

/* MCSync RHO  */
LOG_STRING char MCSync_MCSync_NEWAGENT_ASSIGN_String1[] = "[RHO_MCSync] New Agent assign rhodata:%d";
LOG_STRING char MCSync_MCSync_NEWAGENT_ASSIGN_String2[] = "[RHO_MCSync] New Agent unload:0x%x%x";
LOG_STRING char MCSync_MCSync_NEWAGENT_ASSIGN_String3[] = "[RHO_MCSync] New Agent assign ok:0x%x%x, loaded:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_FILL_String1[] = "[RHO_MCSync] Old Agent fill rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_FILL_String2[] = "[RHO_MCSync] Old Agent fill ok:0x%x%x";
LOG_STRING char MCSync_MCSync_NEWPARTNER_APPLY_String1[] = "[RHO_MCSync] New Partner apply linkinfo:%d";
LOG_STRING char MCSync_MCSync_NEWPARTNER_APPLY_String2[] = "[RHO_MCSync] New Partner unload:0x%x%x";
LOG_STRING char MCSync_MCSync_NEWPARTNER_APPLY_String3[] = "[RHO_MCSync] New Partner load:0x%x%x";
LOG_STRING char MCSync_MCSync_NEWAGENT_APPLY_String[] = "[RHO_MCSync] New Agent apply length:%d, MCSyncData:0x%x";
LOG_STRING char MCSync_MCSync_NEWAGENT_APPLY_ERROR_String1[] = "[RHO_MCSync] New Agent assign data error";
LOG_STRING char MCSync_MCSync_NEWAGENT_APPLY_ERROR_String2[] = "[RHO_MCSync] New Agent send msg no memory:%d";
LOG_STRING char MCSync_MCSync_NEWAGENT_APPLY_ERROR_String3[] = "[RHO_MCSync] New Agent msg length error:%d";
LOG_STRING char MCSync_MCSync_NEWAGENT_APPLY_SUCCESS_String[] = "[RHO_MCSync] New Agent apply OK:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_GETDATA_ERROR_String1[] = "[RHO_MCSync] Old Agent Get Data error: No buffer";
LOG_STRING char MCSync_MCSync_OLDAGENT_GETDATA_ERROR_String2[] = "[RHO_MCSync] Old Agent Get Data error: Fill data fail";
LOG_STRING char MCSync_MCSync_OLDAGENT_GETDATA_ERROR_String3[] = "[RHO_MCSync] Old Agent Get Data error: remaining Qlength:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_GETDATA_POPQ_String[] = "[RHO_MCSync] Old Agent Get Data popQ:%d, %d";
LOG_STRING char MCSync_MCSync_OLDAGENT_GETDATA_LENGTH_String[] = "[RHO_MCSync] Old Agent Get Data length:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_IS_ALLOW_String[] = "[RHO_MCSync] Old Agent IsAllow Msg Num:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_RECORDMSG_String1[] = "[RHO_MCSync] Old Agent Record Msg length:%d, recordData:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_RECORDMSG_String2[] = "[RHO_MCSync] Old Agent Record Msg total Qlength:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_RECORDMSG_ERROR_String1[] = "[RHO_MCSync] Old Agent Record Msg error: no memory:%d";
LOG_STRING char MCSync_MCSync_OLDAGENT_RECORDMSG_ERROR_String2[] = "[RHO_MCSync] Old Agent Record Msg error: push fail:%d";

/* HFP RHO  */
LOG_STRING char MCSync_HFP_NEWAGENT_ASSIGN_String1[] = "[RHO_HFP] New Agent assign rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_HFP_NEWAGENT_ASSIGN_String2[] = "[RHO_HFP] New Agent assign ok:0x%x%x, loaded:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_FILL_String1[] = "[RHO_HFP] Old Agent fill rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_FILL_String2[] = "[RHO_HFP] Old Agent fill ok:0x%x%x";
LOG_STRING char MCSync_HFP_NEWPARTNER_APPLY_String[] = "[RHO_HFP] New Partner apply linkinfo:%d, unloaded:%d";
LOG_STRING char MCSync_HFP_NEWAGENT_APPLY_String[] = "[RHO_HFP] New Agent apply length:%d, hfpData:0x%x";
LOG_STRING char MCSync_HFP_NEWAGENT_APPLY_ERROR_String1[] = "[RHO_HFP] New Agent assign data error";
LOG_STRING char MCSync_HFP_NEWAGENT_APPLY_ERROR_String2[] = "[RHO_HFP] New Agent send msg no memory:%d";
LOG_STRING char MCSync_HFP_NEWAGENT_APPLY_ERROR_String3[] = "[RHO_HFP] New Agent msg length error:%d";
LOG_STRING char MCSync_HFP_NEWAGENT_APPLY_SUCCESS_String[] = "[RHO_HFP] New Agent apply OK:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_GETDATA_ERROR_String1[] = "[RHO_HFP] Old Agent Get Data error: No buffer";
LOG_STRING char MCSync_HFP_OLDAGENT_GETDATA_ERROR_String2[] = "[RHO_HFP] Old Agent Get Data error: Fill data fail";
LOG_STRING char MCSync_HFP_OLDAGENT_GETDATA_ERROR_String3[] = "[RHO_HFP] Old Agent Get Data error: remaining Qlength:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_GETDATA_POPQ_String[] = "[RHO_HFP] Old Agent Get Data popQ:%d, %d";
LOG_STRING char MCSync_HFP_OLDAGENT_GETDATA_LENGTH_String[] = "[RHO_HFP] Old Agent Get Data length:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_IS_ALLOW_String[] = "[RHO_HFP] Old Agent IsAllow Msg AtCmd:%d, Rfcomm:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_RECORDMSG_String1[] = "[RHO_HFP] Old Agent Record Msg length:%d, recordData:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_RECORDMSG_String2[] = "[RHO_HFP] Old Agent Record Msg total Qlength:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_RECORDMSG_ERROR_String1[] = "[RHO_HFP] Old Agent Record Msg error: no memory:%d";
LOG_STRING char MCSync_HFP_OLDAGENT_RECORDMSG_ERROR_String2[] = "[RHO_HFP] Old Agent Record Msg error: push fail:%d";

/* PM RHO */
LOG_STRING char MCSync_PM_NEWAGENT_ASSIGN_ERROR_String1[] = "[RHO_PM] New Agent assign error: no rhodata";
LOG_STRING char MCSync_PM_NEWAGENT_ASSIGN_ERROR_String2[] = "[RHO_PM] New Agent assign error: no link resource";
LOG_STRING char MCSync_PM_NEWAGENT_ASSIGN_SUCCESS_String[] = "[RHO_PM] New Agent assign ok:0x%x%x";
LOG_STRING char MCSync_PM_OLDAGENT_FILL_String1[] = "[RHO_PM] Old Agent fill rhodata:%d, linkinfo:%d";
LOG_STRING char MCSync_PM_OLDAGENT_FILL_String2[] = "[RHO_PM] Old Agent fill ok:0x%x%x";
LOG_STRING char MCSync_PM_NEWPARTNER_APPLY_String[] = "[RHO_PM] New Partner apply AGlinkinfo:%d, linkinfo:%d";
LOG_STRING char MCSync_PM_NEWAGENT_APPLY_String[] = "[RHO_PM] New Agent apply length:%d, pmData:0x%x";
LOG_STRING char MCSync_PM_NEWAGENT_APPLY_ERROR_String1[] = "[RHO_PM] New Agent assign data error";
LOG_STRING char MCSync_PM_NEWAGENT_APPLY_ERROR_String2[] = "[RHO_PM] New Agent send msg no memory:%d";
LOG_STRING char MCSync_PM_NEWAGENT_APPLY_ERROR_String3[] = "[RHO_PM] New Agent msg length error:%d";
LOG_STRING char MCSync_PM_NEWAGENT_APPLY_SUCCESS_String[] = "[RHO_PM] New Agent apply OK:%d";
LOG_STRING char MCSync_PM_OLDAGENT_GETDATA_ERROR_String1[] = "[RHO_PM] Old Agent Get Data error: No buffer";
LOG_STRING char MCSync_PM_OLDAGENT_GETDATA_ERROR_String2[] = "[RHO_PM] Old Agent Get Data error: Fill data fail";
LOG_STRING char MCSync_PM_OLDAGENT_GETDATA_ERROR_String3[] = "[RHO_PM] Old Agent Get Data error: remaining Qlength:%d";
LOG_STRING char MCSync_PM_OLDAGENT_GETDATA_POPQ_String[] = "[RHO_PM] Old Agent Get Data popQ:%d, %d";
LOG_STRING char MCSync_PM_OLDAGENT_GETDATA_LENGTH_String[] = "[RHO_PM] Old Agent Get Data length:%d";
LOG_STRING char MCSync_PM_OLDAGENT_IS_ALLOW_String[] = "[RHO_PM] Old Agent IsAllow Msg num:%d";
LOG_STRING char MCSync_PM_OLDAGENT_RECORDMSG_String1[] = "[RHO_PM] Old Agent Record Msg length:%d, recordData:%d";
LOG_STRING char MCSync_PM_OLDAGENT_RECORDMSG_String2[] = "[RHO_PM] Old Agent Record Msg total Qlength:%d";
LOG_STRING char MCSync_PM_OLDAGENT_RECORDMSG_ERROR_String1[] = "[RHO_PM] Old Agent Record Msg error: no memory:%d";
LOG_STRING char MCSync_PM_OLDAGENT_RECORDMSG_ERROR_String2[] = "[RHO_PM] Old Agent Record Msg error: push fail:%d";

/* APP RHO Handler */
LOG_STRING char MCSync_APP_NEWPARTNER_APPLY_String[] = "[RHO_APP] New Partner applied";
LOG_STRING char MCSync_APP_NEWAGENT_APPLY_String[] = "[RHO_APP] New Agent apply length:%d, appData:0x%x";
LOG_STRING char MCSync_APP_NEWAGENT_APPLY_ERROR_String1[] = "[RHO_APP] New Agent assign data error";
LOG_STRING char MCSync_APP_NEWAGENT_APPLY_ERROR_String2[] = "[RHO_APP] New Agent send msg no memory:%d";
LOG_STRING char MCSync_APP_NEWAGENT_APPLY_ERROR_String3[] = "[RHO_APP] New Agent msg length error:%d";
LOG_STRING char MCSync_APP_NEWAGENT_APPLY_SUCCESS_String[] = "[RHO_APP] New Agent apply OK:%d";
LOG_STRING char MCSync_APP_OLDAGENT_GETDATA_ERROR_String1[] = "[RHO_APP] Old Agent Get Data error: No buffer";
LOG_STRING char MCSync_APP_OLDAGENT_GETDATA_ERROR_String2[] = "[RHO_APP] Old Agent Get Data error: Fill data fail";
LOG_STRING char MCSync_APP_OLDAGENT_GETDATA_ERROR_String3[] = "[RHO_APP] Old Agent Get Data error: remaining Qlength:%d";
LOG_STRING char MCSync_APP_OLDAGENT_GETDATA_POPQ_String[] = "[RHO_APP] Old Agent Get Data popQ:%d, %d";
LOG_STRING char MCSync_APP_OLDAGENT_GETDATA_LENGTH_String[] = "[RHO_APP] Old Agent Get Data length:%d";
LOG_STRING char MCSync_APP_OLDAGENT_RECORDMSG_String1[] = "[RHO_APP] Old Agent Record Msg length:%d, recordData:%d";
LOG_STRING char MCSync_APP_OLDAGENT_RECORDMSG_String2[] = "[RHO_APP] Old Agent Record Msg total Qlength:%d";
LOG_STRING char MCSync_APP_OLDAGENT_RECORDMSG_ERROR_String1[] = "[RHO_APP] Old Agent Record Msg error: no memory:%d";
LOG_STRING char MCSync_APP_OLDAGENT_RECORDMSG_ERROR_String2[] = "[RHO_APP] Old Agent Record Msg error: push fail:%d";
LOG_STRING char MCSync_APPCONN_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_CONN] Old Agent fill data error";
LOG_STRING char MCSync_APPCONN_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_CONN] New Agent Assign data error";
LOG_STRING char MCSync_APPAT_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_AT] Old Agent fill data error";
LOG_STRING char MCSync_APPAT_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_AT] New Agent Assign data error";
LOG_STRING char MCSync_APPSCO_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_SCO] Old Agent fill data error";
LOG_STRING char MCSync_APPSCO_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_SCO] New Agent Assign data error";
LOG_STRING char MCSync_APPST_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_SideTone] Old Agent fill data error";
LOG_STRING char MCSync_APPST_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_SideTone] New Agent Assign data error";
LOG_STRING char MCSync_APPSM_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_Stream] Old Agent fill data error";
LOG_STRING char MCSync_APPSM_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_Stream] New Agent Assign data error";
LOG_STRING char MCSync_APPVP_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_VP] Old Agent fill data error";
LOG_STRING char MCSync_APPVP_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_VP] New Agent Assign data error";
LOG_STRING char MCSync_APPHFPIMG_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_HfpImg] Old Agent fill data error";
LOG_STRING char MCSync_APPHFPIMG_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_HfpImg] New Agent Assign data error";
LOG_STRING char MCSync_APPPWROFF_OLDAGENT_FILL_ERROR_String[] = "[RHO_APP_PwrOff] Old Agent fill data error";
LOG_STRING char MCSync_APPPWROFF_NEWAGENT_ASSIGN_ERROR_String[] = "[RHO_APP_PwrOff] New Agent Assign data error";
LOG_STRING char MCSync_APPRCECMD_ALLOW_KEYCODE_ERROR_String[] = "[RHO_APP_RaceCmd] Old Agent KeyCode Not Allow:%d";
LOG_STRING char MCSync_APPRCECMD_ALLOW_CONN_ERROR_String[] = "[RHO_APP_RaceCmd] Old Agent Connection Not Allow:%d";
LOG_STRING char MCSync_APPRCECMD_ALLOW_ANC_ERROR_String[] = "[RHO_APP_RaceCmd] Old Agent ANC Not Allow:%d";

/* APP Mcsync Reconnect*/
LOG_STRING char APP_McsReconn_ReconnTimeout_String[] = "[APP MCS Reconn] Reconnect Timeout. state:%s";
LOG_STRING char APP_McsReconn_StateHandler_String[] = "[APP MCS Reconn] State Handler. event:%s, state:%s";
LOG_STRING char APP_McsReconn_ActionHandler_String[] = "[APP MCS Reconn] Action Handler. action:%s";
LOG_STRING char APP_McsReconn_SuperReconn_String1[] = "[APP MCS Reconn] Super Reconnect Mode. defaultRole:0x%x, type:%d, state:%s, AG:%d";
LOG_STRING char APP_McsReconn_SuperReconn_String2[] = "[APP MCS Reconn] Super Reconnect Mode. MCS:%d, Feature:%d, SingleHS:%d";
LOG_STRING char APP_McsReconn_SpecialNotReady_String[] = "[APP MCS Reconn] Special not ready, reconnect later";
LOG_STRING char APP_McsReconn_ReconnectNotify_String[] = "[APP MCS Reconn] Reconnect Notify. state:%s, defaultRole:0x%x, connectDev:%d";
LOG_STRING char APP_McsReconn_SetRoleNotify_String[] = "[APP MCS Reconn] Set Role Notify. state:%s, defaultRole:0x%x, status:%d";
LOG_STRING char APP_McsReconn_EnterSuperReconnMode_String[] = "[APP MCS Reconn] Enter Super Reconnect Mode:%d";
LOG_STRING char APP_McsReconn_ExitSuperReconnMode_String[] = "[APP MCS Reconn] Exit Super Reconnect Mode. state:%s, isNeedToBackRole:%d";
LOG_STRING char APP_McsReconn_SetReconnectTime_String[] = "[APP MCS Reconn] Set Reconnect Time. Agent:%d ms, Partner:%d ms";
LOG_STRING char APP_McsReconn_ReconnectFailedNotify_String[] = "[APP MCS Reconn] Reconnect Failed Notify. state:%s, reason:%d";
LOG_STRING char APP_McsReconn_NvkeyInitFailed_String[] = "[APP MCS Reconn] Init No Nvkey";
LOG_STRING char APP_McsReconn_SuperReconnEnd_String[] = "[APP MCS Reconn] Super Reconnect End";
LOG_STRING char APP_McsReconn_SetLinkLossBdAddr_String[] = "[APP MCS Reconn] Set Link Loss BdAddr:0x%x%x";
LOG_STRING char APP_McsReconn_SetNotReconnMask_String[] = "[APP MCS Reconn] Set Not Reconnect Mask:0x%x, original:0x%x";
LOG_STRING char APP_McsReconn_ClearNotReconnMask_String[] = "[APP MCS Reconn] Clear Not Reconnect Mask:0x%x, original:0x%x";
LOG_STRING char APP_McsReconn_ClearAllNotReconnMask_String[] = "[APP MCS Reconn] Clear All Not Reconnect Mask";
LOG_STRING char APP_McsReconn_SyncNotReconnMask_String[] = "[APP MCS Reconn] Sync Not Reconnect Mask:0x%x";
LOG_STRING char APP_McsReconn_IsNeedReconnectAg_String[] = "[APP MCS Reconn] Is Need Reconnect AG. Not Reconnect Mask:0x%x";

LOG_STRING char APP_McsReconn_IsReconnAgLinkInfo_String[] = "[APP MCS Reconn] isReconn:%d, AgLinkState:%d, isNeedAg:%d";
LOG_STRING char APP_McsReconn_AgentIdleIsReconn_String[] = "[APP MCS Reconn] AGENT_IDLE isReconn:%d, AgLinkState:%d, isNeedAg:%d";


LOG_STRING char APP_McsReconn_State_String[][MAX_LOG_STRING] =
{
	"MCS_RECONN_STATE_IDLE",
	"MCS_RECONN_STATE_WAIT_TO_PARTNER",
	"MCS_RECONN_STATE_WAIT_TO_AGENT",
	"MCS_RECONN_STATE_PARTNER_RECONNECTING",
	"MCS_RECONN_STATE_AGENT_RECONNECTING",
	"MCS_RECONN_STATE_AGENT_IDLE",
	"MCS_RECONN_STATE_AGENT_WAIT_RECONNECT_FAILED",
	"MCS_RECONN_STATE_CANCELING",
};

LOG_STRING char APP_McsReconn_Action_String[][MAX_LOG_STRING] =
{
	"MCS_RECONN_ACTION_SET_TO_PARTNER",
	"MCS_RECONN_ACTION_SET_TO_AGENT",
	"MCS_RECONN_ACTION_RECONNECT",
};

LOG_STRING char APP_McsReconn_Event_String[][MAX_LOG_STRING] =
{
	"MCS_RECONN_EVENT_SET_PARTNER_SUCCESSFUL",
	"MCS_RECONN_EVENT_SET_PARTNER_FAILED",
	"MCS_RECONN_EVENT_SET_AGENT_SUCCESSFUL",
	"MCS_RECONN_EVENT_SET_AGENT_FAILED",
	"MCS_RECONN_EVENT_RECONNECT_TIMEOUT",
	"MCS_RECONN_EVENT_RECONNECT_FAILED",
	"MCS_RECONN_EVENT_RECONNECT_FAILED_ALREADY_EXIST",
	"MCS_RECONN_EVENT_RECONNECT_FAILED_CONN_ACCEPT_TIMEOUT",
	"MCS_RECONN_EVENT_AGENT_WITH_PARTNER",
	"MCS_RECONN_EVENT_AGENT_WITH_AG",
	"MCS_RECONN_EVENT_CANCEL_MODE",
};

LOG_STRING char APP_McsReconn_TimerId_String[][MAX_LOG_STRING] =
{
	"ID_RECONNECT_TIMEOUT",
	"ID_RECONNECT_NOTIFY",
	"ID_ACTION_HANDLER",
	"ID_STATE_HANDLER",
	"ID_ENTER_SUPER_RECONNECT",
};

/*Lib Charger*/
LOG_STRING char APP_ChargerCase_DrvEvt_String[]= "[LIB DRV EVT][Smart Case][Charger] ====== Evt: [%s(%d)] ====== ext_id(0x%x)";

/*Smart Charger Case*/
LOG_STRING char APP_SmartCase_DrvEvt_String[][MAX_LOG_STRING] =
{
	"",
	"[BT ON] Pattern",
	"[BT OFF] Pattern",
	"[Chg-CPL] Pattern",
	"[Chg-OUT] Pattern",
	"[RESERVE-0] Pattern",
	"[RESERVE-1] Pattern",
	"[RESERVE-2] Pattern",
	"[RESERVE-3] Pattern",
	"[RESERVE-4] Pattern",
	"[Chg-In] Interrupt",
	"[Chg-CPL] Interrupt",
	"[Re-Chg] Interrupt",
	"[Charger Key(V2)] Pattern",
	"[USER 1(V2)] Pattern",
	"[USER 2(V2)] Pattern",
	"[USER 3(V2)] Pattern",
};


LOG_STRING char LibDrv_SmartCase_OldState[] = "[Smart Case] Old State: <%s(%d)>";
LOG_STRING char LibDrv_SmartCase_SetState[] = "[Smart Case] Set State: <%s(%d)>";
LOG_STRING char LibDrv_Charger_OldState[] = "[Charger] Old State: <%s(%d)>";
LOG_STRING char LibDrv_Charger_SetState[] = "[Charger] Set State: <%s(%d)>";

LOG_STRING char LibDrv_SmartCase_StateString[][MAX_LOG_STRING] =
{
	"STATE_CASE_OFF",
	"STATE_OUT_OF_CASE",
	"STATE_LID_CLOSE",
	"STATE_LID_OPEN",
};

LOG_STRING char LibDrv_Charger_StateString[][MAX_LOG_STRING] =
{
	"STATE_CHARGER_OUT",
	"STATE_CHARGING",
	"STATE_CHARGER_CPL",
};

/* App Smart Case*/
LOG_STRING char APP_SmartCase_StateHandler_String[] = "[APP_SmtChgCse] app_SmtChgCse_StateHandler, State:%s(%d)";
LOG_STRING char APP_SmartCase_TimerHandler_String[] = "[APP_SmtChgCse] app_SmtChgCse_TimerHandler, id:%d";
LOG_STRING char APP_SmartCase_LinOnHandler_String[] = "[APP_SmtChgCse] LidOn, McsState:%s(%d), ConnState:%s(%d), role:0x%x";
LOG_STRING char APP_SmartCase_LidOffHandler_String[] = "[APP_SmtChgCse] LidOff, McsState:%s(%d), role:0x%x";
LOG_STRING char APP_SmartCase_OutOfCaseHandler_String[] = "[APP_SmtChgCse] OutOfCase, McsState:%s(%d), ConnState:%s(%d), role0x%x";
LOG_STRING char APP_SmartCase_MCSyncConnTimerHandler_String[] = "[APP_SmtChgCse] MCSyncConnTimer, SccState:%s(%d), role0x%x";
LOG_STRING char APP_SmartCase_RhoTimerHandler_String[] = "[APP_SmtChgCse] RhoTimer, Pstate:%d, Astate:%d, connState:%d, role:0x%x, mcsState:%d";
LOG_STRING char APP_SmartCase_AgentRhoTimerHandler_String[] = "[APP_SmtChgCse] AgentRhoTimer, isTimerSet:%d, sccState:%d";
LOG_STRING char APP_SmartCase_CheckNeedToConnectToAG_String[] = "[APP_SmtChgCse] sccPState:%d, sccAState:%d, mcsyncState:%d, connState:%d";
LOG_STRING char APP_SmartCase_CheckIsOutOfCase_String[] = "[APP_SmtChgCse] Is Out Of Case, sccState:%d";
LOG_STRING char APP_McSyncLinkString[][MAX_LOG_STRING] =
{
	"MCSYNC_LINK_SAWS_DISCONNECTED",
	"MCSYNC_LINK_SAWS_CONNECTING",
	"MCSYNC_LINK_SAWS_DISCONNECTING",
	"MCSYNC_LINK_SAWS_READY / MCSYNC_LINK_DISCONNECTED",
	"MCSYNC_LINK_CONNECTING",
	"MCSYNC_LINK_CONNECTED",
	"MCSYNC_LINK_DISCONNECTING",
};

LOG_STRING char APP_LinkConnString[][MAX_LOG_STRING]=
{
	"LINK_DISCONNECTED",
	"LINK_CONNECTING",
	"LINK_CONNECTED",
	"LINK_DISCONNECTING",
};


LOG_STRING char APP_SmartCase_LidOnHandler_Checktimer_String[] = "[APP_SmtChgCse]app_SmtChgCse_LidOnHandler checktimer:%d";
LOG_STRING char APP_SmartCase_IsOutOfCaseSCCState_String[] = "[APP_SmtChgCse] IsOutOfCase sccState:%d";
LOG_STRING char APP_SmartCase_IsPhoneNeed_String[] = "[APP_SmtChgCse] APP_SmtChgCse_IsPhoneNeeded";
LOG_STRING char APP_SmartCase_IsAbleToRHO_String[] = "[APP_SmtChgCse] IsAbleToRHO, sccPState:%d, mcsyncState:%d";
LOG_STRING char APP_SmartCase_StateInfo_String[] = "[APP_SmtChgCse] sccPState:%d, sccAState:%d, mcsyncState:%d, connState:%d";

LOG_STRING char APP_SmartCase_app_SmtChgCse_RsvHandlerid_String[] = "[APP SMART V2] app_SmtChgCse_RsvHandler-id:(%d), para:(%d)";
LOG_STRING char APP_SmartCase_keyCodeSupportState_String[] = "[APP SMART V2] keyCode(%x) SupportedState(%x) stateBitMask(%x)";

/* App AMA*/
LOG_STRING char APP_AMA_StartServiceCfm_String[] = "[APP_Ama] AMA_START_SERVICE_CFM status:%d";
LOG_STRING char APP_AMA_StopServiceCfm_String[] = "[APP_Ama] AMA_STOP_SERVICE_CFM status:%d";
LOG_STRING char APP_AMA_EnableAdvCfm_String[] = "[APP_Ama] AMA_ENABLE_ADV_CFM status:%d";
LOG_STRING char APP_AMA_DisableAdvCfm_String[] = "[APP_Ama] AMA_DISABLE_ADV_CFM status:%d";
LOG_STRING char APP_AMA_ConnectCfm_String[] = "[APP_Ama] AMA_CONNECT_CFM status:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_DisconnectInd_String[] = "[APP_Ama] AMA_DISCONNECT_IND status:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_DisconnectCfm_String[] = "[APP_Ama] AMA_DISCONNECT_CFM status:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_StartSpeechCfm_String[] = "[APP_Ama] AMA_START_SPEECH_CFM errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_ProvideSpeechInd_String[] = "[APP_Ama] AMA_PROVIDE_SPEECH_IND BdAddr:0x%x%x";
LOG_STRING char APP_AMA_StopSpeechInd_String[] = "[APP_Ama] AMA_STOP_SPEECH_IND errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_StopSpeechCfm_String[] = "[APP_Ama] AMA_STOP_SPEECH_CFM errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_EndPointSpeechInd_String[] = "[APP_Ama] AMA_ENDPOINT_SPEECH_IND BdAddr:0x%x%x";
LOG_STRING char APP_AMA_EndPointSpeechCfm_String[] = "[APP_Ama] AMA_ENDPOINT_SPEECH_CFM errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_SpeechStateInd_String[] = "[APP_Ama] AMA_SPEECH_STATE_IND state:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_GetStateCfm_String[] = "[APP_Ama] AMA_GET_STATE_CFM BdAddr:0x%x%x, feature:0x%x, Type:%d, value:%d";
LOG_STRING char APP_AMA_GetStateInd_String[] = "[APP_Ama] AMA_GET_STATE_IND BdAddr:0x%x%x, feature:0x%x";
LOG_STRING char APP_AMA_SetStateInd_String[] = "[APP_Ama] AMA_SET_STATE_IND BdAddr:0x%x%x, feature:0x%x, Type:%d, value:%d";
LOG_STRING char APP_AMA_SyncStateCfm_String[] = "[APP_Ama] AMA_SYNCHRONIZE_STATE_CFM errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_SyncStateInd_String[] = "[APP_Ama] AMA_SYNCHRONIZE_STATE_IND BdAddr:0x%x%x, feature:0x%x, Type:%d, value:%d";
LOG_STRING char APP_AMA_MediaControlCfm_String[] = "[APP_Ama] AMA_ISSUE_MEDIA_CONTROL_CFM errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_MediaControlInd_String[] = "[APP_Ama] AMA_ISSUE_MEDIA_CONTROL_IND control:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_ForwardAtCmdInd_String[] = "[APP_Ama] AMA_FORWARD_AT_COMMAND_IND BdAddr:0x%x%x";
LOG_STRING char APP_AMA_IncomingCallCfm_String[] = "[APP_Ama] AMA_INCOMING_CALL_CFM errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_SwitchTransportInd_String[] = "[APP_Ama] AMA_SWITCH_TRANSPORT_IND oldBdAddr:0x%x%x, newBdAddr:0x%x%x";
LOG_STRING char APP_AMA_UpdateDeviceInfoInd_String[] = "[APP_Ama] AMA_UPDATE_DEVICE_INFORMATION_IND BdAddr:0x%x%x";
LOG_STRING char APP_AMA_GetCentralInfoCfm_String[] = "[APP_Ama] AMA_GET_CENTRAL_INFORMATION_CFM errorCode:%d, BdAddr:0x%x%x, platform:%d";
LOG_STRING char APP_AMA_OverrideAssistantCfm_String[] = "[APP_Ama] AMA_OVERRIDE_ASSISTANT_CFM errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_OverrideAssistantInd_String[] = "[APP_Ama] AMA_OVERRIDE_ASSISTANT_IND errorCode:%d, BdAddr:0x%x%x";
LOG_STRING char APP_AMA_FactoryResetCfm_String[] = "[APP_Ama] AMA_FACTORY_RESET_CFM status:%d";
LOG_STRING char APP_AMA_GetDataCfm_String[] = "[APP_Ama] AMA_GET_DATA_CFM status:%d";
LOG_STRING char APP_AMA_UnknownID_String[] = "[APP_Ama] Unknow Ind:%d";


/* App VAD*/
LOG_STRING char APP_VAD_TimerHandler_String[] = "[APP_VAD] TimerHandler, vadStatus:%d";
LOG_STRING char APP_VAD_EventHandler_String[] = "[APP_VAD] EventHandler, id:%d";
LOG_STRING char APP_VAD_NoiseThdReport_String[] = "[APP_VAD] Noise Status:%d";
LOG_STRING char APP_VAD_SetVadMode_String[] = "[APP_VAD] SetMode, isAllowed:%d, isContiuous:%d, vadStatus:%d";
LOG_STRING char APP_VAD_SetVadModeState_String[] = "[APP_VAD] SetModeState, curState:%d, setState:%d";
LOG_STRING char APP_VAD_TriggerModeTimer_String[] = "[APP_VAD] Trigger Mode Timer, vadStatus:%d";
LOG_STRING char APP_VAD_Enable_String[] = "[APP_VAD] Enable, isDisabled:%d";
LOG_STRING char APP_VAD_Disable_String[] = "[APP_VAD] Disable, isDisabled:%d";
LOG_STRING char APP_VAD_ChangeMode_String[] = "[APP_VAD] ChangeMode, isDisabled:%d";
LOG_STRING char APP_VAD_WakeSiri_String[] = "[APP_VAD] Feature, AGSiriOn:%d, AndroidOn:%d";


LOG_STRING char SPP_SDP_REG_CFM_STR[] = "[  SPP] SDP Reg Cfm, Status:0x%x";
LOG_STRING char SPP_SDP_UNREG_CFM_STR[] = "[  SPP] SDP Unreg Cfm, Status:0x%x";
LOG_STRING char SPP_SDP_OPEN_SEARCH_CFM_STR[] = "[  SPP] SDP Open Search Cfm, Status:0x%x";
LOG_STRING char SPP_SDP_CLOSE_SEARCH_CFM_STR[] = "[  SPP] SDP Close Search Cfm, Status:0x%x";
LOG_STRING char SPP_SDP_SERVICE_SEARCH_STR[] = "[  SPP] SDP Service Search Cfm, Status:0x%x";
LOG_STRING char SPP_SDP_ERROR_SRT1[] = "[  SPP] Unknown SDP Cfm, ID:0x%x";

LOG_STRING char APP_CustSPP_StartServiceCfm_String[] = "[APP_CustSPP] Start Service Cfm: %d";
LOG_STRING char APP_CustSPP_StopServiceCfm_String[] = "[APP_CustSPP] Stop Service Cfm: %d";
LOG_STRING char APP_CustSPP_ConnectCfm_String[] = "[APP_CustSPP] Connect Cfm: BdAddr:0x%x%x, status: %d";
LOG_STRING char APP_CustSPP_DisconnectCfm_String[] = "[APP_CustSPP] Disconnect Cfm: BdAddr:0x%x%x, status: %d";
LOG_STRING char APP_CustSPP_TxAvailableInd_String[] = "[APP_CustSPP] Tx Available Ind: BdAddr:0x%x%x";
LOG_STRING char APP_CustSPP_RxDataInd_String[] = "[APP_CustSPP] Rx Data Ind: BdAddr:0x%x%x";

/*LOG_STRING char DBG_HANG_01_String[] = "[HALT DBG:1]";
LOG_STRING char DBG_HANG_02_String[] = "[HALT DBG:2]";
LOG_STRING char DBG_HANG_03_String[] = "[HALT DBG:3]";
LOG_STRING char DBG_HANG_04_String[] = "[HALT DBG:4]";
LOG_STRING char DBG_HANG_05_String[] = "[HALT DBG:5]";
LOG_STRING char DBG_HANG_06_String[] = "[HALT DBG:6]";
LOG_STRING char DBG_HANG_07_String[] = "[HALT DBG:7 %d]";
LOG_STRING char DBG_HANG_08_String[] = "[HALT DBG:8]";
LOG_STRING char DBG_HANG_09_String[] = "[HALT DBG:9]";
LOG_STRING char DBG_HANG_10_String[] = "[HALT DBG:10 %d]";
LOG_STRING char DBG_HANG_11_String[] = "[HALT DBG:11 %d]";
LOG_STRING char DBG_HANG_12_String[] = "[HALT DBG:12 %d]";
LOG_STRING char DBG_HANG_13_String[] = "[HALT DBG:13]";
LOG_STRING char DBG_HANG_14_String[] = "[HALT DBG:14]";*/


